'From Haver 5.0 [latest update: #4638] on 18 June 2021 at 10:41:43 am'!
'Description I provide some means declare menu and button actions in one go.'!
!provides: 'ActionBuilder' 1 34!
!requires: 'Cuis-Base' 50 4635 nil!
!requires: 'Buttons' 1 1 nil!
SystemOrganization addCategory: 'ActionBuilder'!


!moduleCreation: ActionBuilder!
Modules newEnvironment: #ActionBuilder!

!interfacesOf: ActionBuilder!
Modules environment: #ActionBuilder ::
	interface: #SPI exporting: #(#RootActionGroup #AbstractActionGroup #PluggableButtonMorph #ButtonsBuilder #MenuBuilder #Action #ActionGroup #AbstractBuilder #ActionBuilder ) ::
	interface: #API exporting: #(#ActionBuilder ) ::
	interface: #UTI exporting: #(#RootActionGroup #Action #ActionGroup #ActionBuilder )!

!importsOf: ActionBuilder!
Modules environment: #ActionBuilder :: 
	import: #(#PluggableButtonMorph ) from: #API of: Modules>>#Buttons!

!classDefinition: (Modules>>#ActionBuilder>>#AbstractActionGroup) category: 'ActionBuilder'!
Object subclass: #AbstractActionGroup
	instanceVariableNames: 'model target selector menuHeading buttonHeading useSubMenus actions isHorizontal'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActionBuilder'
	inModule: #ActionBuilder!
!classDefinition: (Modules>>#ActionBuilder>>#AbstractActionGroup) class category: 'ActionBuilder'!
(Modules>>#ActionBuilder>>#AbstractActionGroup) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#ActionBuilder>>#ActionGroup) category: 'ActionBuilder'!
(Modules>>#ActionBuilder>>#AbstractActionGroup) subclass: #ActionGroup
	instanceVariableNames: 'owner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActionBuilder'
	inModule: #ActionBuilder!
!classDefinition: (Modules>>#ActionBuilder>>#ActionGroup) class category: 'ActionBuilder'!
(Modules>>#ActionBuilder>>#ActionGroup) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#ActionBuilder>>#RootActionGroup) category: 'ActionBuilder'!
(Modules>>#ActionBuilder>>#AbstractActionGroup) subclass: #RootActionGroup
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActionBuilder'
	inModule: #ActionBuilder!
!classDefinition: (Modules>>#ActionBuilder>>#RootActionGroup) class category: 'ActionBuilder'!
(Modules>>#ActionBuilder>>#RootActionGroup) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#ActionBuilder>>#AbstractBuilder) category: 'ActionBuilder'!
Object subclass: #AbstractBuilder
	instanceVariableNames: 'root current model items itemNamesMustBeUnique'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActionBuilder'
	inModule: #ActionBuilder!
!classDefinition: (Modules>>#ActionBuilder>>#AbstractBuilder) class category: 'ActionBuilder'!
(Modules>>#ActionBuilder>>#AbstractBuilder) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#ActionBuilder>>#AbstractUIBuilder) category: 'ActionBuilder'!
(Modules>>#ActionBuilder>>#AbstractBuilder) subclass: #AbstractUIBuilder
	instanceVariableNames: 'actionBuilder currentElement'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActionBuilder'
	inModule: #ActionBuilder!
!classDefinition: (Modules>>#ActionBuilder>>#AbstractUIBuilder) class category: 'ActionBuilder'!
(Modules>>#ActionBuilder>>#AbstractUIBuilder) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#ActionBuilder>>#ButtonsBuilder) category: 'ActionBuilder'!
(Modules>>#ActionBuilder>>#AbstractUIBuilder) subclass: #ButtonsBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActionBuilder'
	inModule: #ActionBuilder!
!classDefinition: (Modules>>#ActionBuilder>>#ButtonsBuilder) class category: 'ActionBuilder'!
(Modules>>#ActionBuilder>>#ButtonsBuilder) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#ActionBuilder>>#MenuBuilder) category: 'ActionBuilder'!
(Modules>>#ActionBuilder>>#AbstractUIBuilder) subclass: #MenuBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActionBuilder'
	inModule: #ActionBuilder!
!classDefinition: (Modules>>#ActionBuilder>>#MenuBuilder) class category: 'ActionBuilder'!
(Modules>>#ActionBuilder>>#MenuBuilder) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#ActionBuilder>>#ActionBuilder) category: 'ActionBuilder'!
(Modules>>#ActionBuilder>>#AbstractBuilder) subclass: #ActionBuilder
	instanceVariableNames: 'currentGroup'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActionBuilder'
	inModule: #ActionBuilder!
!classDefinition: (Modules>>#ActionBuilder>>#ActionBuilder) class category: 'ActionBuilder'!
(Modules>>#ActionBuilder>>#ActionBuilder) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#ActionBuilder>>#Action) category: 'ActionBuilder'!
Object subclass: #Action
	instanceVariableNames: 'text menuText buttonText balloonText icon model target actionSelector actionArguments messageSelector enabledSelector enabledArguments selectedSelector selectedArguments owner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActionBuilder'
	inModule: #ActionBuilder!
!classDefinition: (Modules>>#ActionBuilder>>#Action) class category: 'ActionBuilder'!
(Modules>>#ActionBuilder>>#Action) class
	instanceVariableNames: ''!


!(Modules>>#ActionBuilder>>#AbstractActionGroup) methodsFor: 'building' stamp: 'KLG 12/15/2020 18:09:05'!
configureElement: aMorph using: aUIBuilder
	"Configure aMorph using aUIBuilder."

	^ self subclassResponsibility! !

!(Modules>>#ActionBuilder>>#AbstractActionGroup) methodsFor: 'building' stamp: 'KLG 12/15/2020 18:25:54'!
createElementUsing: aUIBuilder in: anOwner
	"Create an approriate element using aUIBuilder."

	^ self subclassResponsibility! !

!(Modules>>#ActionBuilder>>#AbstractActionGroup) methodsFor: 'building' stamp: 'KLG 12/21/2020 13:03:58'!
withButtonHeadingDo: aBlock
	"Execute a Block if we have a button heading."

	buttonHeading ifNotNil: aBlock ! !

!(Modules>>#ActionBuilder>>#AbstractActionGroup) methodsFor: 'building' stamp: 'KLG 12/21/2020 13:03:40'!
withMenuHeadingDo: aBlock
	"Execute a Block if we have a menu heading."

	menuHeading ifNotNil: aBlock ! !

!(Modules>>#ActionBuilder>>#AbstractActionGroup) methodsFor: 'visiting' stamp: 'KLG 12/17/2020 21:10:47'!
visitWith: aBuilder do: aBlock withOwner: anOwner 
	"Visit the action and it's sub-actions in preorder."

	| subOwner |
	aBuilder visitOnly: self do: aBlock withOwner: anOwner ::
		ifNil: [ subOwner _ anOwner ]
		ifNotNil: [ :newElement | subOwner _ newElement ].
	actions do: [ :action |		aBuilder visitAllOf: action do: aBlock withOwner: subOwner ].
! !

!(Modules>>#ActionBuilder>>#AbstractActionGroup) methodsFor: 'accessing' stamp: 'KLG 12/10/2020 13:22:43'!
actions
	"Answer the value of actions"

	^ actions! !

!(Modules>>#ActionBuilder>>#AbstractActionGroup) methodsFor: 'accessing' stamp: 'KLG 12/20/2020 19:08:51'!
actions: anObject
	"Set the value of actions"

	actions _ anObject! !

!(Modules>>#ActionBuilder>>#AbstractActionGroup) methodsFor: 'accessing' stamp: 'KLG 12/17/2020 21:48:11'!
addAction: anAction
	"Add an action to our collection of actions."

	^ actions add: anAction ! !

!(Modules>>#ActionBuilder>>#AbstractActionGroup) methodsFor: 'accessing' stamp: 'KLG 12/21/2020 12:58:27'!
buttonHeading
	"Answer the value of buttonHeading"

	^ buttonHeading! !

!(Modules>>#ActionBuilder>>#AbstractActionGroup) methodsFor: 'accessing' stamp: 'KLG 12/21/2020 12:58:27'!
buttonHeading: anObject
	"Set the value of buttonHeading"

	buttonHeading _ anObject! !

!(Modules>>#ActionBuilder>>#AbstractActionGroup) methodsFor: 'accessing' stamp: 'KLG 12/21/2020 13:00:08'!
heading: aString
	"Set both headings."

	self
		menuHeading: aString;
		buttonHeading: aString ! !

!(Modules>>#ActionBuilder>>#AbstractActionGroup) methodsFor: 'accessing' stamp: 'KLG 12/21/2020 11:20:30'!
isHorizontal
	"Answer the value of isHorizontal"

	^ isHorizontal ifNil: [ true ]! !

!(Modules>>#ActionBuilder>>#AbstractActionGroup) methodsFor: 'accessing' stamp: 'KLG 12/21/2020 11:13:11'!
isHorizontal: anObject
	"Set the value of isHorizontal"

	isHorizontal _ anObject! !

!(Modules>>#ActionBuilder>>#AbstractActionGroup) methodsFor: 'accessing' stamp: 'KLG 12/21/2020 12:58:27'!
menuHeading
	"Answer the value of menuHeading"

	^ menuHeading! !

!(Modules>>#ActionBuilder>>#AbstractActionGroup) methodsFor: 'accessing' stamp: 'KLG 12/21/2020 12:58:27'!
menuHeading: anObject
	"Set the value of menuHeading"

	menuHeading _ anObject! !

!(Modules>>#ActionBuilder>>#AbstractActionGroup) methodsFor: 'accessing' stamp: 'KLG 12/20/2020 19:08:51'!
model
	"Answer the value of model"

	^ model! !

!(Modules>>#ActionBuilder>>#AbstractActionGroup) methodsFor: 'accessing' stamp: 'KLG 12/20/2020 19:08:51'!
model: anObject
	"Set the value of model"

	model _ anObject! !

!(Modules>>#ActionBuilder>>#AbstractActionGroup) methodsFor: 'accessing' stamp: 'KLG 12/10/2020 13:56:21'!
owner
	"Answer my ower."

	^ self subclassResponsibility! !

!(Modules>>#ActionBuilder>>#AbstractActionGroup) methodsFor: 'accessing' stamp: 'KLG 12/10/2020 13:38:32'!
selector
	"Answer the value of selector"

	^ selector! !

!(Modules>>#ActionBuilder>>#AbstractActionGroup) methodsFor: 'accessing' stamp: 'KLG 12/10/2020 13:38:32'!
selector: anObject
	"Set the value of selector"

	selector _ anObject! !

!(Modules>>#ActionBuilder>>#AbstractActionGroup) methodsFor: 'accessing' stamp: 'KLG 12/20/2020 19:09:27'!
target
	"Answer the value of target"

	^ target ifNil: [ self model ]! !

!(Modules>>#ActionBuilder>>#AbstractActionGroup) methodsFor: 'accessing' stamp: 'KLG 12/20/2020 19:08:51'!
target: anObject
	"Set the value of target"

	target _ anObject! !

!(Modules>>#ActionBuilder>>#AbstractActionGroup) methodsFor: 'accessing' stamp: 'KLG 6/10/2021 10:57:29'!
title: aString
	"Set both headings, but don't use sub menus.."

	self heading: aString.
	self useSubMenus: false! !

!(Modules>>#ActionBuilder>>#AbstractActionGroup) methodsFor: 'accessing' stamp: 'KLG 6/10/2021 10:41:46'!
useSubMenus
	"Answer the value of useSubMenus"

	^ useSubMenus ifNil: [ useSubMenus _ true ]! !

!(Modules>>#ActionBuilder>>#AbstractActionGroup) methodsFor: 'accessing' stamp: 'KLG 6/10/2021 10:41:31'!
useSubMenus: anObject
	"Set the value of useSubMenus"

	useSubMenus _ anObject! !

!(Modules>>#ActionBuilder>>#AbstractActionGroup) methodsFor: 'initialization' stamp: 'KLG 6/10/2021 10:42:10'!
initialize
	"Initialize me."

	super initialize.
	actions _ OrderedCollection new.
	useSubMenus _ true! !

!(Modules>>#ActionBuilder>>#AbstractActionGroup) methodsFor: 'instance creation' stamp: 'KLG 12/15/2020 13:47:23'!
menuItemMorphClass
	"Answer the class for of our menu item morphs."

	^ self class menuItemMorphClass! !

!(Modules>>#ActionBuilder>>#AbstractActionGroup) class methodsFor: 'instance creation' stamp: 'KLG 12/10/2020 13:40:47'!
forSelector: aSelector
	"Answer a new action group for a selector."

	^ self new selector: aSelector! !

!(Modules>>#ActionBuilder>>#ActionGroup) methodsFor: 'building' stamp: 'KLG 12/17/2020 21:26:13'!
configureElement: aMorph using: aUIBuilder
	"Create the element using aUIBuilder."

	^ aUIBuilder configure: aMorph fromActionGroup: self using: aUIBuilder! !

!(Modules>>#ActionBuilder>>#ActionGroup) methodsFor: 'building' stamp: 'KLG 12/17/2020 21:27:30'!
createElementUsing: aUIBuilder in: anOwner
	"Create an approriate element using aUIBuilder."

	^ aUIBuilder createMorphFromActionGroup: self in: anOwner! !

!(Modules>>#ActionBuilder>>#ActionGroup) methodsFor: 'accessing' stamp: 'KLG 12/21/2020 11:21:08'!
isHorizontal
	"Answer the value of isHorizontal"

	^ isHorizontal ifNil: [ owner isHorizontal ]! !

!(Modules>>#ActionBuilder>>#ActionGroup) methodsFor: 'accessing' stamp: 'KLG 12/20/2020 19:10:40'!
model
	"Answer my or my owners model."

	^ super model ifNil: [ owner model ]! !

!(Modules>>#ActionBuilder>>#ActionGroup) methodsFor: 'accessing' stamp: 'KLG 12/10/2020 13:57:52'!
owner
	"Answer my ower."

	^ owner! !

!(Modules>>#ActionBuilder>>#ActionGroup) methodsFor: 'accessing' stamp: 'KLG 12/10/2020 13:57:27'!
owner: anObject
	"Set the value of owner"

	owner _ anObject! !

!(Modules>>#ActionBuilder>>#ActionGroup) methodsFor: 'accessing' stamp: 'KLG 12/20/2020 19:12:35'!
target
	"Answer my or my owners target."

	^ target ifNil: [ owner target ] :: ifNil: [ self model ]! !

!(Modules>>#ActionBuilder>>#ActionGroup) class methodsFor: 'instance creation' stamp: 'KLG 12/10/2020 13:49:09'!
ownedBy: anOwnerGroup forSelector: aSelector
	"Answer a new action group for aSelector that is owned by anOwnerGroup"

	^ self forSelector: aSelector :: owner: anOwnerGroup! !

!(Modules>>#ActionBuilder>>#RootActionGroup) methodsFor: 'accessing' stamp: 'KLG 12/10/2020 13:56:51'!
owner
	"Answer my ower.
	
	I have no owner thus i answer nil."

	^ nil! !

!(Modules>>#ActionBuilder>>#RootActionGroup) methodsFor: 'building' stamp: 'KLG 12/21/2020 12:56:48'!
buildMenu: aMenuMorphOrNil with: aMenuBuilder
	"Build the menu.
	
	Answer the menu morph to use. for further building"

	| answer |
	self assert: aMenuMorphOrNil isNil.
	answer _ self menuMorphClass new.
	answer defaultTarget: aMenuBuilder model.
	menuHeading ifNotNil: [ answer addTitle: menuHeading ].
	^ answer! !

!(Modules>>#ActionBuilder>>#RootActionGroup) methodsFor: 'building' stamp: 'KLG 12/17/2020 21:27:46'!
configureElement: aMorph using: aUIBuilder
	"Create the element using aUIBuilder."

	^ aUIBuilder configure: aMorph fromRootActionGroup: self using: aUIBuilder! !

!(Modules>>#ActionBuilder>>#RootActionGroup) methodsFor: 'building' stamp: 'KLG 12/17/2020 21:27:11'!
createElementUsing: aUIBuilder in: anOwner
	"Create an approriate element using aUIBuilder."

	^ aUIBuilder createMorphFromRootActionGroup: self in: anOwner! !

!(Modules>>#ActionBuilder>>#AbstractBuilder) methodsFor: 'visiting' stamp: 'KLG 12/17/2020 23:08:59'!
visitAllOf: anItem do: aBlock
	"Visit an item evaluating aBlock.
	
	Reset current to the state prior to invocation of this method.
	Visit all sub-actions."

	^ self visitAllOf: anItem do: aBlock withOwner: nil! !

!(Modules>>#ActionBuilder>>#AbstractBuilder) methodsFor: 'visiting' stamp: 'KLG 12/17/2020 23:08:48'!
visitAllOf: anItem do: aBlock withOwner: anOwner
	"Visit an item evaluating aBlock.
	
	Reset current to the state prior to invocation of this method.
	Visit all sub-actions."

	^ self visitOnly: anItem do: [ :item : owner |
		item visitWith: self do: aBlock withOwner: anOwner ] withOwner: anOwner! !

!(Modules>>#ActionBuilder>>#AbstractBuilder) methodsFor: 'visiting' stamp: 'KLG 12/17/2020 23:08:36'!
visitAllOfCurrentDo: aBlock
	"Visit the current item evaluating aBlock.
	
	Reset current to the state prior to invocation of this method.
	Visit all sub-actions."

	^ self visitAllOf: current do: aBlock! !

!(Modules>>#ActionBuilder>>#AbstractBuilder) methodsFor: 'visiting' stamp: 'KLG 12/17/2020 23:08:28'!
visitAllOfRootDo: aBlock
	"Visit the root item evaluating aBlock.
	
	Reset current to the state prior to invocation of this method.
	Visit all sub-actions."

	^ self visitAllOf: root do: aBlock! !

!(Modules>>#ActionBuilder>>#AbstractBuilder) methodsFor: 'visiting' stamp: 'KLG 12/17/2020 23:08:22'!
visitCurrentOnlyDo: aBlock
	"Visit the current item evaluating aBlock.
	
	Reset current to the state prior to invocation of this method.
	Do not visit any sub-actions."

	^ self visitOnly: current do: aBlock ! !

!(Modules>>#ActionBuilder>>#AbstractBuilder) methodsFor: 'visiting' stamp: 'KLG 12/17/2020 23:07:51'!
visitOnly: anItem do: aBlock
	"Visit an item evaluating aBlock.
	
	Reset current to the state prior to invocation of this method.
	Do not visit any sub-actions."

	^ self visitOnly: anItem do: aBlock withOwner: nil! !

!(Modules>>#ActionBuilder>>#AbstractBuilder) methodsFor: 'visiting' stamp: 'KLG 12/17/2020 23:08:03'!
visitOnly: anItem do: aBlock withOwner: anOwner
	"Visit an item evaluating aBlock.
	
	Reset current to the state prior to invocation of this method.
	Do not visit any sub-actions."

	| wasCurrent |
	wasCurrent _ current.
	current _ anItem.
	^ [ aBlock valueWithPossibleArgument: current and: anOwner ] ensure: [ current _ wasCurrent ]! !

!(Modules>>#ActionBuilder>>#AbstractBuilder) methodsFor: 'visiting' stamp: 'KLG 12/17/2020 23:08:10'!
visitRootOnlyDo: aBlock
	"Visit the root item evaluating aBlock.
	
	Reset current to the state prior to invocation of this method.
	Do not visit any sub-actions."

	^ self visitOnly: root do: aBlock ! !

!(Modules>>#ActionBuilder>>#AbstractBuilder) methodsFor: 'building' stamp: 'KLG 6/10/2021 10:30:44'!
addItem: anItem selector: aSelector
	"Add an item denoted by aSelector."

	^ items
		at: aSelector
		ifPresent:  [ :existingAction | 
			self itemNamesMustBeUnique 
				ifTrue: [
					self error: 'Duplicate item denoted by: ', aSelector ]
				ifFalse: [ anItem ] ]
		ifAbsent:  [ items at: aSelector put: anItem ]! !

!(Modules>>#ActionBuilder>>#AbstractBuilder) methodsFor: 'instance creation' stamp: 'KLG 12/10/2020 14:06:08'!
actionClass
	"Answer the action class"

	^ self class actionClass! !

!(Modules>>#ActionBuilder>>#AbstractBuilder) methodsFor: 'instance creation' stamp: 'KLG 12/10/2020 13:42:29'!
actionGroupClass
	"Answer the action group class"

	^ self class actionGroupClass! !

!(Modules>>#ActionBuilder>>#AbstractBuilder) methodsFor: 'instance creation' stamp: 'KLG 12/19/2020 15:19:04'!
buttonsBuilderClass
	"Answer the button builder class"

	^ ButtonsBuilder! !

!(Modules>>#ActionBuilder>>#AbstractBuilder) methodsFor: 'instance creation' stamp: 'KLG 12/14/2020 10:33:26'!
menuBuilderClass
	"Answer the menu builder class"

	^ MenuBuilder! !

!(Modules>>#ActionBuilder>>#AbstractBuilder) methodsFor: 'instance creation' stamp: 'KLG 12/10/2020 11:45:50'!
rootActionGroupClass
	"Answer the root action group class"

	^ self class rootActionGroupClass! !

!(Modules>>#ActionBuilder>>#AbstractBuilder) methodsFor: 'accessing' stamp: 'KLG 12/10/2020 13:25:57'!
current
	"Answer the value of current"

	^ current! !

!(Modules>>#ActionBuilder>>#AbstractBuilder) methodsFor: 'accessing' stamp: 'KLG 12/10/2020 13:25:57'!
current: anObject
	"Set the value of current"

	current _ anObject! !

!(Modules>>#ActionBuilder>>#AbstractBuilder) methodsFor: 'accessing' stamp: 'KLG 6/10/2021 10:20:15'!
enforceUniqueItemNames
	"Enforce the uniquness of item names."

	self itemNamesMustBeUnique: true! !

!(Modules>>#ActionBuilder>>#AbstractBuilder) methodsFor: 'accessing' stamp: 'KLG 6/10/2021 10:20:00'!
ignoreDuplicateItemNames
	"Ignore duplicate item names."

	self itemNamesMustBeUnique: false! !

!(Modules>>#ActionBuilder>>#AbstractBuilder) methodsFor: 'accessing' stamp: 'KLG 6/10/2021 10:09:27'!
itemNamesMustBeUnique
	"Answer true if item names must be unique."

	^ itemNamesMustBeUnique ifNil: [ itemNamesMustBeUnique _ true ]! !

!(Modules>>#ActionBuilder>>#AbstractBuilder) methodsFor: 'accessing' stamp: 'KLG 6/10/2021 10:19:22'!
itemNamesMustBeUnique: aFlag
	"Set the uniqueness flag for item names.."

	itemNamesMustBeUnique _ aFlag! !

!(Modules>>#ActionBuilder>>#AbstractBuilder) methodsFor: 'accessing' stamp: 'KLG 12/10/2020 13:25:57'!
model
	"Answer the value of model"

	^ model! !

!(Modules>>#ActionBuilder>>#AbstractBuilder) methodsFor: 'accessing' stamp: 'KLG 12/10/2020 13:25:57'!
model: anObject
	"Set the value of model"

	model _ anObject! !

!(Modules>>#ActionBuilder>>#AbstractBuilder) methodsFor: 'accessing' stamp: 'KLG 12/10/2020 13:25:57'!
root
	"Answer the value of root"

	^ root! !

!(Modules>>#ActionBuilder>>#AbstractBuilder) methodsFor: 'accessing' stamp: 'KLG 12/10/2020 13:25:57'!
root: anObject
	"Set the value of root"

	root _ anObject! !

!(Modules>>#ActionBuilder>>#AbstractBuilder) methodsFor: 'initialization' stamp: 'KLG 6/10/2021 10:18:19'!
initialize
	"Initialize my items dictionary."

	super initialize.
	items _ IdentityDictionary new.
	itemNamesMustBeUnique _ true! !

!(Modules>>#ActionBuilder>>#AbstractBuilder) class methodsFor: 'instance creation' stamp: 'KLG 12/10/2020 14:05:47'!
actionClass
	"Answer the action class"

	^ Action! !

!(Modules>>#ActionBuilder>>#AbstractBuilder) class methodsFor: 'instance creation' stamp: 'KLG 12/10/2020 13:41:43'!
actionGroupClass
	"Answer the action group class"

	^ ActionGroup! !

!(Modules>>#ActionBuilder>>#AbstractBuilder) class methodsFor: 'instance creation' stamp: 'KLG 12/10/2020 11:45:32'!
rootActionGroupClass
	"Answer the root action group class"

	^ RootActionGroup! !

!(Modules>>#ActionBuilder>>#AbstractUIBuilder) methodsFor: 'accessing' stamp: 'KLG 12/14/2020 10:36:00'!
actionBuilder
	"Answer the value of actionBuilder"

	^ actionBuilder! !

!(Modules>>#ActionBuilder>>#AbstractUIBuilder) methodsFor: 'accessing' stamp: 'KLG 12/14/2020 10:36:00'!
actionBuilder: anObject
	"Set the value of actionBuilder"

	actionBuilder _ anObject! !

!(Modules>>#ActionBuilder>>#AbstractUIBuilder) methodsFor: 'accessing' stamp: 'KLG 12/17/2020 23:17:14'!
model
	"Answer the model."

	^ super model ifNil: [ actionBuilder model ]! !

!(Modules>>#ActionBuilder>>#AbstractUIBuilder) methodsFor: 'building' stamp: 'KLG 12/20/2020 15:46:27'!
buildUIElement
	"Build the appropriate UI element."

	root _ nil.
	actionBuilder
		visitAllOfRootDo: [ :action :owner |
			action createElementUsing: self in: owner :: ifNotNil: [ :newElement |
				action configureElement: newElement using: self.
				newElement ] ].
	self assert: root notNil.
	^ root
! !

!(Modules>>#ActionBuilder>>#AbstractUIBuilder) methodsFor: 'building' stamp: 'KLG 12/15/2020 18:38:40'!
configure: aMorph fromAction: anAction using: aUIBuilder
	"Configure aMoprh from anAction."

	^ self subclassResponsibility ! !

!(Modules>>#ActionBuilder>>#AbstractUIBuilder) methodsFor: 'building' stamp: 'KLG 12/19/2020 09:54:46'!
configure: aMorph fromActionGroup: anActionGroup using: aUIBuilder
	"Configure aMoprh from anActionGroup."

	self subclassResponsibility! !

!(Modules>>#ActionBuilder>>#AbstractUIBuilder) methodsFor: 'building' stamp: 'KLG 12/19/2020 09:54:31'!
configure: aMorph fromRootActionGroup: anActionGroup using: aUIBuilder
	"Configure aMorph from anActionGroup."

	self subclassResponsibility! !

!(Modules>>#ActionBuilder>>#AbstractUIBuilder) methodsFor: 'building' stamp: 'KLG 12/15/2020 18:20:35'!
createMorphFromAction: anAction in: anOwner
	"Create and answer the morph appropriate for anAction."

	^ self subclassResponsibility ! !

!(Modules>>#ActionBuilder>>#AbstractUIBuilder) methodsFor: 'building' stamp: 'KLG 12/19/2020 09:53:36'!
createMorphFromActionGroup: anActionGroup in: aMenuMorph
	"Create and answer the morph appropriate for anActionGroup."

	^ self subclassResponsibility! !

!(Modules>>#ActionBuilder>>#AbstractUIBuilder) methodsFor: 'building' stamp: 'KLG 12/19/2020 09:52:44'!
createMorphFromRootActionGroup: anActionGroup in: noMorph
	"Create and answer the morph appropriate for anActionGroup."

	self assert: root isNil.
	^ root _ self subclassResponsibility! !

!(Modules>>#ActionBuilder>>#AbstractUIBuilder) methodsFor: 'building' stamp: 'KLG 12/20/2020 19:54:17'!
modelForAction: anAction
	"Answer the model for an action."

	^ anAction model ifNil: [ self model ]! !

!(Modules>>#ActionBuilder>>#AbstractUIBuilder) methodsFor: 'building' stamp: 'KLG 12/21/2020 16:22:06'!
setBalloonTextOf: aMorph fromAction: anAction
	"Set the balloon text of aMoprh from anAction."

	self subclassResponsibility! !

!(Modules>>#ActionBuilder>>#AbstractUIBuilder) methodsFor: 'building' stamp: 'KLG 12/19/2020 10:06:47'!
setIconOf: aMorph fromAction: anAction
	"Set aMorph's from anAction."

	self subclassResponsibility! !

!(Modules>>#ActionBuilder>>#AbstractUIBuilder) methodsFor: 'building' stamp: 'KLG 12/20/2020 19:54:22'!
targetForAction: anAction
	"Answer the target for an action."

	^ anAction target ifNil: [ self model ]! !

!(Modules>>#ActionBuilder>>#AbstractUIBuilder) methodsFor: 'instance creation' stamp: 'KLG 12/19/2020 14:53:24'!
buttonMorphClass
	"Answer the button morph class to use."

	^ self class buttonMorphClass! !

!(Modules>>#ActionBuilder>>#AbstractUIBuilder) methodsFor: 'instance creation' stamp: 'KLG 12/20/2020 19:36:00'!
buttonsBuilder
	"Answer a buttons builder for me."

	^ actionBuilder buttonsBuilder! !

!(Modules>>#ActionBuilder>>#AbstractUIBuilder) methodsFor: 'instance creation' stamp: 'KLG 12/19/2020 15:13:59'!
labelMorphClass
	"Answer the label morph class to use."

	^ self class labelMorphClass! !

!(Modules>>#ActionBuilder>>#AbstractUIBuilder) methodsFor: 'instance creation' stamp: 'KLG 12/19/2020 14:39:36'!
layoutMorphClass
	"Answer the layout morph class to use."

	^ self class layoutMorphClass! !

!(Modules>>#ActionBuilder>>#AbstractUIBuilder) methodsFor: 'instance creation' stamp: 'KLG 12/20/2020 19:35:35'!
menuBuilder
	"Answer a menu builder for me."

	^ actionBuilder menuBuilder! !

!(Modules>>#ActionBuilder>>#AbstractUIBuilder) methodsFor: 'instance creation' stamp: 'KLG 12/15/2020 19:06:32'!
menuItemMorphClass
	"Answer the class for of our menu item morphs."

	^ self class menuItemMorphClass! !

!(Modules>>#ActionBuilder>>#AbstractUIBuilder) methodsFor: 'instance creation' stamp: 'KLG 12/15/2020 19:06:48'!
menuMorphClass
	"Answe the class for of our menu morphs."

	^ self class menuMorphClass! !

!(Modules>>#ActionBuilder>>#AbstractUIBuilder) class methodsFor: 'instance creation' stamp: 'KLG 12/19/2020 19:57:43'!
buttonMorphClass
	"Answer the button morph class to use.
	
	This is our own morph."

	^ PluggableButtonMorph! !

!(Modules>>#ActionBuilder>>#AbstractUIBuilder) class methodsFor: 'instance creation' stamp: 'KLG 12/14/2020 10:36:04'!
forBuilder: anActionBuilder
	"Answer an instance of mine for an action builder."

	^ self new actionBuilder: anActionBuilder ! !

!(Modules>>#ActionBuilder>>#AbstractUIBuilder) class methodsFor: 'instance creation' stamp: 'KLG 12/19/2020 15:14:23'!
labelMorphClass
	"Answer the label morph class to use."

	^ LabelMorph! !

!(Modules>>#ActionBuilder>>#AbstractUIBuilder) class methodsFor: 'instance creation' stamp: 'KLG 12/19/2020 14:39:59'!
layoutMorphClass
	"Answer the layout morph class to use."

	^ LayoutMorph! !

!(Modules>>#ActionBuilder>>#AbstractUIBuilder) class methodsFor: 'instance creation' stamp: 'KLG 12/15/2020 19:07:30'!
menuItemMorphClass
	"Answe the class for of our menu item morphs."

	^ self subclassResponsibility! !

!(Modules>>#ActionBuilder>>#AbstractUIBuilder) class methodsFor: 'instance creation' stamp: 'KLG 12/15/2020 19:07:42'!
menuMorphClass
	"Answe the class for of our menu morphs."

	^ self subclassResponsibility! !

!(Modules>>#ActionBuilder>>#ButtonsBuilder) methodsFor: 'building' stamp: 'KLG 2/27/2021 12:23:49'!
configure: aButton fromAction: anAction using: aUIBuilder
	"Configure aMoprh from anAction."

	| label |
	label _ anAction buttonText.
	anAction 
		withEnabledSelectorDo: [ :selector :arguments |
			aButton 
				enabledSelector: selector;
				enabledArguments: arguments ].
	label isSymbol ifTrue: [ aButton labelSelector: label ].
	aButton
		model: (self modelForAction: anAction)
		stateGetter: anAction selectedSelector
		stateGetterArguments: anAction selectedArguments
		action: anAction messageSelector
		actionArguments: anAction messageArguments
		label: label;
		target: (self targetForAction: anAction).
	self
		setIconOf: aButton fromAction: anAction;
		setBalloonTextOf: aButton fromAction: anAction! !

!(Modules>>#ActionBuilder>>#ButtonsBuilder) methodsFor: 'building' stamp: 'KLG 12/21/2020 13:04:46'!
configure: aLayoutMorph fromActionGroup: anActionGroup using: aUIBuilder
	"Configure aMorph from anActionGroup."

	anActionGroup withButtonHeadingDo: [ :heading |
		aLayoutMorph addMorph: (self newHeadingMorph: heading darker: true) ]! !

!(Modules>>#ActionBuilder>>#ButtonsBuilder) methodsFor: 'building' stamp: 'KLG 12/21/2020 13:04:38'!
configure: aLayoutMorph fromRootActionGroup: anActionGroup using: aUIBuilder
	"Configure aMorph from anActionGroup."

	anActionGroup withButtonHeadingDo: [ :heading |
		aLayoutMorph addMorph: (self newHeadingMorph: heading darker: false) ]! !

!(Modules>>#ActionBuilder>>#ButtonsBuilder) methodsFor: 'building' stamp: 'KLG 2/25/2021 17:37:57'!
createMorphFromAction: anAction in: anOwnerMorph
	"Create and answer the morph appropriate for anAction."

	| answer |
	answer _ self buttonMorphClass new.
	"O: (actionGroup _ anAction owner) isHorizontal"
	anOwnerMorph isRow
		ifTrue: [
			anOwnerMorph 
				addMorph: answer
				proportionalWidth: 1 / anAction owner actions size.	 ]
		ifFalse: [
			anOwnerMorph addMorphUseAll: answer.
			answer layoutSpec fixedHeight: Theme current buttonPaneHeight ].
	^ answer 
		! !

!(Modules>>#ActionBuilder>>#ButtonsBuilder) methodsFor: 'building' stamp: 'KLG 2/25/2021 17:18:47'!
createMorphFromActionGroup: anActionGroup in: anOwningMorph
	"Create and answer the morph appropriate for anActionGroup."

	| answer ls |
	answer _ self newLayoutMorphFromActionGroup: anActionGroup.
	anOwningMorph isRow
		ifTrue: [ ls _ LayoutSpec proportionalWidth: 1 / anActionGroup owner actions size ]
		ifFalse: [ ls _ LayoutSpec useAll ].
	anOwningMorph
		addMorph: answer
		layoutSpec: ls.
	^ answer.! !

!(Modules>>#ActionBuilder>>#ButtonsBuilder) methodsFor: 'building' stamp: 'KLG 2/25/2021 17:12:17'!
createMorphFromRootActionGroup: anActionGroup in: anOwnerMorphOrNil
	"Create and answer the morph appropriate for anActionGroup."

	self assert: root isNil.
	root _ self newLayoutMorphFromActionGroup: anActionGroup.
	anOwnerMorphOrNil ifNotNil: [
		anOwnerMorphOrNil addMorphUseAll: root ].
	^ root! !

!(Modules>>#ActionBuilder>>#ButtonsBuilder) methodsFor: 'building' stamp: 'KLG 12/21/2020 12:40:01'!
newHeadingMorph: heading darker: beDarker 
	"Create a morph for the heading."

	| color |
	color _ Theme current text.
	beDarker ifTrue: [ color _ color muchDarker ].
	^ self labelMorphClass contents: heading :: color: color! !

!(Modules>>#ActionBuilder>>#ButtonsBuilder) methodsFor: 'building' stamp: 'KLG 12/21/2020 11:18:46'!
newLayoutMorphFromActionGroup: anActionGroup
	"Create a new layout morph from anActionGroup."

	^ anActionGroup isHorizontal
		ifTrue: [ self layoutMorphClass newRow ]
		ifFalse: [ self layoutMorphClass newColumn ]! !

!(Modules>>#ActionBuilder>>#ButtonsBuilder) methodsFor: 'building' stamp: 'KLG 12/21/2020 16:21:54'!
setBalloonTextOf: aMorph fromAction: anAction
	"Set the balloon text of aMoprh from anAction."

	anAction 
		withBalloonTextDo: [ :text |			aMorph setBalloonText: text ]! !

!(Modules>>#ActionBuilder>>#ButtonsBuilder) methodsFor: 'building' stamp: 'KLG 12/19/2020 15:37:21'!
setIconOf: aMorph fromAction: anAction
	"Set aMorph's from anAction."

	anAction withIconDo: [ :icon | 	
		aMorph icon: (
			icon isSymbol
				ifTrue: [ Theme current perform: icon ]
				ifFalse: [ icon ] ) ]! !

!(Modules>>#ActionBuilder>>#ButtonsBuilder) methodsFor: 'instance creation' stamp: 'KLG 12/20/2020 19:36:25'!
buttonsBuilder
	"Answer a buttons builder for me. I am one!!"

	^ self! !

!(Modules>>#ActionBuilder>>#MenuBuilder) methodsFor: 'building' stamp: 'KLG 2/26/2021 19:45:27'!
configure: aMorph fromAction: anAction using: aUIBuilder
	"Configure aMoprh from anAction."

	self 
		setBalloonTextOf: aMorph fromAction: anAction;
		setIconOf: aMorph fromAction: anAction.
	anAction 
		withEnabledSelectorDo: [ :selector :arguments |
			aMorph isEnabled: 
				(self modelForAction: anAction :: perform: selector withArguments: arguments) ]! !

!(Modules>>#ActionBuilder>>#MenuBuilder) methodsFor: 'building' stamp: 'KLG 12/21/2020 12:57:22'!
configure: aMorph fromActionGroup: anActionGroup using: aUIBuilder
	"Configure aMoprh from anActionGroup."

	aMorph defaultTarget: aUIBuilder model.
	anActionGroup withMenuHeadingDo: [ :heading | aMorph 		addTitle: heading ]! !

!(Modules>>#ActionBuilder>>#MenuBuilder) methodsFor: 'building' stamp: 'KLG 12/15/2020 19:21:41'!
configure: aMorph fromRootActionGroup: anActionGroup using: aUIBuilder
	"Configure aMorph from anAction."

	self configure: aMorph fromActionGroup: anActionGroup using: aUIBuilder ! !

!(Modules>>#ActionBuilder>>#MenuBuilder) methodsFor: 'building' stamp: 'KLG 3/3/2021 22:49:13'!
createMorphFromAction: anAction in: aMenuMorph
	"Create and answer the morph appropriate for anAction."

	| menuText selectedSelector actionsModel |
	actionsModel _ self modelForAction: anAction.
	(menuText _ anAction menuText) isSymbol  ifTrue: [
		menuText _ actionsModel perform: menuText ].
	(selectedSelector _ anAction selectedSelector) isSymbol ifTrue: [
		anAction selectedArguments
			ifNil: [ actionsModel perform: selectedSelector ]
			ifNotNil: [
				actionsModel perform: selectedSelector withArguments: anAction selectedArguments ] ::
					ifNotNil: [ :isSelected |
						menuText _ (isSelected ifTrue: [ '<yes>' ] ifFalse: [ '<no>' ]), menuText ] ].
	^ aMenuMorph 
		add: menuText
		target: (self targetForAction: anAction)
		action: anAction messageSelector
		argumentList: anAction messageArguments! !

!(Modules>>#ActionBuilder>>#MenuBuilder) methodsFor: 'building' stamp: 'KLG 6/10/2021 10:55:48'!
createMorphFromActionGroup: anActionGroup in: aMenuMorph
	"Create and answer the morph appropriate for anActionGroup."

	anActionGroup actions ifEmpty: [ ^ nil ].
	anActionGroup useSubMenus
		ifTrue: [
			aMenuMorph hasSubmorphs ifTrue: [ aMenuMorph addLine ].
			anActionGroup withMenuHeadingDo: [ :heading | | subMenu |
				subMenu _ self menuMorphClass new.
				aMenuMorph add: heading, '...' subMenu: subMenu.
				^ subMenu ] ]
		ifFalse: [ ^ aMenuMorph ].
	^ nil ! !

!(Modules>>#ActionBuilder>>#MenuBuilder) methodsFor: 'building' stamp: 'KLG 12/17/2020 23:21:44'!
createMorphFromRootActionGroup: anActionGroup in: noMorph
	"Create and answer the morph appropriate for anActionGroup."

	self assert: root isNil.
	^ root _ self menuMorphClass new! !

!(Modules>>#ActionBuilder>>#MenuBuilder) methodsFor: 'building' stamp: 'KLG 12/21/2020 16:21:32'!
setBalloonTextOf: aMorph fromAction: anAction
	"Set the balloon text of aMoprh from anAction."

	anAction 
		withBalloonTextDo: [ :text |
			aMorph setBalloonText:
				(text isSymbol
					ifFalse: [ text ]
					ifTrue: [ self model perform: text ]	) ]! !

!(Modules>>#ActionBuilder>>#MenuBuilder) methodsFor: 'building' stamp: 'KLG 12/19/2020 10:07:51'!
setIconOf: aMorph fromAction: anAction
	"Set aMorph's from anAction."

	anAction withIconDo: [ :icon | 	aMorph setIcon: icon ]! !

!(Modules>>#ActionBuilder>>#MenuBuilder) methodsFor: 'instance creation' stamp: 'KLG 12/20/2020 19:36:48'!
menuBuilder
	"Answer a menu builder for me. I am one"

	^ self! !

!(Modules>>#ActionBuilder>>#MenuBuilder) class methodsFor: 'instance creation' stamp: 'KLG 12/15/2020 19:07:57'!
menuItemMorphClass
	"Answer the class for of our menu item morphs."

	^ MenuItemMorph! !

!(Modules>>#ActionBuilder>>#MenuBuilder) class methodsFor: 'instance creation' stamp: 'KLG 12/15/2020 19:08:16'!
menuMorphClass
	"Answe the class for of our menu morphs."

	^ MenuMorph! !

!(Modules>>#ActionBuilder>>#ActionBuilder) methodsFor: 'building' stamp: 'KLG 12/18/2020 10:40:47'!
addGroup: aGroup selector: aSelector
	"Add aGroup denoted by aSelector."
	
	^ currentGroup _ self addItem: aGroup selector: aSelector! !

!(Modules>>#ActionBuilder>>#ActionBuilder) methodsFor: 'building' stamp: 'KLG 12/18/2020 11:51:41'!
addItem: anItem selector: aSelector
	"Add an item denoted by aSelector."

	currentGroup ifNil: [
		currentGroup _ root ifNil: [
			currentGroup _ root _ anItem.
			^ super addItem: anItem selector: aSelector			] ].
	^ super addItem: (currentGroup addAction: anItem) selector: aSelector! !

!(Modules>>#ActionBuilder>>#ActionBuilder) methodsFor: 'building' stamp: 'KLG 12/17/2020 21:41:13'!
newAction: aSelector
	"Create a new action and answer it."

	^ self 
		addItem: (current _ self actionClass 
								ownedBy: current 
								forSelector: aSelector
								andModel: model)
		selector: aSelector! !

!(Modules>>#ActionBuilder>>#ActionBuilder) methodsFor: 'building' stamp: 'KLG 6/10/2021 10:17:50'!
newAction: aSelector buildDoing: aBlock
	"Create a new action and evaluate a aBlock with me and the newly created action."

	| previous previousUniquenessFlag |
	previous _ current.
	previousUniquenessFlag _ self itemNamesMustBeUnique.
	[ aBlock valueWithPossibleArgument: (self newAction: aSelector) and: self ] ensure:
		[	
			self itemNamesMustBeUnique: previousUniquenessFlag.
			current _ previous ]! !

!(Modules>>#ActionBuilder>>#ActionBuilder) methodsFor: 'building' stamp: 'KLG 12/17/2020 22:59:46'!
newActionGroup: aSelector
	"Create a new action group and answer it."

	^ self 
		addGroup: (current _ self actionGroupClass ownedBy: current forSelector: aSelector)
		selector: aSelector! !

!(Modules>>#ActionBuilder>>#ActionBuilder) methodsFor: 'building' stamp: 'KLG 6/10/2021 10:16:58'!
newActionGroup: aSelector buildDoing: aBlock
	"Create a new action group and evaluate a aBlock with me and the newly created action."
	
	| previous previousGroup previousUniquenessFlag |
	previous _ current.
	previousGroup _ currentGroup.
	previousUniquenessFlag _ self itemNamesMustBeUnique.
	[ aBlock valueWithPossibleArgument: (self newActionGroup: aSelector) and: self ] ensure:
		[
			self itemNamesMustBeUnique: previousUniquenessFlag.
			currentGroup _ previousGroup.
			current _ previous ]! !

!(Modules>>#ActionBuilder>>#ActionBuilder) methodsFor: 'building' stamp: 'KLG 12/18/2020 11:42:15'!
newRootActionGroup: aSelector
	"Create a new root action group and answer it."

	^ self 
		addGroup: (current _ self rootActionGroupClass forSelector: aSelector)
		selector: aSelector! !

!(Modules>>#ActionBuilder>>#ActionBuilder) methodsFor: 'building' stamp: 'KLG 12/17/2020 21:41:44'!
newRootActionGroup: aSelector forModel: aModel
	"Create a new root action group for aModel and answer it."

	model _ aModel.
	^ self newRootActionGroup: aSelector! !

!(Modules>>#ActionBuilder>>#ActionBuilder) methodsFor: 'building' stamp: 'KLG 6/10/2021 10:16:05'!
newRootActionGroup: aSelector forModel: aModel buildDoing: aBlock
	"Create a new root action and evaluate a aBlock with me and the newly created action."

	| previous previousGroup previousUniqenessFlag |
	previous _ current.
	previousGroup _ currentGroup.
	previousUniqenessFlag _ self itemNamesMustBeUnique.
	[ aBlock
		valueWithPossibleArgument:
			(current _ self newRootActionGroup: aSelector forModel: aModel)
		and: self ] ensure:
		[
			self itemNamesMustBeUnique: previousUniqenessFlag.
			currentGroup _ previousGroup.
			current _ previous ]
	! !

!(Modules>>#ActionBuilder>>#ActionBuilder) methodsFor: 'instance creation' stamp: 'KLG 12/19/2020 15:19:06'!
buttonsBuilder
	"Answer a builder that builds layout morphs with buttons."

	^ self buttonsBuilderClass forBuilder: self ! !

!(Modules>>#ActionBuilder>>#ActionBuilder) methodsFor: 'instance creation' stamp: 'KLG 12/14/2020 10:36:06'!
menuBuilder
	"Answer a builder that builds menus "

	^ self menuBuilderClass forBuilder: self ! !

!(Modules>>#ActionBuilder>>#Action) methodsFor: 'visiting' stamp: 'KLG 12/17/2020 21:12:47'!
visitWith: aBuilder do: aBlock withOwner: anOwner 
	"Visit the action and it's sub-actions in preorder.
	
	I have no subactions, so let aBuilder just visit me."

	aBuilder visitOnly: self do: aBlock withOwner: anOwner! !

!(Modules>>#ActionBuilder>>#Action) methodsFor: 'accessing' stamp: 'KLG 2/27/2021 12:22:07'!
actionArgument: anObject
	"Set the value of actionArguments"

	self actionArguments: { anObject }! !

!(Modules>>#ActionBuilder>>#Action) methodsFor: 'accessing' stamp: 'KLG 2/27/2021 12:22:20'!
actionArguments
	"Answer the value of actionArguments"

	^ actionArguments ifNil: [ #() ]! !

!(Modules>>#ActionBuilder>>#Action) methodsFor: 'accessing' stamp: 'KLG 2/27/2021 12:22:29'!
actionArguments: anObject
	"Set the value of actionArguments"

	actionArguments _ anObject! !

!(Modules>>#ActionBuilder>>#Action) methodsFor: 'accessing' stamp: 'KLG 12/10/2020 11:48:54'!
actionSelector
	"Answer the value of actionSelector"

	^ actionSelector! !

!(Modules>>#ActionBuilder>>#Action) methodsFor: 'accessing' stamp: 'KLG 12/10/2020 11:48:54'!
actionSelector: anObject
	"Set the value of actionSelector"

	actionSelector _ anObject! !

!(Modules>>#ActionBuilder>>#Action) methodsFor: 'accessing' stamp: 'KLG 12/13/2020 23:07:07'!
balloonText
	"Answer the value of balloonText"

	^ balloonText! !

!(Modules>>#ActionBuilder>>#Action) methodsFor: 'accessing' stamp: 'KLG 12/13/2020 23:07:07'!
balloonText: anObject
	"Set the value of balloonText"

	balloonText _ anObject! !

!(Modules>>#ActionBuilder>>#Action) methodsFor: 'accessing' stamp: 'KLG 12/15/2020 18:50:06'!
buttonText
	"Answer the value of buttonText"

	^ buttonText ifNil: [ self text ]! !

!(Modules>>#ActionBuilder>>#Action) methodsFor: 'accessing' stamp: 'KLG 12/10/2020 11:48:54'!
buttonText: anObject
	"Set the value of buttonText"

	buttonText _ anObject! !

!(Modules>>#ActionBuilder>>#Action) methodsFor: 'accessing' stamp: 'KLG 2/26/2021 19:57:14'!
enabledArgument: anObject
	"Set the value of enabledArguments"

	self enabledArguments: { anObject }! !

!(Modules>>#ActionBuilder>>#Action) methodsFor: 'accessing' stamp: 'KLG 2/26/2021 19:55:10'!
enabledArguments
	"Answer the value of enabledArguments"

	^ enabledArguments ifNil: [ #() ]! !

!(Modules>>#ActionBuilder>>#Action) methodsFor: 'accessing' stamp: 'KLG 2/26/2021 19:43:45'!
enabledArguments: anObject
	"Set the value of enabledArguments"

	enabledArguments _ anObject! !

!(Modules>>#ActionBuilder>>#Action) methodsFor: 'accessing' stamp: 'KLG 12/10/2020 11:48:54'!
enabledSelector
	"Answer the value of enabledSelector"

	^ enabledSelector! !

!(Modules>>#ActionBuilder>>#Action) methodsFor: 'accessing' stamp: 'KLG 12/10/2020 11:48:54'!
enabledSelector: anObject
	"Set the value of enabledSelector"

	enabledSelector _ anObject! !

!(Modules>>#ActionBuilder>>#Action) methodsFor: 'accessing' stamp: 'KLG 12/10/2020 11:48:54'!
icon
	"Answer the value of icon"

	^ icon! !

!(Modules>>#ActionBuilder>>#Action) methodsFor: 'accessing' stamp: 'KLG 12/10/2020 11:48:54'!
icon: anObject
	"Set the value of icon"

	icon _ anObject! !

!(Modules>>#ActionBuilder>>#Action) methodsFor: 'accessing' stamp: 'KLG 12/15/2020 18:49:14'!
menuText
	"Answer the value of menuText"

	^ menuText ifNil: [ self text ]! !

!(Modules>>#ActionBuilder>>#Action) methodsFor: 'accessing' stamp: 'KLG 12/10/2020 11:48:54'!
menuText: anObject
	"Set the value of menuText"

	menuText _ anObject! !

!(Modules>>#ActionBuilder>>#Action) methodsFor: 'accessing' stamp: 'KLG 2/27/2021 12:20:48'!
messageArgument: anObject
	"Just a synonym for action argument."

	self actionArgument: anObject! !

!(Modules>>#ActionBuilder>>#Action) methodsFor: 'accessing' stamp: 'KLG 2/27/2021 12:23:24'!
messageArguments
	"Answer the argument arry for messages."

	^self actionArguments! !

!(Modules>>#ActionBuilder>>#Action) methodsFor: 'accessing' stamp: 'KLG 2/27/2021 12:21:52'!
messageArguments: anObject
	"Just a synonym for #actionArguments:"

	self actionArguments: anObject! !

!(Modules>>#ActionBuilder>>#Action) methodsFor: 'accessing' stamp: 'KLG 2/26/2021 19:42:26'!
messageSelector
	"Answer the value of messageSelector"

	^ messageSelector ifNil: [ self actionSelector ]! !

!(Modules>>#ActionBuilder>>#Action) methodsFor: 'accessing' stamp: 'KLG 2/27/2021 12:19:33'!
messageSelector: anObject
	"Set the value of messageSelector"

	messageSelector _ anObject! !

!(Modules>>#ActionBuilder>>#Action) methodsFor: 'accessing' stamp: 'KLG 12/20/2020 19:14:11'!
model
	"Answer my or my owners model."

	^ model ifNil: [ owner model ]! !

!(Modules>>#ActionBuilder>>#Action) methodsFor: 'accessing' stamp: 'KLG 12/10/2020 11:48:54'!
model: anObject
	"Set the value of model"

	model _ anObject! !

!(Modules>>#ActionBuilder>>#Action) methodsFor: 'accessing' stamp: 'KLG 12/10/2020 11:48:54'!
owner
	"Answer the value of owner"

	^ owner! !

!(Modules>>#ActionBuilder>>#Action) methodsFor: 'accessing' stamp: 'KLG 12/10/2020 11:48:54'!
owner: anObject
	"Set the value of owner"

	owner _ anObject! !

!(Modules>>#ActionBuilder>>#Action) methodsFor: 'accessing' stamp: 'KLG 2/26/2021 19:58:16'!
selectedArgument: anObject
	"Set the value of selectedArguments"

	self selectedArguments: { anObject }! !

!(Modules>>#ActionBuilder>>#Action) methodsFor: 'accessing' stamp: 'KLG 2/26/2021 19:43:45'!
selectedArguments
	"Answer the value of selectedArguments"

	^ selectedArguments! !

!(Modules>>#ActionBuilder>>#Action) methodsFor: 'accessing' stamp: 'KLG 2/26/2021 19:43:45'!
selectedArguments: anObject
	"Set the value of selectedArguments"

	selectedArguments _ anObject! !

!(Modules>>#ActionBuilder>>#Action) methodsFor: 'accessing' stamp: 'KLG 12/10/2020 11:48:54'!
selectedSelector
	"Answer the value of selectedSelector"

	^ selectedSelector! !

!(Modules>>#ActionBuilder>>#Action) methodsFor: 'accessing' stamp: 'KLG 12/10/2020 11:48:54'!
selectedSelector: anObject
	"Set the value of selectedSelector"

	selectedSelector _ anObject! !

!(Modules>>#ActionBuilder>>#Action) methodsFor: 'accessing' stamp: 'KLG 12/20/2020 19:13:49'!
target
	"Answer my or my owners target."

	^ target ifNil: [ owner target ] :: ifNil: [ self model ]! !

!(Modules>>#ActionBuilder>>#Action) methodsFor: 'accessing' stamp: 'KLG 12/20/2020 19:00:21'!
target: anObject
	"Set the value of target"

	target _ anObject! !

!(Modules>>#ActionBuilder>>#Action) methodsFor: 'accessing' stamp: 'KLG 12/15/2020 18:49:47'!
text
	"Answer the value of text"

	^ text ifNil: [ self actionSelector asString ]! !

!(Modules>>#ActionBuilder>>#Action) methodsFor: 'accessing' stamp: 'KLG 12/10/2020 11:48:54'!
text: anObject
	"Set the value of text"

	text _ anObject! !

!(Modules>>#ActionBuilder>>#Action) methodsFor: 'instance creation' stamp: 'KLG 12/15/2020 13:51:27'!
menuItemMorphClass
	"Answer the class for of our menu item morphs."

	^ self class menuItemMorphClass! !

!(Modules>>#ActionBuilder>>#Action) methodsFor: 'building' stamp: 'KLG 2/25/2021 18:15:58'!
buildMenu: aMenuMorph with: aMenuBuilder
	"Build the menu.
	
	Answer the menu morph to use. for further building"

	self assert: aMenuMorph notNil.
	aMenuMorph add: self menuText action: self messageSelector.
	^ aMenuMorph ! !

!(Modules>>#ActionBuilder>>#Action) methodsFor: 'building' stamp: 'KLG 12/15/2020 18:39:08'!
configureElement: aMorph using: aUIBuilder
	"Create the element using aUIBuilder."

	^ aUIBuilder configure: aMorph fromAction: self using: aUIBuilder! !

!(Modules>>#ActionBuilder>>#Action) methodsFor: 'building' stamp: 'KLG 12/15/2020 18:22:28'!
createElementUsing: aUIBuilder in: anOwner
	"Create the element using aUIBuilder."

	^ aUIBuilder createMorphFromAction: self in: anOwner! !

!(Modules>>#ActionBuilder>>#Action) methodsFor: 'building' stamp: 'KLG 12/15/2020 18:44:55'!
withBalloonTextDo: aBlock
	"Execute aBlock with the balloon text if there exists one."

	balloonText ifNotNil: aBlock! !

!(Modules>>#ActionBuilder>>#Action) methodsFor: 'building' stamp: 'KLG 2/26/2021 19:55:36'!
withEnabledSelectorDo: aBlock
	"Execute aBlock with the enabled selecor if there exists one."

	enabledSelector ifNotNil: [ aBlock value: enabledSelector value: self enabledArguments ]! !

!(Modules>>#ActionBuilder>>#Action) methodsFor: 'building' stamp: 'KLG 12/15/2020 18:52:45'!
withIconDo: aBlock
	"Execute aBlock with the icon (selector) if there exists one."

	icon ifNotNil: aBlock! !

!(Modules>>#ActionBuilder>>#Action) class methodsFor: 'instance creation' stamp: 'KLG 12/15/2020 13:51:44'!
menuItemMorphClass
	"Answer the class for of our menu item morphs."

	^ MenuItemMorph! !

!(Modules>>#ActionBuilder>>#Action) class methodsFor: 'instance creation' stamp: 'KLG 12/10/2020 18:37:23'!
ownedBy: anOwnerGroup forSelector: aSelector andModel: aModel
	"Answer a new action for aSelector that is owned by anOwnerGroup"

	^ self new actionSelector: aSelector :: owner: anOwnerGroup :: model: aModel! !
