'From Haver 5.0 [latest update: #4572] on 29 April 2021 at 10:01:30 pm'!
'Description '!
!provides: 'MQTTTests' 1 7!
SystemOrganization addCategory: 'MQTTClientTest'!


!moduleCreation: MQTTClientTest!
Modules newEnvironment: #MQTTClientTest!

!interfacesOf: MQTTClient!
Modules environment: #MQTTClient ::
	interface: #UTI exporting: #(#MQTTPacketPingReq #MQTTPendingPubAckJob #MQTTPacketUnsubscribe #MQTTPendingSubAckJob #MQTTPendingPubRelJob #MQTTPacketPubAck #MQTTPacketVariableHeaded #MQTTConnectionException #MQTTPacketPubRel #MQTTPacketVariableHeadedWithPayload #MQTTPendingPingJob #MQTTPendingPubCompJob #MQTTSubscription #MQTTClient #MQTTPacketPublish #MQTTPacketConnect #MQTTPacketPingResp #MQTTPendingJob #MQTTPacketSubAck #MQTTBrokerLookupFailure #MQTTPacketSubscribe #MQTTPacketUnsubAck #MQTTPendingUnsubAckJob #MQTTPendingPubRecJob #MQTTPacket #MQTTPacketConnAck #MQTTPacketDisconnect #MQTTPacketPubComp #MQTTPacketPubRec ) inPackage: 'MQTTClientTest'!
!interfacesOf: MQTTClientTest!
Modules environment: #MQTTClientTest ::
	interface: #SPI aliasFor: #API!

!importsOf: MQTTClientTest!
Modules environment: #MQTTClientTest :: 
	import: #UTI of: Modules>>#MQTTClient!

!classDefinition: (Modules>>#MQTTClientTest>>#MQTTClientTests) category: 'MQTTClientTest'!
TestCase subclass: #MQTTClientTests
	instanceVariableNames: 'client broker'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MQTTClientTest'
	inModule: #MQTTClientTest!
!classDefinition: (Modules>>#MQTTClientTest>>#MQTTClientTests) class category: 'MQTTClientTest'!
(Modules>>#MQTTClientTest>>#MQTTClientTests) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#MQTTClientTest>>#MQTTConnectionTests) category: 'MQTTClientTest'!
TestCase subclass: #MQTTConnectionTests
	instanceVariableNames: 'hostName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MQTTClientTest'
	inModule: #MQTTClientTest!
!classDefinition: (Modules>>#MQTTClientTest>>#MQTTConnectionTests) class category: 'MQTTClientTest'!
(Modules>>#MQTTClientTest>>#MQTTConnectionTests) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#MQTTClientTest>>#MQTTPacketTests) category: 'MQTTClientTest'!
TestCase subclass: #MQTTPacketTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MQTTClientTest'
	inModule: #MQTTClientTest!
!classDefinition: (Modules>>#MQTTClientTest>>#MQTTPacketTests) class category: 'MQTTClientTest'!
(Modules>>#MQTTClientTest>>#MQTTPacketTests) class
	instanceVariableNames: ''!


!(Modules>>#MQTTClientTest>>#MQTTClientTests) methodsFor: 'running' stamp: 'KLG 4/29/2021 21:55:29'!
setUp

	"create a client that will attempt to connect to broker"
	client _ MQTTClient new.
	broker _ '127.0.0.1'.
	client
		host: broker;
		clientID: 'testingSqueakMQTT'.! !

!(Modules>>#MQTTClientTest>>#MQTTClientTests) methodsFor: 'running' stamp: 'KLG 7/30/2020 17:27:34'!
tearDown
	"make sure to close the conenction"

	client disconnect.! !

!(Modules>>#MQTTClientTest>>#MQTTClientTests) methodsFor: 'testing' stamp: 'KLG 7/30/2020 17:28:02'!
testQOS0Publishing
	"connect to the broker, subscribe to 'squeakmqtttesting/qos1test', publish to that same topic and check we get back the right message, all at qos=0"
	
	| topic message rxed count qos |
	client class debugOn.
	qos _ 0.
	topic _ 'squeakmqtttesting/qos' , qos asString , 'test'.
	message _ 'sqmqtttest'.
	rxed _ false.
	count _ 0.
	"connect"
	client connect.
	"subscribe"
	client
		onTopic: topic
		qos: qos
		do: [ :t :m |
			self assert: t = topic.
			self assert: m asString = message.
			rxed _ true ].
	"now publish to the topic"
	client
		publishTopic: topic
		message: message
		qos: qos.
	"give the broker some time to return the publish, but not too much"
	[
	count < 10 and: [ rxed not ]] whileTrue: [
		(Delay forMilliseconds: 500) wait.
		count _ count + 1 ].
	"we've only passed if we rxed the message"
	self assert: rxed.
	client class debugOff.! !

!(Modules>>#MQTTClientTest>>#MQTTClientTests) methodsFor: 'testing' stamp: 'KLG 7/30/2020 17:28:12'!
testQOS1Publishing
	"connect to the broker, subscribe to 'squeakmqtttesting/qos1test', publish to that same topic and check we get back the right message, all at qos=1"
	
	| topic message rxed count qos |
	client class debugOn.
	qos _ 1.
	topic _ 'squeakmqtttesting/qos' , qos asString , 'test'.
	message _ 'sqmqtttest'.
	rxed _ false.
	count _ 0.
	"connect"
	client connect.
	"subscribe"
	client
		onTopic: topic
		qos: qos
		do: [ :t :m |
			self assert: t = topic.
			self assert: m asString = message.
			rxed _ true ].
	"now publish to the topic"
	client
		publishTopic: topic
		message: message
		qos: qos.
	"give the broker some time to return the publish, but not too much"
	[
	count < 10 and: [ rxed not ]] whileTrue: [
		(Delay forMilliseconds: 500) wait.
		count _ count + 1 ].
	"we've only passed if we rxed the message"
	self assert: rxed.
	client class debugOff.! !

!(Modules>>#MQTTClientTest>>#MQTTClientTests) methodsFor: 'testing' stamp: 'KLG 7/30/2020 17:28:16'!
testQOS2Publishing
	"connect to the broker, subscribe to 'squeakmqtttesting/qos1test', publish to that same topic and check we get back the right message, all at qos=2"

	| topic message rxed count qos |
	client class debugOn.
	qos _ 2.
	topic _ 'squeakmqtttesting/qos' , qos asString , 'test'.
	message _ 'sqmqtttest'.
	rxed _ false.
	count _ 0.
	"connect"
	client connect.
	"subscribe"
	client
		onTopic: topic
		qos: qos
		do: [ :t :m |
			self assert: t = topic.
			self assert: m asString = message.
			rxed _ true ].
	"now publish to the topic"
	client
		publishTopic: topic
		message: message
		qos: qos.
	"give the broker some time to return the publish, but not too much"
	[
	count < 10 and: [ rxed not ]] whileTrue: [
		(Delay forMilliseconds: 500) wait.
		count _ count + 1 ].
	"we've only passed if we rxed the message"
	self assert: rxed.
	client class debugOff.! !

!(Modules>>#MQTTClientTest>>#MQTTConnectionTests) methodsFor: 'testing' stamp: 'KLG 7/30/2020 20:44:59'!
testLocalSubscribeAndPublish
	"try to connect to an mqtt broker
	send a connect packet
	wait for a connAck packet
	send a subscribe 'weatherstation/mqtttesting'
	wait for a subAck
	start looping process to read incoming published info
	send a disconnect"

	| connAckPacket connectPacket sockStrm resultPacket subAckPacket subPacket |
	sockStrm _ SocketStream
		openConnectionToHostNamed: hostName
		port: 1883.
	sockStrm binary.
	connectPacket _ MQTTPacketConnect new keepAliveTime: 0.
	connectPacket encodeOn: sockStrm.
	connAckPacket _ MQTTPacket readFrom: sockStrm.
	self assert: [ connAckPacket class = MQTTPacketConnAck ].
	self assert: [ connAckPacket sessionPresent isKindOf: Boolean ].
	subPacket _ MQTTPacketSubscribe new
		
			addTopic: 'weatherstation/mqtttestÿing2'
			qos: 0;
		packetID: 242.
	subPacket encodeOn: sockStrm.
	subAckPacket _ MQTTPacket readFrom: sockStrm.
	self assert: [ subAckPacket class = MQTTPacketSubAck ].
	(Delay forMilliseconds: 2000) wait.
	sockStrm noTimeout.
	[ [ [
		resultPacket _ MQTTPacket readFrom: sockStrm.
		Transcript
			show: resultPacket;
			cr ] repeat ]
			on: Error
			do: [ :e |
				Transcript
					show: e;
					cr.
				MQTTPacketDisconnect new encodeOn: sockStrm.
				sockStrm close ]] forkNamed: 'MQTTProcess'.! !

!(Modules>>#MQTTClientTest>>#MQTTConnectionTests) methodsFor: 'testing' stamp: 'KLG 7/30/2020 21:15:06'!
testQOS1LocalPublish
	"simplest publish related test I can think of; add qos 1 to the mix"
	"try to connect to an mqtt broker.
	send a connect packet
	wait for a connAck packet
	send a pingreq
	wait for a pingresp
	send a disconnect"
	| connAckPacket connectPacket disconnectPacket  pubPacket sockStrm pubAckPacket |
	sockStrm := SocketStream openConnectionToHostNamed: hostName port: 1883.
	sockStrm binary.
	connectPacket := MQTTPacketConnect new
							willTopic: 'hello'
							message: 'there'
							retain: true
							qos: 0.
	connectPacket encodeOn: sockStrm.
	connAckPacket := MQTTPacket readFrom: sockStrm.
	self assert: [connAckPacket class = MQTTPacketConnAck].
	self assert: [connAckPacket sessionPresent isKindOf:Boolean].
	pubPacket := MQTTPacketPublish new
						topic: 'weatherstation/mqtttesing' message: 'hello qos 1' asByteArray;
						messageID: 42;
						qos: 1.
	pubPacket encodeOn: sockStrm.
	pubAckPacket := MQTTPacket readFrom: sockStrm.
	self assert: [pubAckPacket class = MQTTPacketPubAck].
	self assert: [pubAckPacket packetID = 42].			
	disconnectPacket := MQTTPacketDisconnect new.
	disconnectPacket encodeOn: sockStrm.
	sockStrm close
	
	! !

!(Modules>>#MQTTClientTest>>#MQTTConnectionTests) methodsFor: 'testing' stamp: 'KLG 7/30/2020 21:23:31'!
testQOS2LocalPublish
	"simplest publish related test I can think of; add qos 2 to the mix"
	"try to connect to an mqtt broker.
	send a connect packet
	wait for a connAck packet
	send a pingreq
	wait for a pingresp
	send a disconnect"
	
	| connAckPacket connectPacket disconnectPacket pubPacket sockStrm pubCompPacket pubRecPacket pubRelPacket |
	sockStrm _ SocketStream
		openConnectionToHostNamed: hostName
		port: 1883.
	sockStrm binary.
	connectPacket _ MQTTPacketConnect new
		willTopic: 'hello'
		message: 'there'
		retain: true
		qos: 0.
	connectPacket encodeOn: sockStrm.
	connAckPacket _ MQTTPacket readFrom: sockStrm.
	self assert: [ connAckPacket class = MQTTPacketConnAck ].
	self assert: [ connAckPacket sessionPresent isKindOf: Boolean ].
	pubPacket _ MQTTPacketPublish new
		
			topic: 'weatherstation/mqtttesing'
			message: 'hello qos 2' asByteArray;
		messageID: 142;
		qos: 2.
	pubPacket encodeOn: sockStrm.
	pubRecPacket _ MQTTPacket readFrom: sockStrm.
	self assert: [ pubRecPacket class = MQTTPacketPubRec ].
	self assert: [ pubRecPacket packetID = 142 ].
	pubRelPacket _ MQTTPacketPubRel new packetID: pubRecPacket packetID.
	pubRelPacket encodeOn: sockStrm.
	pubCompPacket _ MQTTPacket readFrom: sockStrm.
	self assert: [ pubCompPacket class = MQTTPacketPubComp ].
	self assert: [ pubCompPacket packetID = 142 ].
	disconnectPacket _ MQTTPacketDisconnect new.
	disconnectPacket encodeOn: sockStrm.
	sockStrm close.! !

!(Modules>>#MQTTClientTest>>#MQTTConnectionTests) methodsFor: 'testing' stamp: 'KLG 7/30/2020 21:23:56'!
testSimpleConnection
	"simplest connections related test I can think of"
	"try to connect to an mqtt broker.
	send a connect packet
	wait for a connAck packet
	send a pingreq
	wait for a pingresp
	send a disconnect"
	
	| connAckPacket connectPacket disconnectPacket pingPacket pingRespPacket sockStrm |
	self flag: 'Make this work, behin our proxy'.
	"hostName _ 'iot.eclipse.org'."
	sockStrm _ SocketStream
		openConnectionToHostNamed: hostName
		port: 1883.
	sockStrm binary.
	connectPacket _ MQTTPacketConnect new
		willTopic: 'hello'
		message: 'there'
		retain: true
		qos: 0.
	connectPacket encodeOn: sockStrm.
	connAckPacket _ MQTTPacket readFrom: sockStrm.
	self assert: [ connAckPacket class = MQTTPacketConnAck ].
	self assert: [ connAckPacket sessionPresent isKindOf: Boolean ].
	pingPacket _ MQTTPacketPingReq new.
	pingPacket encodeOn: sockStrm.
	pingRespPacket _ MQTTPacket readFrom: sockStrm.
	self assert: [ pingRespPacket class = MQTTPacketPingResp ].
	disconnectPacket _ MQTTPacketDisconnect new.
	disconnectPacket encodeOn: sockStrm.
	sockStrm close.! !

!(Modules>>#MQTTClientTest>>#MQTTConnectionTests) methodsFor: 'testing' stamp: 'KLG 7/30/2020 20:47:24'!
testSimpleLocalConnection
	"simplest connections related test I can think of"
	"try to connect to an mqtt broker.
	send a connect packet
	wait for a connAck packet
	send a pingreq
	wait for a pingresp
	send a disconnect"

	| connAckPacket connectPacket disconnectPacket pingPacket pingRespPacket sockStrm |
	sockStrm _ SocketStream
		openConnectionToHostNamed: hostName
		port: 1883.
	sockStrm binary.
	connectPacket _ MQTTPacketConnect new
		willTopic: 'hello'
		message: 'there'
		retain: true
		qos: 0.
	connectPacket encodeOn: sockStrm.
	connAckPacket _ MQTTPacket readFrom: sockStrm.
	self assert: [ connAckPacket class = MQTTPacketConnAck ].
	self assert: [ connAckPacket sessionPresent isKindOf: Boolean ].
	pingPacket _ MQTTPacketPingReq new.
	pingPacket encodeOn: sockStrm.
	pingRespPacket _ MQTTPacket readFrom: sockStrm.
	self assert: [ pingRespPacket class = MQTTPacketPingResp ].
	disconnectPacket _ MQTTPacketDisconnect new.
	disconnectPacket encodeOn: sockStrm.
	sockStrm close.! !

!(Modules>>#MQTTClientTest>>#MQTTConnectionTests) methodsFor: 'testing' stamp: 'KLG 7/30/2020 20:47:32'!
testSimpleLocalConnectionWithWill
	"simplest connections related test I can think of; don't disconnect and so trigger the will being published"
	"try to connect to an mqtt broker.
	send a connect packet
	wait for a connAck packet
	send a pingreq
	wait for a pingresp
	send a disconnect"

	| connAckPacket connectPacket pingPacket sockStrm |
	sockStrm _ SocketStream
		openConnectionToHostNamed: hostName
		port: 1883.
	sockStrm binary.
	connectPacket _ MQTTPacketConnect new
		
			willTopic: 'weatherstation/mqtttesting'
			message: 'mqtt will testing ok'
			retain: true
			qos: 0;
		keepAliveTime: 2.
	connectPacket encodeOn: sockStrm.
	connAckPacket _ MQTTPacket readFrom: sockStrm.
	self assert: [ connAckPacket class = MQTTPacketConnAck ].
	self assert: [ connAckPacket sessionPresent isKindOf: Boolean ].
	pingPacket _ MQTTPacketPingReq new.
	pingPacket encodeOn: sockStrm.
	sockStrm close.! !

!(Modules>>#MQTTClientTest>>#MQTTConnectionTests) methodsFor: 'testing' stamp: 'KLG 7/30/2020 20:47:38'!
testSimpleLocalPublish
	"simplest publish related test I can think of"
	"try to connect to an mqtt broker.
	send a connect packet
	wait for a connAck packet
	send a pingreq
	wait for a pingresp
	send a disconnect"

	| connAckPacket connectPacket disconnectPacket pubPacket sockStrm |
	sockStrm _ SocketStream
		openConnectionToHostNamed: hostName
		port: 1883.
	sockStrm binary.
	connectPacket _ MQTTPacketConnect new
		willTopic: 'hello'
		message: 'there'
		retain: true
		qos: 0.
	connectPacket encodeOn: sockStrm.
	connAckPacket _ MQTTPacket readFrom: sockStrm.
	self assert: [ connAckPacket class = MQTTPacketConnAck ].
	self assert: [ connAckPacket sessionPresent isKindOf: Boolean ].
	pubPacket _ MQTTPacketPublish new
		topic: 'weatherstation/mqtttesing'
		message: 'hello, qos 0' asByteArray.
	pubPacket encodeOn: sockStrm.
	disconnectPacket _ MQTTPacketDisconnect new.
	disconnectPacket encodeOn: sockStrm.
	sockStrm close.! !

!(Modules>>#MQTTClientTest>>#MQTTConnectionTests) methodsFor: 'testing' stamp: 'KLG 7/30/2020 20:47:44'!
testSimpleLocalSubscribeAndPublish
	"simplest publish/subscribe related test I can think of"
	"try to connect to an mqtt broker.
	send a connect packet
	wait for a connAck packet
	send a subscribe 'weatherstation/mqtttesting'
	wait for a subAck
	send a publish qos=0 'weatherstation/mqtttesting' - 'hello'
	send a disconnect"

	| connAckPacket connectPacket disconnectPacket pubPacket sockStrm resultPacket subAckPacket subPacket messageString |
	messageString _ 'hello, subscriber'.
	sockStrm _ SocketStream
		openConnectionToHostNamed: hostName
		port: 1883.
	sockStrm binary.
	connectPacket _ MQTTPacketConnect new.
	"willTopic: 'weatherstation/mqtttesting'
							message: 'mqtt will testing ok'
							retain: true
							qos: 0"
	connectPacket encodeOn: sockStrm.
	connAckPacket _ MQTTPacket readFrom: sockStrm.
	self assert: [ connAckPacket sessionPresent isKindOf: Boolean ].
	subPacket _ MQTTPacketSubscribe new
		
			addTopic: 'weatherstation/mqtttesting2'
			qos: 0;
		packetID: 242.
	subPacket encodeOn: sockStrm.
	subAckPacket _ MQTTPacket readFrom: sockStrm.
	self assert: [ subAckPacket class = MQTTPacketSubAck ].
	pubPacket _ MQTTPacketPublish new
		topic: 'weatherstation/mqtttesting2'
		message: messageString asByteArray.
	pubPacket encodeOn: sockStrm.
	(Delay forMilliseconds: 2000) wait.
	resultPacket _ MQTTPacket readFrom: sockStrm.
	self assert: [ resultPacket class = MQTTPacketPublish ].
	self assert: [ resultPacket messageString = messageString ].
	disconnectPacket _ MQTTPacketDisconnect new.
	disconnectPacket encodeOn: sockStrm.
	sockStrm close.! !

!(Modules>>#MQTTClientTest>>#MQTTConnectionTests) methodsFor: 'testing' stamp: 'KLG 7/30/2020 20:47:51'!
testSimpleLocalSubscribeAndPublishWithRetain
	"simplest publish/subscribe related test I can think of"
	"try to connect to an mqtt broker.
	send a connect packet
	wait for a connAck packet
	send a publish qos=0 & retain 'weatherstation/mqtttesting' - 'hello subscriber'
	send a subscribe 'weatherstation/mqtttesting'
	wait for a subAck
	read the hopefully retained message that should be sent to us
	send a disconnect"

	| connAckPacket connectPacket disconnectPacket pubPacket sockStrm subPacket messageString resultPacket1 resultPacket2 |
	messageString _ 'hello, subscriber'.
	sockStrm _ SocketStream
		openConnectionToHostNamed: hostName
		port: 1883.
	sockStrm binary.
	connectPacket _ MQTTPacketConnect new.
	"willTopic: 'weatherstation/mqtttesting'
							message: 'mqtt will testing ok'
							retain: true
							qos: 0"
	connectPacket encodeOn: sockStrm.
	connAckPacket _ MQTTPacket readFrom: sockStrm.
	self assert: [ connAckPacket class = MQTTPacketConnAck ].
	self assert: [ connAckPacket sessionPresent isKindOf: Boolean ].
	pubPacket _ MQTTPacketPublish new
		
			topic: 'weatherstation/mqtttesting2'
			message: messageString asByteArray;
		retainFlag: true.
	pubPacket encodeOn: sockStrm.
	subPacket _ MQTTPacketSubscribe new
		
			addTopic: 'weatherstation/mqtttesting2'
			qos: 0;
		packetID: 242.
	subPacket encodeOn: sockStrm.
	"at this piint things can get interesting since the retained message can be sent to us before the SUBACK packet"
	resultPacket1 _ MQTTPacket readFrom: sockStrm.
	resultPacket2 _ MQTTPacket readFrom: sockStrm.
	(resultPacket1 class = MQTTPacketSubAck and: [ resultPacket2 class = MQTTPacketPublish ])
		ifTrue: [ self assert: [ resultPacket2 messageString = messageString ]]
		ifFalse: [
			(resultPacket1 class = MQTTPacketPublish and: [ resultPacket2 class = MQTTPacketSubAck ])
				ifTrue: [ self assert: [ resultPacket1 messageString = messageString ]]
				ifFalse: [ self signalFailure: 'bad class of packet received' ]].
	disconnectPacket _ MQTTPacketDisconnect new.
	disconnectPacket encodeOn: sockStrm.
	sockStrm close.! !

!(Modules>>#MQTTClientTest>>#MQTTConnectionTests) methodsFor: 'running' stamp: 'KLG 7/30/2020 20:48:58'!
setUp
	"Create the test configuration."
	
	super setUp.
	hostName _ '127.0.0.1'  ": Don't trust any '/etc/host/ or DNS."! !

!(Modules>>#MQTTClientTest>>#MQTTPacketTests) methodsFor: 'testing' stamp: 'KLG 7/30/2020 17:38:47'!
testConnAckPacketWriteRead
	"basic check that we can write a CONNACK packet to a stream and read it back"
	| packet1 packet2 writeStream |

	packet1 _ MQTTPacketConnAck new testSessionPresent: false.
	writeStream _ packet1 encodeOn: (WriteStream on: ByteArray new).
	packet2 _ MQTTPacket readFrom: (ReadStream on: writeStream contents) .
	self assert: [ packet1 class = packet2 class ].
	self assert: [ packet1 sessionPresent = packet1 sessionPresent ].
	packet1 testSessionPresent: true.
	writeStream _ packet1 encodeOn: (WriteStream on: ByteArray new).
	packet2 _ MQTTPacket readFrom: (ReadStream on: writeStream contents).
	self assert: [ packet1 class = packet2 class ].
	self assert: [ packet1 sessionPresent = packet1 sessionPresent ].! !

!(Modules>>#MQTTClientTest>>#MQTTPacketTests) methodsFor: 'testing' stamp: 'KLG 7/30/2020 18:08:40'!
testConnectPacketWriteRead
	"basic check that we can write a PUBLISH packet to a stream and read it back"
	| packet1 packet2 message writeStream  |

	message _ 'hello, subscriber'.
	packet1 _ MQTTPacketPublish new
		topic: 'weatherstation/mqtttesting'
		message: message asByteArray.
	writeStream _ packet1 encodeOn: (WriteStream on: ByteArray new).
	packet2 _ MQTTPacket readFrom: (ReadStream on: writeStream contents) readStream.
	self assert: packet1 class equals: packet2 class.
	self assert: message equals: packet2 messageString.! !

!(Modules>>#MQTTClientTest>>#MQTTPacketTests) methodsFor: 'testing' stamp: 'KLG 7/30/2020 17:43:17'!
testPingRespPacketWriteRead
	"basic check that we can write a PINGRESP packet to a stream and read it back"

	| packet1 packet2 writeStream |
	packet1 _ MQTTPacketPingResp new.
	writeStream _ packet1 encodeOn: (WriteStream on: ByteArray new).
	packet2 _ MQTTPacket readFrom: (ReadStream on: writeStream contents).
	self assert: [ packet1 class = packet2 class ].! !

!(Modules>>#MQTTClientTest>>#MQTTPacketTests) methodsFor: 'testing' stamp: 'KLG 7/30/2020 17:58:14'!
testPublishPacketWriteRead
	"basic check that we can write a PUBLISH packet to a stream and read it back"

	| packet1 packet2 message writeStream |
	message _ 'hello, subscriber'.
	packet1 _ MQTTPacketPublish new
		topic: 'weatherstation/mqtttesting'
		message: message asByteArray.
	writeStream _ packet1 encodeOn: (WriteStream on: ByteArray new).
	packet2 _ MQTTPacket readFrom: (ReadStream on: writeStream contents).
	self assert: packet1 class equals: packet2 class.
	self assert: packet2 messageString equals: message.
	
	packet1 _ MQTTPacketPublish new
			topic: 'weatherstation/mqtttesting'
			message: message asByteArray;
		packetID: 1;
		qos: 1.
	writeStream _ packet1 encodeOn: (WriteStream on: ByteArray new).
	packet2 _ MQTTPacket readFrom: (ReadStream on: writeStream contents).
	self assert: packet1 class = packet2 class.
	self assert: packet2 messageString = message.
	
	packet1 _ MQTTPacketPublish new
			topic: 'weatherstation/mqtttesting'
			message: message asByteArray;
		packetID: 2;
		qos: 2.
	writeStream _ packet1 encodeOn: (WriteStream on: ByteArray new).
	packet2 _ MQTTPacket readFrom: (ReadStream on: writeStream contents).
	self assert: packet1 class = packet2 class.
	self assert: packet2 messageString = message.! !
