'From Haver 6.0 [latest update: #5096] on 6 April 2022 at 12:59:41 pm'!
'Description I contain a TCP/SMTP forwarder that slows down responses for unknown hosts.'!
!provides: 'SlowForward' 1 70!
!requires: 'Network-Kernel' 1 5 nil!
!requires: 'Tracing' 1 9 nil!
!requires: 'PersistentObjectCollection' 1 12 nil!
SystemOrganization addCategory: 'SlowForward'!


!moduleCreation: SlowForward!
Modules newEnvironment: #SlowForward!

!interfacesOf: SlowForward!
Modules environment: #SlowForward ::
	interface: #UTI aliasFor: #API ::
	interface: #SPI aliasFor: #API!

!importsOf: SlowForward!
Modules environment: #SlowForward :: 
	import: #API of: Modules>>#Tracing!

!classDefinition: (Modules>>#SlowForward>>#ReputationStore) category: 'SlowForward'!
(Modules>>#PersistentObjectCollection>>#AbstractConcurrentPersistentSingletonCollection) subclass: #ReputationStore
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlowForward'
	inModule: #SlowForward!
!classDefinition: (Modules>>#SlowForward>>#ReputationStore) class category: 'SlowForward'!
(Modules>>#SlowForward>>#ReputationStore) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#SlowForward>>#AbstractClientDesignation) category: 'SlowForward'!
Object subclass: #AbstractClientDesignation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlowForward'
	inModule: #SlowForward!
!classDefinition: (Modules>>#SlowForward>>#AbstractClientDesignation) class category: 'SlowForward'!
(Modules>>#SlowForward>>#AbstractClientDesignation) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#SlowForward>>#SimpleSMTPClientDesignation) category: 'SlowForward'!
(Modules>>#SlowForward>>#AbstractClientDesignation) subclass: #SimpleSMTPClientDesignation
	instanceVariableNames: 'address'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlowForward'
	inModule: #SlowForward!
!classDefinition: (Modules>>#SlowForward>>#SimpleSMTPClientDesignation) class category: 'SlowForward'!
(Modules>>#SlowForward>>#SimpleSMTPClientDesignation) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#SlowForward>>#AbstractCommunicationItem) category: 'SlowForward'!
Object subclass: #AbstractCommunicationItem
	instanceVariableNames: 'data'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlowForward'
	inModule: #SlowForward!
!classDefinition: (Modules>>#SlowForward>>#AbstractCommunicationItem) class category: 'SlowForward'!
(Modules>>#SlowForward>>#AbstractCommunicationItem) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#SlowForward>>#AbstractSMTPCommunicationItem) category: 'SlowForward'!
(Modules>>#SlowForward>>#AbstractCommunicationItem) subclass: #AbstractSMTPCommunicationItem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlowForward'
	inModule: #SlowForward!
!classDefinition: (Modules>>#SlowForward>>#AbstractSMTPCommunicationItem) class category: 'SlowForward'!
(Modules>>#SlowForward>>#AbstractSMTPCommunicationItem) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#SlowForward>>#SMTPData) category: 'SlowForward'!
(Modules>>#SlowForward>>#AbstractSMTPCommunicationItem) subclass: #SMTPData
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlowForward'
	inModule: #SlowForward!
!classDefinition: (Modules>>#SlowForward>>#SMTPData) class category: 'SlowForward'!
(Modules>>#SlowForward>>#SMTPData) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#SlowForward>>#SMTPRequest) category: 'SlowForward'!
(Modules>>#SlowForward>>#AbstractSMTPCommunicationItem) subclass: #SMTPRequest
	instanceVariableNames: 'keyword'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlowForward'
	inModule: #SlowForward!
!classDefinition: (Modules>>#SlowForward>>#SMTPRequest) class category: 'SlowForward'!
(Modules>>#SlowForward>>#SMTPRequest) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#SlowForward>>#SMTPResponse) category: 'SlowForward'!
(Modules>>#SlowForward>>#AbstractSMTPCommunicationItem) subclass: #SMTPResponse
	instanceVariableNames: 'code'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlowForward'
	inModule: #SlowForward!
!classDefinition: (Modules>>#SlowForward>>#SMTPResponse) class category: 'SlowForward'!
(Modules>>#SlowForward>>#SMTPResponse) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#SlowForward>>#AbstractForwarderConfiguration) category: 'SlowForward'!
Object subclass: #AbstractForwarderConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlowForward'
	inModule: #SlowForward!
!classDefinition: (Modules>>#SlowForward>>#AbstractForwarderConfiguration) class category: 'SlowForward'!
(Modules>>#SlowForward>>#AbstractForwarderConfiguration) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#SlowForward>>#ForwarderConfiguration) category: 'SlowForward'!
(Modules>>#SlowForward>>#AbstractForwarderConfiguration) subclass: #ForwarderConfiguration
	instanceVariableNames: 'listenEndpoints targetEndpoints'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlowForward'
	inModule: #SlowForward!
!classDefinition: (Modules>>#SlowForward>>#ForwarderConfiguration) class category: 'SlowForward'!
(Modules>>#SlowForward>>#ForwarderConfiguration) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#SlowForward>>#PortWiseForwarderConfiguration) category: 'SlowForward'!
(Modules>>#SlowForward>>#AbstractForwarderConfiguration) subclass: #PortWiseForwarderConfiguration
	instanceVariableNames: 'configurationByPort isTestConfiguration isDevelopmentConfiguration'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlowForward'
	inModule: #SlowForward!
!classDefinition: (Modules>>#SlowForward>>#PortWiseForwarderConfiguration) class category: 'SlowForward'!
(Modules>>#SlowForward>>#PortWiseForwarderConfiguration) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#SlowForward>>#AbstractProtocolMatcher) category: 'SlowForward'!
Object subclass: #AbstractProtocolMatcher
	instanceVariableNames: ''
	classVariableNames: 'MatcherNamesToClasses'
	poolDictionaries: ''
	category: 'SlowForward'
	inModule: #SlowForward!
!classDefinition: (Modules>>#SlowForward>>#AbstractProtocolMatcher) class category: 'SlowForward'!
(Modules>>#SlowForward>>#AbstractProtocolMatcher) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#SlowForward>>#AbstractItemSequenceMatcher) category: 'SlowForward'!
(Modules>>#SlowForward>>#AbstractProtocolMatcher) subclass: #AbstractItemSequenceMatcher
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlowForward'
	inModule: #SlowForward!
!classDefinition: (Modules>>#SlowForward>>#AbstractItemSequenceMatcher) class category: 'SlowForward'!
(Modules>>#SlowForward>>#AbstractItemSequenceMatcher) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#SlowForward>>#MultipleSucessfullRcptMatcher) category: 'SlowForward'!
(Modules>>#SlowForward>>#AbstractItemSequenceMatcher) subclass: #MultipleSucessfullRcptMatcher
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlowForward'
	inModule: #SlowForward!
!classDefinition: (Modules>>#SlowForward>>#MultipleSucessfullRcptMatcher) class category: 'SlowForward'!
(Modules>>#SlowForward>>#MultipleSucessfullRcptMatcher) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#SlowForward>>#NotDotMatcher) category: 'SlowForward'!
(Modules>>#SlowForward>>#AbstractItemSequenceMatcher) subclass: #NotDotMatcher
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlowForward'
	inModule: #SlowForward!
!classDefinition: (Modules>>#SlowForward>>#NotDotMatcher) class category: 'SlowForward'!
(Modules>>#SlowForward>>#NotDotMatcher) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#SlowForward>>#RepeatedResponseMatcher) category: 'SlowForward'!
(Modules>>#SlowForward>>#AbstractItemSequenceMatcher) subclass: #RepeatedResponseMatcher
	instanceVariableNames: 'responseCode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlowForward'
	inModule: #SlowForward!
!classDefinition: (Modules>>#SlowForward>>#RepeatedResponseMatcher) class category: 'SlowForward'!
(Modules>>#SlowForward>>#RepeatedResponseMatcher) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#SlowForward>>#AbstractSingleItemMatcher) category: 'SlowForward'!
(Modules>>#SlowForward>>#AbstractProtocolMatcher) subclass: #AbstractSingleItemMatcher
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlowForward'
	inModule: #SlowForward!
!classDefinition: (Modules>>#SlowForward>>#AbstractSingleItemMatcher) class category: 'SlowForward'!
(Modules>>#SlowForward>>#AbstractSingleItemMatcher) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#SlowForward>>#SingleCommandMatcher) category: 'SlowForward'!
(Modules>>#SlowForward>>#AbstractSingleItemMatcher) subclass: #SingleCommandMatcher
	instanceVariableNames: 'commandString'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlowForward'
	inModule: #SlowForward!
!classDefinition: (Modules>>#SlowForward>>#SingleCommandMatcher) class category: 'SlowForward'!
(Modules>>#SlowForward>>#SingleCommandMatcher) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#SlowForward>>#SingleResponseMatcher) category: 'SlowForward'!
(Modules>>#SlowForward>>#AbstractSingleItemMatcher) subclass: #SingleResponseMatcher
	instanceVariableNames: 'responseCode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlowForward'
	inModule: #SlowForward!
!classDefinition: (Modules>>#SlowForward>>#SingleResponseMatcher) class category: 'SlowForward'!
(Modules>>#SlowForward>>#SingleResponseMatcher) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#SlowForward>>#AbstractReputation) category: 'SlowForward'!
Object subclass: #AbstractReputation
	instanceVariableNames: 'designation overallSessions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlowForward'
	inModule: #SlowForward!
!classDefinition: (Modules>>#SlowForward>>#AbstractReputation) class category: 'SlowForward'!
(Modules>>#SlowForward>>#AbstractReputation) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#SlowForward>>#AbstractBadReputation) category: 'SlowForward'!
(Modules>>#SlowForward>>#AbstractReputation) subclass: #AbstractBadReputation
	instanceVariableNames: 'invalidReceiverSends otherDomainSends passwordTrials prematureCloses'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlowForward'
	inModule: #SlowForward!
!classDefinition: (Modules>>#SlowForward>>#AbstractBadReputation) class category: 'SlowForward'!
(Modules>>#SlowForward>>#AbstractBadReputation) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#SlowForward>>#EvilReputation) category: 'SlowForward'!
(Modules>>#SlowForward>>#AbstractBadReputation) subclass: #EvilReputation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlowForward'
	inModule: #SlowForward!
!classDefinition: (Modules>>#SlowForward>>#EvilReputation) class category: 'SlowForward'!
(Modules>>#SlowForward>>#EvilReputation) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#SlowForward>>#SpammerReputation) category: 'SlowForward'!
(Modules>>#SlowForward>>#AbstractBadReputation) subclass: #SpammerReputation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlowForward'
	inModule: #SlowForward!
!classDefinition: (Modules>>#SlowForward>>#SpammerReputation) class category: 'SlowForward'!
(Modules>>#SlowForward>>#SpammerReputation) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#SlowForward>>#GoodReputation) category: 'SlowForward'!
(Modules>>#SlowForward>>#AbstractReputation) subclass: #GoodReputation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlowForward'
	inModule: #SlowForward!
!classDefinition: (Modules>>#SlowForward>>#GoodReputation) class category: 'SlowForward'!
(Modules>>#SlowForward>>#GoodReputation) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#SlowForward>>#UnknownReputation) category: 'SlowForward'!
(Modules>>#SlowForward>>#AbstractReputation) subclass: #UnknownReputation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlowForward'
	inModule: #SlowForward!
!classDefinition: (Modules>>#SlowForward>>#UnknownReputation) class category: 'SlowForward'!
(Modules>>#SlowForward>>#UnknownReputation) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#SlowForward>>#AbstractRule) category: 'SlowForward'!
Object subclass: #AbstractRule
	instanceVariableNames: 'referree scoreBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlowForward'
	inModule: #SlowForward!
!classDefinition: (Modules>>#SlowForward>>#AbstractRule) class category: 'SlowForward'!
(Modules>>#SlowForward>>#AbstractRule) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#SlowForward>>#AbstractBinaryRule) category: 'SlowForward'!
(Modules>>#SlowForward>>#AbstractRule) subclass: #AbstractBinaryRule
	instanceVariableNames: 'matches'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlowForward'
	inModule: #SlowForward!
!classDefinition: (Modules>>#SlowForward>>#AbstractBinaryRule) class category: 'SlowForward'!
(Modules>>#SlowForward>>#AbstractBinaryRule) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#SlowForward>>#SimpleProtocolPattern) category: 'SlowForward'!
(Modules>>#SlowForward>>#AbstractBinaryRule) subclass: #SimpleProtocolPattern
	instanceVariableNames: 'benchmark'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlowForward'
	inModule: #SlowForward!
!classDefinition: (Modules>>#SlowForward>>#SimpleProtocolPattern) class category: 'SlowForward'!
(Modules>>#SlowForward>>#SimpleProtocolPattern) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#SlowForward>>#AbstractFuzzyRule) category: 'SlowForward'!
(Modules>>#SlowForward>>#AbstractRule) subclass: #AbstractFuzzyRule
	instanceVariableNames: 'score'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlowForward'
	inModule: #SlowForward!
!classDefinition: (Modules>>#SlowForward>>#AbstractFuzzyRule) class category: 'SlowForward'!
(Modules>>#SlowForward>>#AbstractFuzzyRule) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#SlowForward>>#ForwarderOwned) category: 'SlowForward'!
Object subclass: #ForwarderOwned
	instanceVariableNames: 'forwarder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlowForward'
	inModule: #SlowForward!
!classDefinition: (Modules>>#SlowForward>>#ForwarderOwned) class category: 'SlowForward'!
(Modules>>#SlowForward>>#ForwarderOwned) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#SlowForward>>#AbstractEndPoint) category: 'SlowForward'!
(Modules>>#SlowForward>>#ForwarderOwned) subclass: #AbstractEndPoint
	instanceVariableNames: 'endPoint state guard refereeClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlowForward'
	inModule: #SlowForward!
!classDefinition: (Modules>>#SlowForward>>#AbstractEndPoint) class category: 'SlowForward'!
(Modules>>#SlowForward>>#AbstractEndPoint) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#SlowForward>>#AbstractForwardingConnection) category: 'SlowForward'!
(Modules>>#SlowForward>>#AbstractEndPoint) subclass: #AbstractForwardingConnection
	instanceVariableNames: 'insideSocketStream outsideSocketStream outsideRemoteAddress ingressProcess outgressProcess sendingIn sendingOut referee'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlowForward'
	inModule: #SlowForward!
!classDefinition: (Modules>>#SlowForward>>#AbstractForwardingConnection) class category: 'SlowForward'!
(Modules>>#SlowForward>>#AbstractForwardingConnection) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#SlowForward>>#AbstractSMTPConnection) category: 'SlowForward'!
(Modules>>#SlowForward>>#AbstractForwardingConnection) subclass: #AbstractSMTPConnection
	instanceVariableNames: 'addMoniker'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlowForward'
	inModule: #SlowForward!
!classDefinition: (Modules>>#SlowForward>>#AbstractSMTPConnection) class category: 'SlowForward'!
(Modules>>#SlowForward>>#AbstractSMTPConnection) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#SlowForward>>#SMTPConnection) category: 'SlowForward'!
(Modules>>#SlowForward>>#AbstractSMTPConnection) subclass: #SMTPConnection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlowForward'
	inModule: #SlowForward!
!classDefinition: (Modules>>#SlowForward>>#SMTPConnection) class category: 'SlowForward'!
(Modules>>#SlowForward>>#SMTPConnection) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#SlowForward>>#StutteringSMTPConnection) category: 'SlowForward'!
(Modules>>#SlowForward>>#AbstractSMTPConnection) subclass: #StutteringSMTPConnection
	instanceVariableNames: 'nextOctetDelay clusterCount random'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlowForward'
	inModule: #SlowForward!
!classDefinition: (Modules>>#SlowForward>>#StutteringSMTPConnection) class category: 'SlowForward'!
(Modules>>#SlowForward>>#StutteringSMTPConnection) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#SlowForward>>#ListenEndPoint) category: 'SlowForward'!
(Modules>>#SlowForward>>#AbstractEndPoint) subclass: #ListenEndPoint
	instanceVariableNames: 'listenProcess ingressSocket'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlowForward'
	inModule: #SlowForward!
!classDefinition: (Modules>>#SlowForward>>#ListenEndPoint) class category: 'SlowForward'!
(Modules>>#SlowForward>>#ListenEndPoint) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#SlowForward>>#SMTPEndPoint) category: 'SlowForward'!
(Modules>>#SlowForward>>#ListenEndPoint) subclass: #SMTPEndPoint
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlowForward'
	inModule: #SlowForward!
!classDefinition: (Modules>>#SlowForward>>#SMTPEndPoint) class category: 'SlowForward'!
(Modules>>#SlowForward>>#SMTPEndPoint) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#SlowForward>>#AbstractReferee) category: 'SlowForward'!
(Modules>>#SlowForward>>#ForwarderOwned) subclass: #AbstractReferee
	instanceVariableNames: 'score rules'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlowForward'
	inModule: #SlowForward!
!classDefinition: (Modules>>#SlowForward>>#AbstractReferee) class category: 'SlowForward'!
(Modules>>#SlowForward>>#AbstractReferee) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#SlowForward>>#AbstractSMTPReferee) category: 'SlowForward'!
(Modules>>#SlowForward>>#AbstractReferee) subclass: #AbstractSMTPReferee
	instanceVariableNames: 'communicationItems state'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlowForward'
	inModule: #SlowForward!
!classDefinition: (Modules>>#SlowForward>>#AbstractSMTPReferee) class category: 'SlowForward'!
(Modules>>#SlowForward>>#AbstractSMTPReferee) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#SlowForward>>#SMTPReferee) category: 'SlowForward'!
(Modules>>#SlowForward>>#AbstractSMTPReferee) subclass: #SMTPReferee
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlowForward'
	inModule: #SlowForward!
!classDefinition: (Modules>>#SlowForward>>#SMTPReferee) class category: 'SlowForward'!
(Modules>>#SlowForward>>#SMTPReferee) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#SlowForward>>#SubmissionReferee) category: 'SlowForward'!
(Modules>>#SlowForward>>#AbstractSMTPReferee) subclass: #SubmissionReferee
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlowForward'
	inModule: #SlowForward!
!classDefinition: (Modules>>#SlowForward>>#SubmissionReferee) class category: 'SlowForward'!
(Modules>>#SlowForward>>#SubmissionReferee) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#SlowForward>>#SlowForwarder) category: 'SlowForward'!
Object subclass: #SlowForwarder
	instanceVariableNames: 'configuration unreachableTargetEndpoints forwardingConnections listenEndpoints pumper keepOnRunning pendingActions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlowForward'
	inModule: #SlowForward!
!classDefinition: (Modules>>#SlowForward>>#SlowForwarder) class category: 'SlowForward'!
(Modules>>#SlowForward>>#SlowForwarder) class
	instanceVariableNames: 'forwarderCloseHook'!

!classDefinition: (Modules>>#SlowForward>>#SMTPForwarder) category: 'SlowForward'!
(Modules>>#SlowForward>>#SlowForwarder) subclass: #SMTPForwarder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlowForward'
	inModule: #SlowForward!
!classDefinition: (Modules>>#SlowForward>>#SMTPForwarder) class category: 'SlowForward'!
(Modules>>#SlowForward>>#SMTPForwarder) class
	instanceVariableNames: 'application'!


!(Modules>>#SlowForward>>#ReputationStore) commentStamp: '<historical>' prior: 0!
I am PlanE base store for reputations.

No precaution for synchronisations are taken.!

!(Modules>>#SlowForward>>#AbstractClientDesignation) commentStamp: '<historical>' prior: 0!
I am the abstract superclass of all client designations.

A client designation describes a client mostly for the purpose of reputions.!

!(Modules>>#SlowForward>>#SimpleSMTPClientDesignation) commentStamp: '<historical>' prior: 0!
I am the simplest SMTP client designation.

I designate SMTP and submission clients by their address.!

!(Modules>>#SlowForward>>#AbstractCommunicationItem) commentStamp: '<historical>' prior: 0!
I am the abstract base class of a communication item.

I am used by the referees to store request and response aka command sequences.!

!(Modules>>#SlowForward>>#AbstractSMTPCommunicationItem) commentStamp: '<historical>' prior: 0!
I am the abstract super class of all smtp communication item classes.!

!(Modules>>#SlowForward>>#SMTPData) commentStamp: '<historical>' prior: 0!
I represent an ordinary data item.!

!(Modules>>#SlowForward>>#SMTPRequest) commentStamp: '<historical>' prior: 0!
I am a SMTP request.

The keyword indication the command can be retrieved by sending the #keyword message!

!(Modules>>#SlowForward>>#SMTPResponse) commentStamp: '<historical>' prior: 0!
I am a response to an SMTP request.

My response code can be retreived with the #code message.!

!(Modules>>#SlowForward>>#ForwarderConfiguration) commentStamp: '<historical>' prior: 0!
I am simple configuration for the for a forwarder.

I support non empty sets of listen endpoints and
target endpoints. Each listen endpoint can connect
to any target endpoint.!

!(Modules>>#SlowForward>>#PortWiseForwarderConfiguration) commentStamp: '<historical>' prior: 0!
I am a complex configuration that supports
simple sub-configuration grouped by a (well
known) listen port.!

!(Modules>>#SlowForward>>#AbstractProtocolMatcher) commentStamp: '<historical>' prior: 0!
I am the abstract superclass of all protocol matchers used by SimpleProtocolPattern.

My sybclasses match one request/reply or a sequence of them.!

!(Modules>>#SlowForward>>#AbstractItemSequenceMatcher) commentStamp: '<historical>' prior: 0!
I am the abstract base class of all multiple item matchers.!

!(Modules>>#SlowForward>>#MultipleSucessfullRcptMatcher) commentStamp: '<historical>' prior: 0!
I match a non empty squeance of sucessful recipient commands.!

!(Modules>>#SlowForward>>#NotDotMatcher) commentStamp: '<historical>' prior: 0!
I match an arbitrary line, that does not consist of a single dot.!

!(Modules>>#SlowForward>>#RepeatedResponseMatcher) commentStamp: '<historical>' prior: 0!
I match a non empty sequence of responses.!

!(Modules>>#SlowForward>>#AbstractSingleItemMatcher) commentStamp: '<historical>' prior: 0!
I am the superclass of all single item matchers.!

!(Modules>>#SlowForward>>#SingleCommandMatcher) commentStamp: '<historical>' prior: 0!
I match a single mail command.!

!(Modules>>#SlowForward>>#SingleResponseMatcher) commentStamp: '<historical>' prior: 0!
I match a single response by its code!

!(Modules>>#SlowForward>>#AbstractReputation) commentStamp: '<historical>' prior: 0!
I am the abstract super class of all reputations.

Reputations describe the reputation of a client.!

!(Modules>>#SlowForward>>#AbstractBadReputation) commentStamp: '<historical>' prior: 0!
I am the abstract base class of all bad reputations.!

!(Modules>>#SlowForward>>#EvilReputation) commentStamp: '<historical>' prior: 0!
I describe a client we cuaght doing evil things.!

!(Modules>>#SlowForward>>#SpammerReputation) commentStamp: '<historical>' prior: 0!
I describe a client that has the reputation of a spammer.!

!(Modules>>#SlowForward>>#GoodReputation) commentStamp: '<historical>' prior: 0!
I describe clients that are in good reputation.!

!(Modules>>#SlowForward>>#UnknownReputation) commentStamp: '<historical>' prior: 0!
I describe clients that have unkown reputation.!

!(Modules>>#SlowForward>>#AbstractRule) commentStamp: '<historical>' prior: 0!
I am the abstract superclass of rules.

Rules are owned by a referee.
The decide how well a client's behavior matches just onc simple aspect.
They feature a score between 0 and 100.
The score may be nil, in this case there was not enough
data to dice whether the rule did match.!

!(Modules>>#SlowForward>>#AbstractBinaryRule) commentStamp: '<historical>' prior: 0!
I am a rule that either matches completely (score = 100) or not all (score = 0).!

!(Modules>>#SlowForward>>#SimpleProtocolPattern) commentStamp: '<historical>' prior: 0!
I am a simple command pattern that contains an array of symbols and responses in benchmark.!

!(Modules>>#SlowForward>>#AbstractFuzzyRule) commentStamp: '<historical>' prior: 0!
I am the abstract superclass of a rule that has a real numeric score.!

!(Modules>>#SlowForward>>#AbstractEndPoint) commentStamp: '<historical>' prior: 0!
I am the abstract superclass of all end points.!

!(Modules>>#SlowForward>>#AbstractForwardingConnection) commentStamp: '<historical>' prior: 0!
I am the abstract superclass of all forwadring connections.!

!(Modules>>#SlowForward>>#AbstractSMTPConnection) commentStamp: '<historical>' prior: 0!
I am the abstract superclass of all SMTP forwarding connections.!

!(Modules>>#SlowForward>>#SMTPConnection) commentStamp: '<historical>' prior: 0!
I am an ordinary SMTP connection.!

!(Modules>>#SlowForward>>#StutteringSMTPConnection) commentStamp: '<historical>' prior: 0!
I am an SMTP connection that stutters.!

!(Modules>>#SlowForward>>#ListenEndPoint) commentStamp: '<historical>' prior: 0!
I am an listen endpoint.!

!(Modules>>#SlowForward>>#SMTPEndPoint) commentStamp: '<historical>' prior: 0!
I am a SMTP endpoint.!

!(Modules>>#SlowForward>>#AbstractReferee) commentStamp: '<historical>' prior: 0!
I am the abstract super class of referees, that judge the behavior of clients.!

!(Modules>>#SlowForward>>#AbstractSMTPReferee) commentStamp: '<historical>' prior: 0!
I am the abstract super class of referees, that judge the behavior of SMTP clients.!

!(Modules>>#SlowForward>>#SMTPReferee) commentStamp: '<historical>' prior: 0!
I am the referee for SMTP connections.!

!(Modules>>#SlowForward>>#SubmissionReferee) commentStamp: '<historical>' prior: 0!
I am the referee for submission connections.!

!(Modules>>#SlowForward>>#SlowForwarder) commentStamp: '<historical>' prior: 0!
I am a forwarder for tcp connections.!

!(Modules>>#SlowForward>>#SimpleSMTPClientDesignation) methodsFor: 'printing' stamp: 'KLG 2/22/2022 11:32:28'!
printOn: aStream
	"Print me on aStream."
	
	aStream nextPutAll: 'SMTPClient @ '.
	address do: [ :byte | byte printOn: aStream ] separatedBy: [ aStream nextPut: $. ]! !

!(Modules>>#SlowForward>>#SMTPData) methodsFor: 'printing' stamp: 'KLG 12/4/2021 21:09:56'!
printOn: aStream
	"Print me on aStream."

	| printSize |
	printSize _ 25.
	aStream 
		nextPutAll: self class name;
		nextPut: $(;
		nextPutAll: (data copyFrom: 1 to: (data size min: printSize));
		nextPutAll: ' ...' when: (data size > printSize);
		nextPut: $)	! !

!(Modules>>#SlowForward>>#SMTPRequest) methodsFor: 'printing' stamp: 'KLG 12/4/2021 20:55:20'!
printOn: aStream
	"Print me on aStream."

	aStream 
		nextPutAll: self class name;
		nextPut: $(.
	self keyword printOn: aStream.
	aStream nextPut: $)	! !

!(Modules>>#SlowForward>>#SMTPResponse) methodsFor: 'printing' stamp: 'KLG 12/4/2021 20:56:24'!
printOn: aStream
	"Print me on aStream."

	aStream 
		nextPutAll: self class name;
		nextPut: $(.
	self code printOn: aStream.
	aStream nextPut: $)	! !

!(Modules>>#SlowForward>>#NotDotMatcher) methodsFor: 'printing' stamp: 'KLG 12/4/2021 17:26:24'!
printOn: aStream
	"Print me on aStream.'"

	aStream nextPutAll: 'NotDot ...'! !

!(Modules>>#SlowForward>>#RepeatedResponseMatcher) methodsFor: 'printing' stamp: 'KLG 12/4/2021 17:28:52'!
printOn: aStream
	"Print me on aStream.'"

	aStream nextPutAll: '<-- ('.
	responseCode printOn: aStream.
	aStream nextPutAll: ' ...)'
! !

!(Modules>>#SlowForward>>#SingleCommandMatcher) methodsFor: 'printing' stamp: 'KLG 12/4/2021 17:32:39'!
printOn: aStream
	"Print me on aStream.'"

	commandString printOn: aStream.
	aStream nextPutAll: ' -->'
! !

!(Modules>>#SlowForward>>#SingleResponseMatcher) methodsFor: 'printing' stamp: 'KLG 12/4/2021 17:32:55'!
printOn: aStream
	"Print me on aStream.'"

	aStream nextPutAll: '<-- '.
	responseCode printOn: aStream
! !

!(Modules>>#SlowForward>>#AbstractReputation) methodsFor: 'printing' stamp: 'KLG 2/22/2022 11:40:40'!
printOn: aStream
	"Print me on aStream."

	aStream
		nextPutAll: self class name;
		nextPut: $[.
	designation printOn: aStream.
	aStream nextPutAll: ', '.
	self printDataOn: aStream.
	aStream nextPut: $]! !

!(Modules>>#SlowForward>>#SlowForwarder) class methodsFor: 'class initialization' stamp: 'KLG 1/31/2022 12:31:56'!
initClassCachedState
	"Create the global tracer."

	self class environment
		at: #Tracer
		ifPresent: [ :tracer | tracer ensureOpen ]
		ifAbsent: [ self installTracer: false ]! !

!(Modules>>#SlowForward>>#ReputationStore) methodsFor: 'accessing' stamp: 'KLG 12/17/2021 18:10:22'!
elements
	"Answer the reputations."
	
	^ elements values! !

!(Modules>>#SlowForward>>#ReputationStore) class methodsFor: 'instance creation' stamp: 'KLG 12/16/2021 22:23:52'!
baseCollectionClass
	"Answer the base collection class.
	
	May be overidden in subclasses."

	^ Dictionary! !

!(Modules>>#SlowForward>>#ReputationStore) class methodsFor: 'persistence' stamp: 'KLG 12/17/2021 15:19:09'!
storeFilename
	"Answer the filename of the store."

	^ 'SlowForwarderReputations.planE'! !

!(Modules>>#SlowForward>>#SimpleSMTPClientDesignation) methodsFor: 'accessing' stamp: 'KLG 12/3/2021 14:17:49'!
address
	"Answer the value of address"

	^ address! !

!(Modules>>#SlowForward>>#SimpleSMTPClientDesignation) methodsFor: 'accessing' stamp: 'KLG 12/3/2021 14:17:49'!
address: anObject
	"Set the value of address"

	address _ anObject! !

!(Modules>>#SlowForward>>#SimpleSMTPClientDesignation) class methodsFor: 'instance creation' stamp: 'KLG 12/3/2021 14:13:27'!
forAddress: anAddress
	"Answer a client designation for anAddress."

	^ self new address: anAddress; yourself! !

!(Modules>>#SlowForward>>#AbstractCommunicationItem) methodsFor: 'accessing' stamp: 'KLG 11/27/2021 13:23:48'!
data
	"Answer the value of data"

	^ data! !

!(Modules>>#SlowForward>>#AbstractCommunicationItem) methodsFor: 'accessing' stamp: 'KLG 11/27/2021 13:23:48'!
data: anObject
	"Set the value of data"

	data _ anObject! !

!(Modules>>#SlowForward>>#AbstractCommunicationItem) class methodsFor: 'instance creation' stamp: 'KLG 11/27/2021 13:25:47'!
forData: someData
	"Create a command for some data."

	^ self new data: someData; yourself! !

!(Modules>>#SlowForward>>#AbstractSMTPCommunicationItem) methodsFor: 'accessing' stamp: 'KLG 12/4/2021 20:49:13'!
code
	"Answer nil, I do not have a code code."
	
	^ nil! !

!(Modules>>#SlowForward>>#AbstractSMTPCommunicationItem) methodsFor: 'accessing' stamp: 'KLG 12/4/2021 20:48:52'!
keyword
	"I don't have keywords answer nil."
	
	^ nil! !

!(Modules>>#SlowForward>>#SMTPRequest) methodsFor: 'accessing' stamp: 'KLG 11/27/2021 13:32:05'!
keyword
	"Answer the value of keyword"

	^ keyword ifNil: [
		keyword _ data copyUpTo: `Character space` ]! !

!(Modules>>#SlowForward>>#SMTPRequest) methodsFor: 'accessing' stamp: 'KLG 11/27/2021 13:23:36'!
keyword: anObject
	"Set the value of keyword"

	keyword _ anObject! !

!(Modules>>#SlowForward>>#SMTPResponse) methodsFor: 'accessing' stamp: 'KLG 11/27/2021 13:34:59'!
code
	"Answer the value of code"

	^ code ifNil: [		code _ data asNumber ]! !

!(Modules>>#SlowForward>>#SMTPResponse) methodsFor: 'accessing' stamp: 'KLG 11/27/2021 13:24:02'!
code: anObject
	"Set the value of code"

	code _ anObject! !

!(Modules>>#SlowForward>>#AbstractForwarderConfiguration) methodsFor: 'accessing' stamp: 'KLG 2/21/2022 14:50:24'!
isDevelopmentConfiguration
	"Answer true if we are a development configuration."

	^ false! !

!(Modules>>#SlowForward>>#AbstractForwarderConfiguration) methodsFor: 'accessing' stamp: 'KLG 2/21/2022 14:50:43'!
isTestConfiguration
	"Answer true if we are a test configuration."

	^ true! !

!(Modules>>#SlowForward>>#AbstractForwarderConfiguration) methodsFor: 'accessing' stamp: 'KLG 1/18/2022 14:48:25'!
listenEndpoints
	"Answer the listenEndpoints"

	^ self subclassResponsibility! !

!(Modules>>#SlowForward>>#AbstractForwarderConfiguration) methodsFor: 'accessing' stamp: 'KLG 12/30/2021 13:50:01'!
targetEndpointsByListenPort: aPortNumber
	"Answer the set of target enpoints by port number."

	^ self subclassResponsibility! !

!(Modules>>#SlowForward>>#ForwarderConfiguration) methodsFor: 'accessing' stamp: 'KLG 10/28/2021 13:18:30'!
listenEndpoints
	"Answer the value of listenEndpoints"

	^ listenEndpoints! !

!(Modules>>#SlowForward>>#ForwarderConfiguration) methodsFor: 'accessing' stamp: 'KLG 10/28/2021 13:18:30'!
listenEndpoints: anObject
	"Set the value of listenEndpoints"

	listenEndpoints _ anObject! !

!(Modules>>#SlowForward>>#ForwarderConfiguration) methodsFor: 'accessing' stamp: 'KLG 10/28/2021 13:18:30'!
targetEndpoints
	"Answer the value of targetEndpoints"

	^ targetEndpoints! !

!(Modules>>#SlowForward>>#ForwarderConfiguration) methodsFor: 'accessing' stamp: 'KLG 10/28/2021 13:18:30'!
targetEndpoints: anObject
	"Set the value of targetEndpoints"

	targetEndpoints _ anObject! !

!(Modules>>#SlowForward>>#ForwarderConfiguration) methodsFor: 'accessing' stamp: 'KLG 12/30/2021 13:50:01'!
targetEndpointsByListenPort: aPortNumber
	"Answer the set of target enpoints by port number."

	^ self targetEndpoints! !

!(Modules>>#SlowForward>>#ForwarderConfiguration) class methodsFor: 'instance creation' stamp: 'KLG 1/18/2022 14:40:33'!
defaultConfiguration
	"Answer the default configuration."
	
	^ self defaultSMTPConfiguration! !

!(Modules>>#SlowForward>>#ForwarderConfiguration) class methodsFor: 'instance creation' stamp: 'KLG 1/18/2022 14:39:06'!
defaultSMTPConfiguration
	"Answer the default SMTP-configuration."
	
	^ self new
		targetEndpoints: (Set with: #(#[192 168 43 33] 25) with: #(#[192 168 43 35] 25));
		listenEndpoints: (Set with: {#[0 0 0 0]. 25. SMTPReferee });
		yourself! !

!(Modules>>#SlowForward>>#ForwarderConfiguration) class methodsFor: 'instance creation' stamp: 'KLG 1/19/2022 12:10:57'!
defaultSubmissionConfiguration
	"Answer the default Submission-configuration."
	
	^ self new
		targetEndpoints: (Set with: #(#[192 168 43 33] 587) with: #(#[192 168 43 35] 587));
		listenEndpoints: (Set with: {#[0 0 0 0]. 587. SubmissionReferee });
		yourself! !

!(Modules>>#SlowForward>>#ForwarderConfiguration) class methodsFor: 'instance creation' stamp: 'KLG 12/29/2021 20:32:29'!
developmentConfiguration
	"Answer the devleopment configuration."
	
	^ self new
		targetEndpoints: (Set with: #(#[127 0 0 1] 20025));
		listenEndpoints: (Set with: {#[127 0 0 1]. 10025. SMTPReferee });
		yourself! !

!(Modules>>#SlowForward>>#ForwarderConfiguration) class methodsFor: 'instance creation' stamp: 'KLG 1/18/2022 14:38:33'!
developmentSMTPConfiguration
	"Answer the devleopment SMTP-configuration."
	
	^ self new
		targetEndpoints: (Set with: #(#[127 0 0 1] 20025));
		listenEndpoints: (Set with: {#[127 0 0 1]. 10025. SMTPReferee });
		yourself! !

!(Modules>>#SlowForward>>#ForwarderConfiguration) class methodsFor: 'instance creation' stamp: 'KLG 1/18/2022 14:41:15'!
developmentSubmissionConfiguration
	"Answer the devleopment Submission-configuration."
	
	^ self new
		targetEndpoints: (Set with: #(#[127 0 0 1] 20587));
		listenEndpoints: (Set with: {#[127 0 0 1]. 10587. SubmissionReferee });
		yourself! !

!(Modules>>#SlowForward>>#ForwarderConfiguration) class methodsFor: 'instance creation' stamp: 'KLG 1/19/2022 12:22:07'!
liveTestSMTPConfiguration
	"Answer the live test SMTP-configuration."
	
	^ self new
		targetEndpoints: (Set with: #(#[192 168 43 33] 20025) with: #(#[192 168 43 35] 20025));
		listenEndpoints: (Set with: {#[0 0 0 0]. 25. SMTPReferee });
		yourself! !

!(Modules>>#SlowForward>>#ForwarderConfiguration) class methodsFor: 'instance creation' stamp: 'KLG 1/19/2022 12:21:50'!
liveTestSubmissionConfiguration
	"Answer the live-test Submission-configuration."
	
	^ self new
		targetEndpoints: (Set with: #(#[192 168 43 33] 20025) with: #(#[192 168 43 35] 20025));
		listenEndpoints: (Set with: {#[0 0 0 0]. 587. SubmissionReferee });
		yourself! !

!(Modules>>#SlowForward>>#ForwarderConfiguration) class methodsFor: 'instance creation' stamp: 'KLG 12/29/2021 20:32:40'!
remoteDevelopmentConfiguration
	"Answer the devleopment configuration for remote SMTP server
	
	Remote means an a different machine."
	
	^ self new
		targetEndpoints: (Set with: #(#[192 168 43 22] 10025));
		listenEndpoints: (Set with: {#[127 0 0 1]. 10025. SMTPReferee });
		yourself! !

!(Modules>>#SlowForward>>#ForwarderConfiguration) class methodsFor: 'instance creation' stamp: 'KLG 12/29/2021 20:32:51'!
testConfiguration
	"Answer the test configuration."
	
	^ self new
		targetEndpoints: (Set with: #(#[192 168 43 22] 10025));
		listenEndpoints: (Set with: {#[159 100 249 126]. 25. SMTPReferee });
		yourself! !

!(Modules>>#SlowForward>>#PortWiseForwarderConfiguration) methodsFor: 'initialization' stamp: 'KLG 12/30/2021 13:53:24'!
initialize
	"Initialize the port to configuration mapping."

	super initialize.
	configurationByPort _ Dictionary new! !

!(Modules>>#SlowForward>>#PortWiseForwarderConfiguration) methodsFor: 'accessing' stamp: 'KLG 12/30/2021 13:58:20'!
addConfiguration: aConfiguration
	"Add a configuration."

	| listenPort listenEndpoints |
	listenPort _ (listenEndpoints _ aConfiguration listenEndpoints) anyOne second.
	self assert: (listenEndpoints allSatisfy: [ :endpoint |
		endpoint second = listenPort ]).
	configurationByPort at: listenPort put: aConfiguration! !

!(Modules>>#SlowForward>>#PortWiseForwarderConfiguration) methodsFor: 'accessing' stamp: 'KLG 2/21/2022 14:51:32'!
isDevelopmentConfiguration
	"Answer true if we are a development configuration."

	^ isDevelopmentConfiguration ifNil: [ false ]! !

!(Modules>>#SlowForward>>#PortWiseForwarderConfiguration) methodsFor: 'accessing' stamp: 'KLG 2/21/2022 14:51:44'!
isTestConfiguration
	"Answer true if we are a test configuration."

	^ isTestConfiguration ifNil: [ true ]! !

!(Modules>>#SlowForward>>#PortWiseForwarderConfiguration) methodsFor: 'accessing' stamp: 'KLG 1/18/2022 14:51:26'!
listenEndpoints
	"Answer the listenEndpoints"
	
	| answer |
	answer _ Set new.
	configurationByPort do: [ :configuration |
		configuration listenEndpoints do: [ :endpoint |
			answer add: endpoint ] ].
	^ answer! !

!(Modules>>#SlowForward>>#PortWiseForwarderConfiguration) methodsFor: 'accessing' stamp: 'KLG 2/21/2022 14:52:31'!
tagAsDevelopmentConfiguration
	"Tag this configuration as development configuration."

	self assert: isDevelopmentConfiguration isNil.
	isDevelopmentConfiguration _ true! !

!(Modules>>#SlowForward>>#PortWiseForwarderConfiguration) methodsFor: 'accessing' stamp: 'KLG 2/21/2022 06:45:56'!
tagAsLiveConfiguration
	"Tag this configuration as live configuration."

	self assert: isTestConfiguration isNil.
	isTestConfiguration _ false! !

!(Modules>>#SlowForward>>#PortWiseForwarderConfiguration) methodsFor: 'accessing' stamp: 'KLG 12/30/2021 13:52:11'!
targetEndpointsByListenPort: aPortNumber
	"Answer the set of target enpoints by port number."

	^ configurationByPort at: aPortNumber :: targetEndpointsByListenPort: aPortNumber! !

!(Modules>>#SlowForward>>#PortWiseForwarderConfiguration) class methodsFor: 'instance creation' stamp: 'KLG 2/21/2022 06:46:18'!
defaultConfiguration
	"Answer the default configuration."

	^ self new
		addConfiguration: self simpleConfigurationClass defaultSMTPConfiguration;
		addConfiguration: self simpleConfigurationClass defaultSubmissionConfiguration;
		tagAsLiveConfiguration;
		yourself! !

!(Modules>>#SlowForward>>#PortWiseForwarderConfiguration) class methodsFor: 'instance creation' stamp: 'KLG 2/21/2022 14:53:01'!
developmentConfiguration
	"Answer the development configuration."

	^ self new
		addConfiguration: self simpleConfigurationClass developmentSMTPConfiguration;
		addConfiguration: self simpleConfigurationClass developmentSubmissionConfiguration;
		tagAsDevelopmentConfiguration;
		yourself! !

!(Modules>>#SlowForward>>#PortWiseForwarderConfiguration) class methodsFor: 'instance creation' stamp: 'KLG 1/19/2022 12:15:13'!
liveTestConfiguration
	"Answer the live-test configuration."

	^ self new
		addConfiguration: self simpleConfigurationClass liveTestSMTPConfiguration;
		addConfiguration: self simpleConfigurationClass liveTestSubmissionConfiguration;
		yourself! !

!(Modules>>#SlowForward>>#PortWiseForwarderConfiguration) class methodsFor: 'instance creation' stamp: 'KLG 1/19/2022 12:10:17'!
simpleConfigurationClass

	^ ForwarderConfiguration! !

!(Modules>>#SlowForward>>#AbstractProtocolMatcher) methodsFor: 'evaluating' stamp: 'KLG 12/4/2021 17:52:38'!
match: aStream onMismatch: aMismatchBlock
	"Match me on aStream.
	
	Forward the stream as much items as I match.
	If there is a mismatch evaluate aMismatchBlock."

	self subclassResponsibility! !

!(Modules>>#SlowForward>>#AbstractProtocolMatcher) class methodsFor: 'accessing' stamp: 'KLG 12/7/2021 12:14:58'!
matcherClassAt: aMatcherNare
	"Answer the matche rname for aClassName."

	^ MatcherNamesToClasses at: aMatcherNare! !

!(Modules>>#SlowForward>>#AbstractProtocolMatcher) class methodsFor: 'class initialization' stamp: 'KLG 12/7/2021 12:32:12'!
initialize
	"Initialize the mapping from matcher names to classes."

	MatcherNamesToClasses _ IdentityDictionary newFromPairs: {
		#notDot. NotDotMatcher.
		#multipleRecipients. MultipleSucessfullRcptMatcher }
		! !

!(Modules>>#SlowForward>>#MultipleSucessfullRcptMatcher) methodsFor: 'evaluating' stamp: 'KLG 12/7/2021 12:30:49'!
match: aStream onMismatch: aMismatchBlock
	"Match me on aStream.
	
	Forward the stream as much items as I match.
	If there is a mismatch evaluate aMismatchBlock."

	aStream next keyword = 'rcpt' ifFalse: aMismatchBlock.
	aStream next code = 250 ifFalse: aMismatchBlock.
	[ aStream peek keyword = 'rcpt' ] whileTrue: [
		aStream next.
		aStream next code = 250 ifFalse: aMismatchBlock ]
! !

!(Modules>>#SlowForward>>#NotDotMatcher) methodsFor: 'evaluating' stamp: 'KLG 12/4/2021 22:10:51'!
match: aStream onMismatch: aMismatchBlock
	"Match me on aStream.
	
	Forward the stream as much items as I match.
	If there is a mismatch evaluate aMismatchBlock."

	[ aStream next data = '.' ] whileFalse! !

!(Modules>>#SlowForward>>#RepeatedResponseMatcher) methodsFor: 'accessing' stamp: 'KLG 12/4/2021 11:55:53'!
responseCode
	"Answer the value of responseCode"

	^ responseCode! !

!(Modules>>#SlowForward>>#RepeatedResponseMatcher) methodsFor: 'accessing' stamp: 'KLG 12/4/2021 11:55:53'!
responseCode: anObject
	"Set the value of responseCode"

	responseCode _ anObject! !

!(Modules>>#SlowForward>>#RepeatedResponseMatcher) methodsFor: 'evaluating' stamp: 'KLG 12/4/2021 20:37:46'!
match: aStream onMismatch: aMismatchBlock
	"Match me on aStream.
	
	Forward the stream as much items as I match.
	If there is a mismatch evaluate aMismatchBlock."

	[ aStream peek code = responseCode ] whileTrue: [ aStream skip: 1 ]! !

!(Modules>>#SlowForward>>#RepeatedResponseMatcher) class methodsFor: 'instance creation' stamp: 'KLG 12/4/2021 11:56:48'!
for: aResponseCode
	"Answer an instanc eof mine for aResponseCode."

	^ self new responseCode: aResponseCode; yourself! !

!(Modules>>#SlowForward>>#SingleCommandMatcher) methodsFor: 'accessing' stamp: 'KLG 12/4/2021 11:57:44'!
commandString
	"Answer the value of commandString"

	^ commandString! !

!(Modules>>#SlowForward>>#SingleCommandMatcher) methodsFor: 'accessing' stamp: 'KLG 12/4/2021 11:57:44'!
commandString: anObject
	"Set the value of commandString"

	commandString _ anObject! !

!(Modules>>#SlowForward>>#SingleCommandMatcher) methodsFor: 'evaluating' stamp: 'KLG 12/4/2021 17:57:48'!
match: aStream onMismatch: aMismatchBlock
	"Match me on aStream.
	
	Forward the stream as much items as I match.
	If there is a mismatch evaluate aMismatchBlock."

	aStream next keyword = commandString ifFalse: aMismatchBlock! !

!(Modules>>#SlowForward>>#SingleCommandMatcher) class methodsFor: 'instance creation' stamp: 'KLG 12/4/2021 11:59:10'!
for: aCommandString
	"Answer an instanc eof mine for aCommandString"

	^ self new commandString: aCommandString; yourself! !

!(Modules>>#SlowForward>>#SingleResponseMatcher) methodsFor: 'accessing' stamp: 'KLG 12/4/2021 11:57:29'!
responseCode
	"Answer the value of responseCode"

	^ responseCode! !

!(Modules>>#SlowForward>>#SingleResponseMatcher) methodsFor: 'accessing' stamp: 'KLG 12/4/2021 11:57:29'!
responseCode: anObject
	"Set the value of responseCode"

	responseCode _ anObject! !

!(Modules>>#SlowForward>>#SingleResponseMatcher) methodsFor: 'evaluating' stamp: 'KLG 12/4/2021 17:58:30'!
match: aStream onMismatch: aMismatchBlock
	"Match me on aStream.
	
	Forward the stream as much items as I match.
	If there is a mismatch evaluate aMismatchBlock."

	aStream next code = responseCode ifFalse: aMismatchBlock! !

!(Modules>>#SlowForward>>#SingleResponseMatcher) class methodsFor: 'instance creation' stamp: 'KLG 12/4/2021 11:57:18'!
for: aResponseCode
	"Answer an instanc eof mine for aResponseCode."

	^ self new responseCode: aResponseCode; yourself! !

!(Modules>>#SlowForward>>#AbstractReputation) methodsFor: 'instance creation' stamp: 'KLG 11/26/2021 14:23:48'!
forwarderClass
	"Answer the forwader class."

	^ self class forwarderClass! !

!(Modules>>#SlowForward>>#AbstractReputation) methodsFor: 'accessing' stamp: 'KLG 12/3/2021 14:36:55'!
designation
	"Answer the value of designation"

	^ designation! !

!(Modules>>#SlowForward>>#AbstractReputation) methodsFor: 'accessing' stamp: 'KLG 12/3/2021 14:36:55'!
designation: anObject
	"Set the value of designation"

	designation _ anObject! !

!(Modules>>#SlowForward>>#AbstractReputation) methodsFor: 'accessing' stamp: 'KLG 12/3/2021 14:36:55'!
overallSessions
	"Answer the value of overallSessions"

	^ overallSessions! !

!(Modules>>#SlowForward>>#AbstractReputation) methodsFor: 'accessing' stamp: 'KLG 12/3/2021 14:37:17'!
overallSessions: anObject
	"Set the value of overallSessions"

	self assert: overallSessions isNil.
	overallSessions _ anObject! !

!(Modules>>#SlowForward>>#AbstractReputation) methodsFor: 'private' stamp: 'KLG 2/22/2022 11:41:44'!
printDataOn: aStream
	"Print my scores on aStream."

	overallSessions
		ifNotNil: [
			aStream nextPutAll: 'overall sessions: '.
			overallSessions printOn: aStream ]
		ifNil: [ aStream nextPutAll: 'no sessions' ]
		! !

!(Modules>>#SlowForward>>#AbstractReputation) class methodsFor: 'instance creation' stamp: 'KLG 12/3/2021 14:39:37'!
defaultDesignationClass
	"Answer the default designation class."

	^ SimpleSMTPClientDesignation! !

!(Modules>>#SlowForward>>#AbstractReputation) class methodsFor: 'instance creation' stamp: 'KLG 12/17/2021 15:11:59'!
forAddress: anAddress
	"Create a reputationf for anAddress."

	^ self new 
		designation: (self defaultDesignationClass forAddress: anAddress);
			yourself! !

!(Modules>>#SlowForward>>#AbstractReputation) class methodsFor: 'instance creation' stamp: 'KLG 11/26/2021 14:24:15'!
forwarderClass
	"Answer the forwader class."

	^ StutteringSMTPConnection! !

!(Modules>>#SlowForward>>#AbstractReputation) class methodsFor: 'instance creation' stamp: 'KLG 12/19/2021 23:11:01'!
fromReputation: anOldReputation
	"Create a new reputationf from anOldReputation."

	^ self new 
		designation: anOldReputation designation;
		overallSessions: (anOldReputation overallSessions ifNil: [ 1 ]) + 1;
		yourself! !

!(Modules>>#SlowForward>>#AbstractBadReputation) methodsFor: 'initialization' stamp: 'KLG 11/29/2021 11:59:20'!
initialize
	"Initialize the counts"
	
	super initialize.
	passwordTrials _ 	invalidReceiverSends _ otherDomainSends _ prematureCloses _ 0! !

!(Modules>>#SlowForward>>#GoodReputation) class methodsFor: 'instance creation' stamp: 'KLG 11/26/2021 14:24:34'!
forwarderClass
	"Answer the forwader class."

	^ SMTPConnection! !

!(Modules>>#SlowForward>>#AbstractRule) methodsFor: 'accessing' stamp: 'KLG 12/3/2021 17:07:19'!
referree
	"Answer the value of referree"

	self assert: referree notNil.
	^ referree! !

!(Modules>>#SlowForward>>#AbstractRule) methodsFor: 'accessing' stamp: 'KLG 12/3/2021 17:06:47'!
referree: anObject
	"Set the value of referree"

	self assert: referree isNil.
	referree _ anObject! !

!(Modules>>#SlowForward>>#AbstractRule) methodsFor: 'accessing' stamp: 'KLG 12/3/2021 16:57:00'!
score
	"Answer the rules score."

	^ self subclassResponsibility! !

!(Modules>>#SlowForward>>#AbstractRule) methodsFor: 'accessing' stamp: 'KLG 12/4/2021 20:22:26'!
scoreBlock
	"Answer the value of scoreBlock"

	^ scoreBlock! !

!(Modules>>#SlowForward>>#AbstractRule) methodsFor: 'accessing' stamp: 'KLG 12/4/2021 20:22:26'!
scoreBlock: anObject
	"Set the value of scoreBlock"

	scoreBlock _ anObject! !

!(Modules>>#SlowForward>>#AbstractRule) methodsFor: 'evaluating' stamp: 'KLG 12/3/2021 21:36:33'!
evaluate
	"(Re)Evaluate the rule and answer the score."

	^ self subclassResponsibility! !

!(Modules>>#SlowForward>>#AbstractRule) class methodsFor: 'instance creation' stamp: 'KLG 12/4/2021 20:24:06'!
forReferee: aReferee andScoreBlock: aScoreBlock
	"Answer a new rule for aReferee"

	^ self new
		referree: aReferee;
		scoreBlock: aScoreBlock;
		yourself.! !

!(Modules>>#SlowForward>>#AbstractBinaryRule) methodsFor: 'accessing' stamp: 'KLG 12/3/2021 16:58:47'!
score
	"Answer the rules score."

	^ matches ifNotNil: [ matches ifFalse: [ 0 ] ifTrue: [ 100 ] ] ! !

!(Modules>>#SlowForward>>#SimpleProtocolPattern) methodsFor: 'accessing' stamp: 'KLG 12/3/2021 21:44:57'!
benchmark
	"Answer the value of benchmark"

	^ benchmark! !

!(Modules>>#SlowForward>>#SimpleProtocolPattern) methodsFor: 'accessing' stamp: 'KLG 12/7/2021 12:20:37'!
benchmark: aSequence
	"Set the value of benchmark"

	benchmark _ aSequence collect: [ :item |
		item isInteger
			ifTrue: [ SingleResponseMatcher 	for: item ]
			ifFalse: [ item isSymbol 
				ifTrue: [ AbstractProtocolMatcher matcherClassAt: item :: new ]
				ifFalse: [ item isString
					ifTrue: [ SingleCommandMatcher for: item ]
					ifFalse: [ item isArray and: [ item size = 1 ] :: and: [ item first isInteger ] ::
						ifTrue: [ RepeatedResponseMatcher for: item first ] ] ] ] ]! !

!(Modules>>#SlowForward>>#SimpleProtocolPattern) methodsFor: 'evaluating' stamp: 'KLG 1/31/2022 13:43:46'!
evaluate
	"Evaluate the pattern"

	| stream |
	stream _ referree communicationStream.
	benchmark do: [ :matcher |
		[	matcher match: stream onMismatch: [
				Tracer spy: [ :out |
					out
						newLine;
						show: 'Mismatch at: ';
						show: stream position;
						show: ' (';
						show: stream peek data;
						show: ') with: '.
					matcher printOn: out ].
				matches _ false.
				^ self score ] ]
		on: Error do: [ :exception |
			Tracer trace: [ :out |
				out
					newLine;
					show: 'Exception ';
					show: exception;
					show: ' at ';
					show: stream position;
					show: ' (';
					show: stream peek;
					show: ') when matching with: '.
				matcher printOn: out ].
			matches _ false.
			^ self score ]	 ].
	matches _ true.
	scoreBlock value: self score.
	^ self score! !

!(Modules>>#SlowForward>>#SimpleProtocolPattern) class methodsFor: 'instance creation' stamp: 'KLG 12/4/2021 20:23:39'!
forReferee: aReferee andBenchmark: aPatternSelector andScoreBlock: aScoreBlock 
	"Answer a new instance for aReferee and pattern selected by aPatternSelector"

	^ self forReferee: aReferee andScoreBlock: aScoreBlock :: benchmark: (self perform: aPatternSelector)! !

!(Modules>>#SlowForward>>#SimpleProtocolPattern) class methodsFor: 'benchmarks' stamp: 'KLG 12/4/2021 17:08:46'!
justQuit
	"Answer the just quit pattern."

	^ #(220 'QUIT' 221)! !

!(Modules>>#SlowForward>>#SimpleProtocolPattern) class methodsFor: 'benchmarks' stamp: 'KLG 12/7/2021 11:59:17'!
mailToMultipleRecipients
	"A pattern to recognize mail for multiple recipients."

	^ #(220 'ehlo' (250) 'mail' 250 #multipleRecipients 'data' 354 notDot 250 'QUIT')! !

!(Modules>>#SlowForward>>#SimpleProtocolPattern) class methodsFor: 'benchmarks' stamp: 'KLG 12/4/2021 22:07:35'!
mailToOneRecipient
	"Add all the pattern rules to aCollection."

	^ #(220 'ehlo' (250) 'mail' 250 'rcpt' 250 'data' 354 notDot 250 'QUIT')! !

!(Modules>>#SlowForward>>#SimpleProtocolPattern) class methodsFor: 'benchmarks' stamp: 'KLG 12/7/2021 19:39:59'!
usesSTARTTLS
	"Answer the patern that jus uses STARTTLS"

	^ #(220 'ehlo' (250) 'STARTTLS' 250) "The remainder is encryted and thus missing."! !

!(Modules>>#SlowForward>>#AbstractFuzzyRule) methodsFor: 'accessing' stamp: 'KLG 12/3/2021 17:02:44'!
score
	"Answer the socre."

	^ score! !

!(Modules>>#SlowForward>>#ForwarderOwned) methodsFor: 'accessing' stamp: 'KLG 11/29/2021 11:55:41'!
configuration
	"Access the forwarders configuration."

	^ forwarder configuration! !

!(Modules>>#SlowForward>>#ForwarderOwned) methodsFor: 'accessing' stamp: 'KLG 11/26/2021 14:37:22'!
forwarder
	"Answer the value of forwarder"

	^ forwarder! !

!(Modules>>#SlowForward>>#ForwarderOwned) methodsFor: 'accessing' stamp: 'KLG 11/26/2021 14:37:22'!
forwarder: anObject
	"Set the value of forwarder"

	forwarder _ anObject! !

!(Modules>>#SlowForward>>#ForwarderOwned) class methodsFor: 'instance creation' stamp: 'KLG 12/5/2021 23:23:31'!
forForwarder: aForwarder
	"Answer a new instance of mine for aForwarder."

	^ self new forwarder: aForwarder; yourself! !

!(Modules>>#SlowForward>>#AbstractEndPoint) methodsFor: 'processes' stamp: 'KLG 2/22/2022 21:37:49'!
forwardingPriority
	"Answer the process priority for the tow forwarding processes."

	^ self subclassResponsibility ! !

!(Modules>>#SlowForward>>#AbstractEndPoint) methodsFor: 'processes' stamp: 'KLG 11/6/2021 10:09:55'!
startProcesses
	"Start the necessary processes."

	self subclassResponsibility! !

!(Modules>>#SlowForward>>#AbstractEndPoint) methodsFor: 'processes' stamp: 'KLG 11/6/2021 14:04:40'!
stopProcesses
	"Stop the necessary processes."

	self subclassResponsibility! !

!(Modules>>#SlowForward>>#AbstractEndPoint) methodsFor: 'open/close' stamp: 'KLG 11/5/2021 23:14:22'!
close
	"Close the end point"

	self subclassResponsibility! !

!(Modules>>#SlowForward>>#AbstractEndPoint) methodsFor: 'open/close' stamp: 'KLG 11/26/2021 19:31:42'!
kill
	"Kill the end point by all means"

	self subclassResponsibility! !

!(Modules>>#SlowForward>>#AbstractEndPoint) methodsFor: 'open/close' stamp: 'KLG 11/5/2021 23:14:12'!
open
	"Open the end point"

	self subclassResponsibility! !

!(Modules>>#SlowForward>>#AbstractEndPoint) methodsFor: 'controlling' stamp: 'KLG 11/9/2021 11:56:19'!
whileInState: aState do: aBlock
	"Repeat aBlock as long I am in state aState."

	[ guard critical: [ state == aState ] ] whileTrue: aBlock! !

!(Modules>>#SlowForward>>#AbstractEndPoint) methodsFor: 'controlling' stamp: 'KLG 11/24/2021 14:58:52'!
whileInStates: aStateCollection do: aBlock
	"Repeat aBlock as long I am in state aState."

	[ guard critical: [ aStateCollection identityIncludes: state ] ] whileTrue: aBlock! !

!(Modules>>#SlowForward>>#AbstractEndPoint) methodsFor: 'accessing' stamp: 'KLG 11/6/2021 14:45:22'!
state
	"Answer the state/"

	^ guard critical: [ state ]! !

!(Modules>>#SlowForward>>#AbstractEndPoint) methodsFor: 'accessing' stamp: 'KLG 11/6/2021 14:45:48'!
state: aNewState
	"Set the state the state/"

	^ guard critical: [ state _ aNewState ]! !

!(Modules>>#SlowForward>>#AbstractEndPoint) methodsFor: 'instance creation' stamp: 'KLG 11/5/2021 23:18:28'!
socketClass
	"Answer the socket class."
	
	^ self class socketClass! !

!(Modules>>#SlowForward>>#AbstractEndPoint) methodsFor: 'instance creation' stamp: 'KLG 11/5/2021 23:18:45'!
socketStreamClass
	"Answer the socket stream class."
	
	^ self class socketStreamClass! !

!(Modules>>#SlowForward>>#AbstractEndPoint) methodsFor: 'initialization' stamp: 'KLG 11/6/2021 14:44:30'!
initialize
	"Intialize the state and the guard."

	super initialize.
	guard _ Mutex new.
	state _ #new! !

!(Modules>>#SlowForward>>#AbstractEndPoint) class methodsFor: 'instance creation' stamp: 'KLG 11/5/2021 23:19:02'!
socketClass
	"Answer the socket class."
	
	^ Socket! !

!(Modules>>#SlowForward>>#AbstractEndPoint) class methodsFor: 'instance creation' stamp: 'KLG 11/5/2021 23:19:30'!
socketStreamClass
	"Answer the socket stream class."
	
	^ SocketStream! !

!(Modules>>#SlowForward>>#AbstractForwardingConnection) methodsFor: 'processes' stamp: 'KLG 2/22/2022 21:51:20'!
forwardingPriority
	"Answer the process priority for the tow forwarding processes."

	^ `40 - 9`! !

!(Modules>>#SlowForward>>#AbstractForwardingConnection) methodsFor: 'processes' stamp: 'KLG 2/21/2022 13:59:39'!
ingressForwardingStates
	"Answer the forwarding states."

	^ #(forwarding forwardingSTARTTLSRequested forwardingSTARTTLS insideClosed)! !

!(Modules>>#SlowForward>>#AbstractForwardingConnection) methodsFor: 'processes' stamp: 'KLG 4/4/2022 13:46:54'!
ingressLoop
	"I forward the ingress traffic."

	self whileInStates: self ingressForwardingStates do: [
		[ self sendIngressChunkHandlingState: self receiveIngressChunk ]
			on: Error
			do: [ :error |
				Tracer trace: [ :out |
					out
						show: Processor activeProcess name;
						space;
						newLine;
						show: 'Error in in ingress loop: ';
						show: error;
						newLine;
						show: 'Will kill socket streams and terminate'.
					Tracer flush ].
				forwarder inDevelopmentMode
					ifTrue: [
						Processor activeProcess
							debug: error signalerContext
							title: error description ]
					ifFalse: [
						Smalltalk
							logError: error description
							inContext: error signalerContext
							to: 'SlowForwarderIngressLoop' ].
				"Avoid guard and thus deadlocks."
				state _ #dead.
				self killStreams.
				forwarder removeForwardingConnection: self ].
		self updateState ].
	Tracer trace: [ :out |
		out
			newLine;
			show: Processor activeProcess name;
			show: ': ';
			show: 'ingress loop terminating'.
		Tracer flush ]! !

!(Modules>>#SlowForward>>#AbstractForwardingConnection) methodsFor: 'processes' stamp: 'KLG 12/6/2021 13:36:25'!
outgressForwardingStates
	"Answer the outgress forwarding states."

	^ #(forwarding forwardingSTARTTLSRequested forwardingSTARTTLS outsideClosed)! !

!(Modules>>#SlowForward>>#AbstractForwardingConnection) methodsFor: 'processes' stamp: 'KLG 4/4/2022 13:41:12'!
outgressLoop
	"I forward the outgress traffic."

	self whileInStates: self outgressForwardingStates do: [
		[ self sendOutgressChunkHandlingState: self receiveOutgressChunk ] 
			on: Error
			do: [ :error |
				Tracer trace: [ :out |
					out
						show: Processor activeProcess name;
						space;
						newLine;
						show: 'Error in in outgress loop: ';
						show: error;
						newLine;
						show: 'Will kill socket streams and terminate';
						flush ].
					forwarder inDevelopmentMode
						ifTrue: [
							Processor activeProcess
								debug: error signalerContext
								title: error description ]
						ifFalse: [
							Smalltalk
								logError: error description
								inContext: error signalerContext
								to: 'SlowForwarderOutgressLoop' ].
					"Avoid guard and thus deadlocks."
					state _ #dead.
					self killStreams.
					forwarder removeForwardingConnection: self ].
		self updateState ].
	Tracer trace: [ :out |
		out
			newLine;
			show: Processor activeProcess name;
			show: ': ';
			show: 'outgress loop terminating'.
		Tracer flush ]! !

!(Modules>>#SlowForward>>#AbstractForwardingConnection) methodsFor: 'processes' stamp: 'KLG 2/22/2022 21:33:46'!
startProcesses
	"Start the necessary processes."

	| namer |
	namer _ [ :arrow |
		String streamContents: [ :stream |
			stream nextPutAll: '[sf] '.
			outsideSocketStream socket remoteAddress printOn: stream.
			stream nextPut: $:.
			outsideSocketStream socket remotePort printOn: stream.
			stream
				nextPut: `Character space`;
				nextPutAll: arrow;
				nextPut: `Character space`.
			endPoint first printOn: stream.
			stream nextPut: $:.
			endPoint second printOn: stream ] ].
	(ingressProcess _ [ self ingressLoop ] newProcess)
		priority: self forwardingPriority;
		name: (namer value: '=->').
	(outgressProcess _ [ self outgressLoop ] newProcess)
		priority: self forwardingPriority;
		name: (namer value: '<-=').
	outgressProcess resume.
	ingressProcess resume! !

!(Modules>>#SlowForward>>#AbstractForwardingConnection) methodsFor: 'processes' stamp: 'KLG 11/18/2021 19:50:54'!
stopProcesses

	ingressProcess terminate.
	outgressProcess terminate.
	ingressProcess _ outgressProcess _ nil! !

!(Modules>>#SlowForward>>#AbstractForwardingConnection) methodsFor: 'processes' stamp: 'KLG 4/6/2022 12:52:34'!
updateState
	"Update the forwarders state wrt. the state of the socket streams."

	guard critical: [
		state == #dead ifTrue: [ ^ self ].
		outsideSocketStream isConnected ifFalse: [
			state caseOf: {
				[ #forwarding ] -> [ state _ #outsideClosed ].
				[ #forwardingSTARTTLS ] -> [ state _ #outsideClosed ].
				[ #forwardingSTARTTLSRequested ] -> [ state _ #outsideClosed ].
				[ #insideClosed ] -> [ state _ #closed ].
				[ #outsideClosed ] -> [].
				[ #closed ] -> [].
				[ #rejecting ] -> [ state _ #rejectingDone ].
				[ #rejectingDone ] -> [] } ].
		insideSocketStream 
			ifNil: [ self assert: (state == #rejecting or: [ state == #rejectingDone ]) ]
			ifNotNil: [
				insideSocketStream isConnected ifFalse: [
					state caseOf: {
						[ #forwarding ] -> [ state _ #insideClosed ].
						[ #forwardingSTARTTLS ] -> [ state _ #insideClosed ].
						[ #forwardingSTARTTLSRequested ] -> [ state _ #insideClosed ].
						[ #outsideClosed ] -> [ state _ #closed ].
						[ #insideClosed ] -> [].
						[ #closed ] -> [] } ] ].
		state == #closed ifTrue: [
			forwarder closeForwardingConnection: self andKeep: false.
			state _ #dead ].
		state  == #rejectingDone ifTrue: [
			forwarder closeForwardingConnection: self andKeep: true.
			outsideSocketStream close.
			state _ #dead ] ]! !

!(Modules>>#SlowForward>>#AbstractForwardingConnection) methodsFor: 'processes' stamp: 'KLG 11/24/2021 14:45:25'!
waitFor: aMilliSecondDelay 
	"Wait for aMilliSecondDelay."
	
	Delay forMilliseconds: aMilliSecondDelay :: wait! !

!(Modules>>#SlowForward>>#AbstractForwardingConnection) methodsFor: 'initialization' stamp: 'KLG 11/25/2021 20:06:57'!
forwarder: aForwarder outsideSocket: aSocket endPoint: anEndPoint 
	"Set the end point."

	self assert: outsideSocketStream isNil.
	(outsideSocketStream _ self socketStreamClass on: aSocket)
		shouldSignal: true;
		timeout: self streamOperationTimeout.
	forwarder _ aForwarder.
	endPoint _ anEndPoint! !

!(Modules>>#SlowForward>>#AbstractForwardingConnection) methodsFor: 'initialization' stamp: 'KLG 12/17/2021 18:14:58'!
forwarder: aForwarder outsideSocket: aSocket endPoint: anEndPoint andReferrClass: aRefereeClass
	"Set the end point."

	self assert: outsideSocketStream isNil.
	"Store the address as long the socket is connected.
	We will need it after disconnection tos tore the clients
	reputation."
	outsideRemoteAddress _ aSocket remoteAddress.
	(outsideSocketStream _ self socketStreamClass on: aSocket)
		shouldSignal: true;
		timeout: self streamOperationTimeout.
	forwarder _ aForwarder.
	endPoint _ anEndPoint.
	refereeClass _ aRefereeClass! !

!(Modules>>#SlowForward>>#AbstractForwardingConnection) methodsFor: 'initialization' stamp: 'KLG 11/25/2021 23:07:36'!
initialize
	"Initialize the state flags."

	super initialize.
	sendingIn _ sendingOut _ false! !

!(Modules>>#SlowForward>>#AbstractForwardingConnection) methodsFor: 'blacklisting' stamp: 'KLG 2/24/2022 20:53:30'!
checkSenderAddressBlackListing
	"Check whether the senders address is black listed.
	
	Answer true, if we encountered a blackguard, flase otherwise."

	^ false "Be permissive"! !

!(Modules>>#SlowForward>>#AbstractForwardingConnection) methodsFor: 'blacklisting' stamp: 'KLG 2/24/2022 20:55:54'!
rejectForwarding
	"Rehect forarding the connection.
	
	Implement me in some protocol specific way."

	self subclassResponsibility! !

!(Modules>>#SlowForward>>#AbstractForwardingConnection) methodsFor: 'open/close' stamp: 'KLG 12/6/2021 02:00:26'!
close
	"Close the forwarder."

	insideSocketStream close.
	outsideSocketStream close.
	self stopProcesses.
	insideSocketStream _ outsideSocketStream _ nil! !

!(Modules>>#SlowForward>>#AbstractForwardingConnection) methodsFor: 'open/close' stamp: 'KLG 2/21/2022 20:10:54'!
connectToTarget
	"Connect to the target server.
	
	Answert true if this was successfull, false otherwise."

	[ insideSocketStream _ self socketStreamClass
		openConnectionToHost: endPoint first
		port: endPoint second
		timeout: self targetEndpointConnectionTimeout ] 
			on: NetworkError, ConnectionTimedOut
			do: [	self state: #connectFailed.
				Tracer trace: [ :out |
					out
						show: 'Connecting to host: ';
						show: endPoint first;
						show: ' port: ';
						show: endPoint;
						show: ' failed'.
					Tracer flush ].
				forwarder 
					markEndpointAsUnreachable: endPoint;
					closeForwardingConnection: self andKeep: true;
					openForwarderForConnectedSocket: outsideSocketStream socket
						andRefereeClass: referee class.
						^ false ].
	^ true! !

!(Modules>>#SlowForward>>#AbstractForwardingConnection) methodsFor: 'open/close' stamp: 'KLG 2/2/2022 10:29:35'!
kill
	"Kill the forwarder."
	
	ingressProcess ifNotNil: [
		ingressProcess terminate.
		ingressProcess _ nil ].
	outgressProcess ifNotNil: [
		outgressProcess terminate.
		outgressProcess _ nil ].
	self killStreams.
	"Avoid locking and any possible deadlocks!!"
	state _ #dead! !

!(Modules>>#SlowForward>>#AbstractForwardingConnection) methodsFor: 'open/close' stamp: 'KLG 2/20/2022 15:58:38'!
killStreams
	"Kill the sockets streams without signaling any errors."

	| killer | 
	killer _ [ :name :socketStream |
		[ socketStream
			shouldSignal: false;
			close ]
		on: NetworkError
		do: [ :exception |
			Tracer trace: [ :out |
				out
					show: 'Could not kill ';
					show: name;
					show: ' stream, because of: ';
					show: exception.
				Tracer flush ] ] ].
	insideSocketStream ifNotNil: [
		killer value: 'inside' value: insideSocketStream.
		insideSocketStream _ nil ].
	outsideSocketStream ifNotNil: [
		killer value: 'outside' value: 		outsideSocketStream.
		outsideSocketStream _ nil ]! !

!(Modules>>#SlowForward>>#AbstractForwardingConnection) methodsFor: 'open/close' stamp: 'KLG 2/24/2022 20:55:03'!
open
	"Open a socket stream to the given end point."
	
	self checkSenderAddressBlackListing ifTrue: [
		^ self rejectForwarding ].
	endPoint ifNil: [ 	^ self retryOpenDeferred ].
	referee _ self refereeClass forForwarder: self.
	self connectToTarget ifTrue: [
		self proceedToForwardingState ]! !

!(Modules>>#SlowForward>>#AbstractForwardingConnection) methodsFor: 'open/close' stamp: 'KLG 2/21/2022 20:15:42'!
proceedToForwardingState
	"Make everthing ready to start forwarding."

	insideSocketStream 
			shouldSignal: true;
			timeout: self streamOperationTimeout.
		self state: #forwarding.
		self startProcesses! !

!(Modules>>#SlowForward>>#AbstractForwardingConnection) methodsFor: 'open/close' stamp: 'KLG 2/21/2022 20:07:01'!
retryOpenDeferred
	"Open a socket stream at some time in the future because we do not have a valid endpoit."
	
	| delayTime delay reconnector |
	referee _ self refereeClass forForwarder: self.
	self state: #connectFailed.
	delay _ Delay forDuration: (delayTime _ forwarder unreachableTragetEndpointActionDelayTime).
	Tracer trace: [ :out |
		out
			show: 'No valid endpoint to connect to, will delay connection for: ';
			show: delayTime.
		Tracer flush ].
	forwarder closeForwardingConnection: self andKeep: true.
	reconnector _ [
		delay wait.
		forwarder 
			openForwarderForConnectedSocket: outsideSocketStream socket
				andRefereeClass: referee class ] newProcess.
		reconnector 
			name: (String streamContents: [ :stream |
				| socket |
				stream nextPutAll: '[sf] Endpoint Reconnector ('.
				Time now print24: true on: stream.
				stream nextPutAll: ', '.
				delayTime printOn: stream.
				stream nextPutAll: ', '.
				(socket _ outsideSocketStream socket)
					remoteAddress printOn: stream.
				stream nextPutAll: ', '.
				socket remotePort printOn: stream.
				stream nextPutAll: ' -> '.
				socket localAddress printOn: stream.
				stream nextPutAll: ', '.
				socket localPort printOn: stream.
				stream nextPut: $) ]);
			priority: Processor userBackgroundPriority;
			resume

! !

!(Modules>>#SlowForward>>#AbstractForwardingConnection) methodsFor: 'open/close' stamp: 'KLG 2/20/2022 15:09:38'!
targetEndpointConnectionTimeout
	"Answer the timeout for target endpoint connections."

	^ 23! !

!(Modules>>#SlowForward>>#AbstractForwardingConnection) methodsFor: 'send/receive' stamp: 'KLG 11/25/2021 23:16:01'!
handleHalfClosedState
	"Handle the half closed state of connections."

	self state
		caseOf: {
			[ #outsideClosed ] -> [
				guard critical: [ sendingIn ] :: ifFalse: [ insideSocketStream close ] ].
			[ #insideClosed ] -> [
				guard critical: [ sendingOut ] :: ifFalse: [ outsideSocketStream close ] ] }
		otherwise: []! !

!(Modules>>#SlowForward>>#AbstractForwardingConnection) methodsFor: 'send/receive' stamp: 'KLG 12/6/2021 13:29:22'!
processIngressChunk: aChunk

	"Process the message to detect spam or the like.
	
	Do nothing here."! !

!(Modules>>#SlowForward>>#AbstractForwardingConnection) methodsFor: 'send/receive' stamp: 'KLG 2/21/2022 13:57:20'!
processOutgressChunk: aChunk
	"Process an outgress junk.
	
	Do nothing here."
! !

!(Modules>>#SlowForward>>#AbstractForwardingConnection) methodsFor: 'send/receive' stamp: 'KLG 11/24/2021 12:18:26'!
receiveIngressChunk
	"Receive and answer one chunk of ingress data."
	
	^ self subclassResponsibility! !

!(Modules>>#SlowForward>>#AbstractForwardingConnection) methodsFor: 'send/receive' stamp: 'KLG 11/24/2021 12:18:36'!
receiveOutgressChunk
	"Receive and answer one chunk of outgress data."
	
	^ self subclassResponsibility! !

!(Modules>>#SlowForward>>#AbstractForwardingConnection) methodsFor: 'send/receive' stamp: 'KLG 11/24/2021 12:20:49'!
sendIngressChunk: aChunk
	"Send an ingress chunk to the receiving endpoint."
	
	self subclassResponsibility! !

!(Modules>>#SlowForward>>#AbstractForwardingConnection) methodsFor: 'send/receive' stamp: 'KLG 12/6/2021 13:29:22'!
sendIngressChunkHandlingState: aChunk
	"Send an ingress chunk to the receiving endpoint handle all state.."
	
	aChunk ifNil: [ ^ self handleHalfClosedState ].
	guard critical: [ sendingIn _ true ].
	self processIngressChunk: aChunk.
	[ self sendIngressChunk: aChunk ] ensure: [
		guard critical: [ sendingIn _ false ] ].! !

!(Modules>>#SlowForward>>#AbstractForwardingConnection) methodsFor: 'send/receive' stamp: 'KLG 11/24/2021 12:22:55'!
sendOutgressChunk: aChunk
	"Send an outgress chunk to the receiving endpoint."
	
	self subclassResponsibility! !

!(Modules>>#SlowForward>>#AbstractForwardingConnection) methodsFor: 'send/receive' stamp: 'KLG 2/21/2022 13:57:20'!
sendOutgressChunkHandlingState: aChunk
	"Send an outgress chunk to the receiving endpoint handle all state.."
	
	aChunk ifNil: [ ^ self handleHalfClosedState ].
	guard critical: [ sendingOut _ true ].
	self flagHaver: 'Hanlde non-requests/data'.
	self processOutgressChunk: aChunk.
	[ self sendOutgressChunk: aChunk ] ensure: [
		guard critical: [ sendingOut _ false ] ]! !

!(Modules>>#SlowForward>>#AbstractForwardingConnection) methodsFor: 'send/receive' stamp: 'KLG 11/25/2021 20:18:44'!
streamOperationTimeout
	"Answer the timeout for stream operations."

	^ 1 "second"! !

!(Modules>>#SlowForward>>#AbstractForwardingConnection) methodsFor: 'instance creation' stamp: 'KLG 12/8/2021 18:03:53'!
refereeClass
	"Answer the class of the referee."

	^ refereeClass ifNil: [ self class refereeClass ]! !

!(Modules>>#SlowForward>>#AbstractForwardingConnection) methodsFor: 'journaling' stamp: 'KLG 12/9/2021 21:18:19'!
dumpCommunicationItemsWith: aBlock
	"Dump all the communication items with aBlock"

	referee dumpCommunicationItemsWith: aBlock! !

!(Modules>>#SlowForward>>#AbstractForwardingConnection) methodsFor: 'reputations' stamp: 'KLG 12/17/2021 18:16:17'!
updateReputation
	"Update the reputations by asking the referee to do so.
	
	Note, that this API is not thread/process safe."

	referee 
		updateReputationForAddress: outsideRemoteAddress
		andForwarder: forwarder! !

!(Modules>>#SlowForward>>#AbstractForwardingConnection) class methodsFor: 'instance creation' stamp: 'KLG 11/24/2021 12:32:47'!
forForwarder: aForwarder andConnectedSocket: aSocket andEndpoint: anEndPoint 
	"comment stating purpose of message"

	^ self new forwarder: aForwarder outsideSocket: aSocket endPoint: anEndPoint; yourself ! !

!(Modules>>#SlowForward>>#AbstractForwardingConnection) class methodsFor: 'instance creation' stamp: 'KLG 12/8/2021 18:02:37'!
forForwarder: aForwarder andConnectedSocket: aSocket andEndpoint: anEndPoint andReferrClass: aRefereeClass
	"comment stating purpose of message"

	^ self new
			forwarder: aForwarder
			outsideSocket: aSocket
			endPoint: anEndPoint
			andReferrClass: aRefereeClass;
		yourself.! !

!(Modules>>#SlowForward>>#AbstractForwardingConnection) class methodsFor: 'instance creation' stamp: 'KLG 12/5/2021 23:25:58'!
refereeClass
	"Answer the class of the referee."

	^ self subclassResponsibility! !

!(Modules>>#SlowForward>>#AbstractSMTPConnection) methodsFor: 'send/receive' stamp: 'KLG 12/6/2021 14:12:17'!
processIngressChunk: aChunk
	"Process the message to detect spam or the like."

	self state == #forwardingSTARTTLS ifFalse: [
		forwarder addIngressLine: aChunk to: referee ]! !

!(Modules>>#SlowForward>>#AbstractSMTPConnection) methodsFor: 'send/receive' stamp: 'KLG 2/21/2022 13:57:20'!
processOutgressChunk: aChunk
	"Process an outgress junk."

	self state == #forwardingSTARTTLS ifFalse: [
		forwarder addOutgressLine: aChunk to: referee. ]! !

!(Modules>>#SlowForward>>#AbstractSMTPConnection) methodsFor: 'send/receive' stamp: 'KLG 12/6/2021 19:13:17'!
receiveIngressChunk
	"Receive and answer one chunk of ingress data."
	
	[ ^ self state == #forwardingSTARTTLS
			ifFalse: [ outsideSocketStream nextLineCrLf ]
			ifTrue: [ outsideSocketStream nextReceivable ] ]
		on: NetworkError
		do: [	self updateState.
			^ nil ]! !

!(Modules>>#SlowForward>>#AbstractSMTPConnection) methodsFor: 'send/receive' stamp: 'KLG 12/6/2021 19:13:03'!
receiveOutgressChunk
	"Receive and answer one chunk of outgress data."
	
	[ ^  state == #forwardingSTARTTLS
			ifFalse: [ insideSocketStream nextLineCrLf ]
			ifTrue: [ insideSocketStream nextReceivable ] ]
		on: NetworkError
		do: [ self updateState.
			^ nil ]! !

!(Modules>>#SlowForward>>#AbstractSMTPConnection) methodsFor: 'send/receive' stamp: 'KLG 4/2/2022 16:09:13'!
sendIngressChunk: aChunk
	"Send an ingress chunk to the receiving endpoint."
	
	[
	addMoniker ifNotNil: [
		addMoniker ifTrue: 	[ | socket address |
			socket _ outsideSocketStream socket.
			insideSocketStream
				nextPutAll: 'X-SlowForwardedFor: ';
				nextPutAll: ('.' join: (address _ socket remoteAddress)).
			NetNameResolver nameForAddress: address timeout: 1 :: ifNotNil: [ :name |
				insideSocketStream 
					nextPutAll: ' (';
					nextPutAll: name;
					nextPut: $) ].
			insideSocketStream crlf.
			addMoniker _ false ] ].
	insideSocketStream		nextPutAll: aChunk.
	self state == #forwardingSTARTTLS ifFalse: [
		Tracer spy: [ :out |
			out
				newLine;
				show: 'ingress  -> ';
				show: aChunk ].
		addMoniker ifNil: [
			aChunk size >= 4 and: [
				aChunk copyFrom: 1 to: 4 :: asString asUppercase = 'DATA' ] :: ifTrue: [ addMoniker _ true ] ].
		insideSocketStream			crlf ].
	insideSocketStream flush ]
			on: NetworkError
			do: [ self updateState ].
	self state == #forwarding and: [		aChunk beginsWith: 'STARTTLS' ] :: ifTrue: [
		self state: #forwardingSTARTTLSRequested ]! !

!(Modules>>#SlowForward>>#AbstractSMTPConnection) methodsFor: 'send/receive' stamp: 'KLG 1/31/2022 13:58:46'!
sendOutgressChunk: aChunk
	"Send an outgress chunk to the receiving endpoint."
	
	[
	outsideSocketStream nextPutAll: aChunk.
	self state == #forwardingSTARTTLS ifFalse: [
		Tracer spy: [ :out |
			out
				newLine;
				show: 'outgress -> ';
				show: aChunk ].
		outsideSocketStream			crlf ].
	outsideSocketStream flush ]
		on: NetworkError
		do: [ self updateState ].
	self state == #forwardingSTARTTLSRequested and: [		aChunk beginsWith: '220' ] :: ifTrue: [
		self flagHaver: 'Actually we may have a small race here!!.'.
		guard critical: [
			self state: #forwardingSTARTTLS.
			outsideSocketStream
				flush;
				binary.
			insideSocketStream
				flush;
				binary ] ]! !

!(Modules>>#SlowForward>>#AbstractSMTPConnection) methodsFor: 'accessing' stamp: 'KLG 2/8/2022 11:02:22'!
state: aState
	"Update an log my state."

	Tracer trace: [ :out |
		out
			newLine;
			show: Processor activeProcess name;
			show: ': ';
			show: self state;
			show: ' --> ';
			show: aState ].
	super state: aState! !

!(Modules>>#SlowForward>>#AbstractSMTPConnection) methodsFor: 'blacklisting' stamp: 'KLG 4/5/2022 15:57:38'!
checkSenderAddressBlackListing
	"Check whether the senders address is black listed.
	
	Answer true, if we encountered a blackguard, false otherwise."

	| nameToRequest |
	nameToRequest _ 
		NetNameResolver stringFromAddress: outsideSocketStream socket remoteAddress reverse :: ,
			'zen.spamhouse.org'.
	NetNameResolver addressForName: nameToRequest timeout: 2 ::
		ifNotNil: [ :verdict |
			verdict second = 255 or: [ verdict third = 255 ] :: ifTrue: [ ^ false ].
			verdict third = 1 ifTrue: [ ^ true ].
			verdict third = 0 and: [ ^ verdict fourth between: 2 and: 11 ] ].
	^ false
	! !

!(Modules>>#SlowForward>>#AbstractSMTPConnection) methodsFor: 'blacklisting' stamp: 'KLG 4/5/2022 11:33:34'!
rejectForwarding
	"Rehect forarding the connection.
	
	Just send a 554 Code."

	| address addressString |
	self state: #rejecting.
	addressString _ NetNameResolver
		stringFromAddress: (address _ outsideSocketStream socket remoteAddress).
	[ | addressName |
		Tracer trace: [ :out |
			addressName _ NetNameResolver nameForAddress: address timeout: 2.
			out
				show: 'Starting reject loop for: ';
				show: addressString.
			addressName ifNotNil: [
				out
					nextPut: $(;
					show: addressName;
					nextPut: $) ] ].
		self rejectLoop ] newProcess
			name: (String streamContents: [ :stream |
				stream
					nextPutAll: '[sf] Rejector for ';
					nextPutAll:  addressString ]);
			priority: self forwardingPriority;
			resume
		! !

!(Modules>>#SlowForward>>#AbstractSMTPConnection) methodsFor: 'blacklisting' stamp: 'KLG 4/6/2022 12:43:07'!
rejectLoop
	"Reject every comman in loop until we see a QUIT."

	| responder |
	responder _ 	[ 	self sendOutgressChunk: 			'554 Go away spammer' ].
	[
		outsideSocketStream noTimeout.
		responder value.
		Tracer spy: [ :out |
			out
				show: 'Startin reject loop in state: ';
				show: state.
				Tracer flush ].
		[ self state == #rejecting ] whileTrue: [
			self receiveIngressChunk 
				ifNotNil: [ :chunk |
					Tracer spy: [ :out |
						out
							show: 'chunk while rejecting: ';
							show: chunk ].
					chunk asUppercase beginsWith: 'QUIT' ::
						ifTrue: [ self
								sendOutgressChunk: '221 Thank goodness';
								state: #rejectingDone ]
						ifFalse: responder ]
				ifNil: [
					Tracer spy: [ :out |
						out show: 'Nil ingress chunk while rejecting' ].
					self state: #rejectingDone ].
			self updateState ] ]
	on: Error
	do: [ :error |
		Tracer trace: [ :out |
			out
				show: 'Error in reject loop: ';
				show: error.
			Tracer flush ].
		forwarder inDevelopmentMode
			ifTrue: [
				Processor activeProcess
					debug: error signalerContext
					title: error description ]
			ifFalse: [
				Smalltalk
					logError: error description
					inContext: error signalerContext
					to: 'SlowForwarderRejectLoop' ] ].
	Tracer trace: [ :out |
		out 
			show: Processor activeProcess name;
			show: ' terminated'.
		Tracer flush ]! !

!(Modules>>#SlowForward>>#SMTPConnection) methodsFor: 'instance creation' stamp: 'KLG 12/8/2021 18:05:21'!
refereeClass
	"Answer a referee class based on my listening port."

	refereeClass ifNotNil: [ ^ refereeClass ].
	^ outsideSocketStream socket localPort
		caseOf: {
			[ 25 ] -> [ self smtpRefereeClass ]. "SMTP, proper"
			[ 587 ] -> [ self submissionRefereeClass ] } "Submission"
		otherwise: [ super refereeClass ]! !

!(Modules>>#SlowForward>>#SMTPConnection) methodsFor: 'instance creation' stamp: 'KLG 12/7/2021 19:17:25'!
smtpRefereeClass
	"Answer the class of the referee."

	^ self class smtpRefereeClass! !

!(Modules>>#SlowForward>>#SMTPConnection) methodsFor: 'instance creation' stamp: 'KLG 12/7/2021 19:17:42'!
submissionRefereeClass
	"Answer the class of the referee."

	^ self class submissionRefereeClass! !

!(Modules>>#SlowForward>>#SMTPConnection) class methodsFor: 'instance creation' stamp: 'KLG 12/5/2021 23:26:16'!
refereeClass
	"Answer the class of the referee."

	^ SMTPReferee! !

!(Modules>>#SlowForward>>#SMTPConnection) class methodsFor: 'instance creation' stamp: 'KLG 12/7/2021 19:06:26'!
smtpRefereeClass
	"Answer the class of the referee."

	^ SMTPReferee! !

!(Modules>>#SlowForward>>#SMTPConnection) class methodsFor: 'instance creation' stamp: 'KLG 12/7/2021 19:07:10'!
submissionRefereeClass
	"Answer the class of the referee."

	^ SubmissionReferee! !

!(Modules>>#SlowForward>>#StutteringSMTPConnection) methodsFor: 'send/receive' stamp: 'KLG 12/31/2021 18:17:46'!
crLfDelay
	"Delay in milli seconds until we send the final Cr LF."

	^ nextOctetDelay * 2! !

!(Modules>>#SlowForward>>#StutteringSMTPConnection) methodsFor: 'send/receive' stamp: 'KLG 2/21/2022 20:16:16'!
initialNextOctetDelay

	^ 250! !

!(Modules>>#SlowForward>>#StutteringSMTPConnection) methodsFor: 'send/receive' stamp: 'KLG 2/21/2022 20:16:16'!
nextOctetDelay
	"Delay in milli seconds until we send teh next octet."

	^ nextOctetDelay _ (nextOctetDelay ifNil: [ self initialNextOctetDelay ]) * self nextOctetDelayDecreaseFactor + (random nextInteger: 25) - 15 :: abs! !

!(Modules>>#SlowForward>>#StutteringSMTPConnection) methodsFor: 'send/receive' stamp: 'KLG 1/6/2022 23:02:23'!
nextOctetDelayDecreaseFactor
	"Factor to decrease the next octet delay"

	^ (random nextInteger: 25) + 87 / 100! !

!(Modules>>#SlowForward>>#StutteringSMTPConnection) methodsFor: 'send/receive' stamp: 'KLG 2/24/2022 11:27:41'!
sendOutgressChunk: aChunk
	"Send an outgress chunk to the receiving endpoint."
	
	"D:Transcript
		newLine;
		show: 'stutter  -> ';
		show: aChunk."
	| cachedState |
	(cachedState _ self state) == #forwardingSTARTTLS or: [
		cachedState == #forwardingSTARTTLSRequested ] :: ifTrue: [
		^ super sendOutgressChunk: aChunk ].
	aChunk do: [ :octet |
		self waitUntilNextOctet.
		[ outsideSocketStream nextPut: octet	.
		  self shouldFlush ifTrue: [ outsideSocketStream 			flush ] ]
			on: NetworkError
			do: [ self updateState.
				^ self ] ].
	self waitUntilCrLf.
	[ outsideSocketStream
		crlf;
		flush ]
		on: NetworkError
		do: [ self updateState ]! !

!(Modules>>#SlowForward>>#StutteringSMTPConnection) methodsFor: 'send/receive' stamp: 'KLG 1/6/2022 22:57:22'!
shouldFlush
	"Answer true if we should flush the outside socket."

	| clusterCountResetter |
	clusterCount		ifNil: (clusterCountResetter _ [
		clusterCount _ 1 / nextOctetDelay * 200 :: asInteger. random nextBoolean ]).
	"Transcript
		newLine;
		show: 'clusterCount: ';
		show: clusterCount."
	^ (clusterCount _ clusterCount - 1) negative
		ifTrue: clusterCountResetter
		ifFalse: [ false ]! !

!(Modules>>#SlowForward>>#StutteringSMTPConnection) methodsFor: 'processes' stamp: 'KLG 2/22/2022 21:34:55'!
forwardingPriority
	"Answer the process priority for the tow forwarding processes."

	^ Processor lowestPriority + 5! !

!(Modules>>#SlowForward>>#StutteringSMTPConnection) methodsFor: 'processes' stamp: 'KLG 11/24/2021 15:14:07'!
waitUntilCrLf
	"Wait until the final Cr Lf."
	
	self waitFor: self crLfDelay! !

!(Modules>>#SlowForward>>#StutteringSMTPConnection) methodsFor: 'processes' stamp: 'KLG 11/24/2021 14:42:09'!
waitUntilNextOctet
	"Wait until we send the next octet."

	self waitFor: self nextOctetDelay! !

!(Modules>>#SlowForward>>#StutteringSMTPConnection) methodsFor: 'initialization' stamp: 'KLG 1/6/2022 22:51:38'!
initialize
	"Initialize the (outbound) random number generator"

	super initialize.
	random _ Random new! !

!(Modules>>#SlowForward>>#ListenEndPoint) methodsFor: 'open/close' stamp: 'KLG 12/13/2021 16:18:49'!
close
	"Close the end point"

	self assert: ingressSocket notNil.
	self stopProcesses.
	ingressSocket destroy.
	ingressSocket _ nil! !

!(Modules>>#SlowForward>>#ListenEndPoint) methodsFor: 'open/close' stamp: 'KLG 12/7/2021 20:59:59'!
kill
	"Uncoditionally kill th end point. Don't check for races etc. pp."

	ingressSocket ifNotNil: [
		ingressSocket destroy.
		ingressSocket _ nil ].
	listenProcess ifNotNil: [
		listenProcess terminate.
		listenProcess _ nil ]! !

!(Modules>>#SlowForward>>#ListenEndPoint) methodsFor: 'open/close' stamp: 'KLG 12/8/2021 12:39:04'!
open
	"Open the end point
	
	In this case make it listen"
	self assert: ingressSocket isNil.
	(ingressSocket _ self socketClass new)
		listenOn: endPoint second backlogSize: 4 interface: endPoint first.
	endPoint size > 2 ifTrue: [
		refereeClass _ endPoint third ].
	self startProcesses ! !

!(Modules>>#SlowForward>>#ListenEndPoint) methodsFor: 'instance creation' stamp: 'KLG 11/9/2021 12:11:31'!
newTCPConnectionFor: aSocket
	"Start a new TCP connection for a socket."

	self subclassResponsibility! !

!(Modules>>#SlowForward>>#ListenEndPoint) methodsFor: 'instance creation' stamp: 'KLG 11/9/2021 12:15:57'!
tcpConnectionClass
	"Answer the class of a new TCP connection."

	^ self class tcpConnectionClass! !

!(Modules>>#SlowForward>>#ListenEndPoint) methodsFor: 'processes' stamp: 'KLG 11/18/2021 19:49:33'!
acceptTimeout
	"Answer the time in seconds we wait for accept to return."

	^ 2! !

!(Modules>>#SlowForward>>#ListenEndPoint) methodsFor: 'processes' stamp: 'KLG 11/24/2021 13:25:41'!
listenLoop
	"I am the listen loop."

	self whileInState: #running do: [
		self newTCPConnectionFor: (ingressSocket waitForAcceptFor: self acceptTimeout) ]! !

!(Modules>>#SlowForward>>#ListenEndPoint) methodsFor: 'processes' stamp: 'KLG 2/22/2022 21:50:44'!
listeningPriority
	"Answer the process priority for the tow forwarding processes."

	^ `40 - 1`! !

!(Modules>>#SlowForward>>#ListenEndPoint) methodsFor: 'processes' stamp: 'KLG 2/22/2022 21:40:02'!
startProcesses
	"Start the necessary processes.
	
	In my case, start the listen loop"

	self assert: self state == #new.
	self state: #running.
	(listenProcess _ [ self listenLoop ] newProcess)
		name: (String streamContents: [ :stream |
			stream nextPutAll: '[sf] Listener on: '.
			endPoint printOn: stream ]);
		priority: self listeningPriority;
		resume! !

!(Modules>>#SlowForward>>#ListenEndPoint) methodsFor: 'processes' stamp: 'KLG 11/9/2021 11:55:16'!
stopProcesses
	"Stop the necessary processes.

	In my case, stop the listen loop"

	self assert: self state == #running.
	self state: #stopping! !

!(Modules>>#SlowForward>>#ListenEndPoint) methodsFor: 'initialization' stamp: 'KLG 11/9/2021 14:18:15'!
forwarder: aForwarder endPoint: anEndPoint
	"Set the end point."

	self assert: ingressSocket isNil.
	forwarder _ aForwarder.
	endPoint _ anEndPoint! !

!(Modules>>#SlowForward>>#ListenEndPoint) class methodsFor: 'instance creation' stamp: 'KLG 11/9/2021 14:16:25'!
forForwarder: aForwarder andEndPoint: anEndPoint
	"comment stating purpose of message"

	^ self new forwarder: aForwarder endPoint: anEndPoint; yourself ! !

!(Modules>>#SlowForward>>#ListenEndPoint) class methodsFor: 'instance creation' stamp: 'KLG 11/9/2021 12:14:31'!
tcpConnectionClass
	"Answer the class of a new TCP connection."

	^ self subclassResponsibility! !

!(Modules>>#SlowForward>>#SMTPEndPoint) methodsFor: 'instance creation' stamp: 'KLG 1/31/2022 13:32:23'!
newTCPConnectionFor: aSocket
	"Start a new SMTP connection for a socket."

	aSocket ifNotNil: [
		Tracer trace: [ :out |
			out
				newLine;
				show: 'new c:onnection for: ';
				show: aSocket ].
		refereeClass
			ifNil: [
				forwarder openForwarderForConnectedSocket: aSocket ]
			ifNotNil: [
				forwarder 
					openForwarderForConnectedSocket: aSocket
					andRefereeClass: refereeClass ] ]! !

!(Modules>>#SlowForward>>#SMTPEndPoint) class methodsFor: 'instance creation' stamp: 'KLG 11/9/2021 12:15:06'!
tcpConnectionClass
	"Answer the class of a new TCP connection."

	^ SMTPConnection! !

!(Modules>>#SlowForward>>#AbstractReferee) methodsFor: 'reputations' stamp: 'KLG 2/22/2022 10:31:22'!
updateReputationForAddress: anAddress andForwarder: aForwarder 
	"Update the reputation based on the sessions score."

	| newReputationClass newReputation |
	self evaluate.
	newReputationClass _ score > 90
			ifTrue: [
				aForwarder goodReputationClass ]
			ifFalse: [
				aForwarder unknownReputationClass ].
	newReputation _ ReputationStore
		at: anAddress 
		ifPresent: [ :oldReputation | newReputationClass fromReputation: oldReputation ]
		ifAbsent: [ newReputationClass forAddress: anAddress ].
	Tracer trace: [ :out |
		out
			show: 'New reputation for: ';
			show: anAddress;
			show: ' is: ';
			show: newReputation ].
	ReputationStore
		at: anAddress 
		put: newReputation! !

!(Modules>>#SlowForward>>#AbstractReferee) methodsFor: 'rules' stamp: 'KLG 12/4/2021 13:16:09'!
addPatternRuleSelectorsTo: aCollection
	"Answer all the pattern rules to referee."

	self subclassResponsibility! !

!(Modules>>#SlowForward>>#AbstractReferee) methodsFor: 'rules' stamp: 'KLG 12/4/2021 20:21:38'!
initializeRules
	"Initialize the collection of rules"

	| patternRuleSelectors |
	rules _ IdentitySet new.
	patternRuleSelectors _ IdentitySet new.
	self addPatternRuleSelectorsTo: patternRuleSelectors.
	rules addAll: (patternRuleSelectors collect: [ :selectorAndScoreBlock | | selector scoreBlock |
		selector _ selectorAndScoreBlock first.
		scoreBlock _ selectorAndScoreBlock second.
		SimpleProtocolPattern forReferee: self andBenchmark: selector andScoreBlock: scoreBlock ]).
	^ rules! !

!(Modules>>#SlowForward>>#AbstractReferee) methodsFor: 'initialization' stamp: 'KLG 12/4/2021 20:29:57'!
initialize
	"Initalize the rule set"

	super initialize.
	self initializeRules.
	score _ 0! !

!(Modules>>#SlowForward>>#AbstractReferee) methodsFor: 'evaluating' stamp: 'KLG 12/4/2021 20:26:55'!
evaluate
	"Evaluate all my rules on my communication items.
	
	Answer the score."

	rules do: [ :rule |
		rule evaluate ]! !

!(Modules>>#SlowForward>>#AbstractReferee) methodsFor: 'accessing' stamp: 'KLG 12/4/2021 20:27:57'!
score
	"Answer the score."

	^ score! !

!(Modules>>#SlowForward>>#AbstractReferee) methodsFor: 'journaling' stamp: 'KLG 12/9/2021 21:18:52'!
dumpCommunicationItemsWith: aBlock
	"Dump all the communication items with aBlock"

	self subclassResponsibility! !

!(Modules>>#SlowForward>>#AbstractSMTPReferee) methodsFor: 'initialization' stamp: 'KLG 12/6/2021 01:41:38'!
initialize
	"Intialize the log of commands seen."

	super initialize.
	communicationItems _ OrderedCollection new.
	state _ #request! !

!(Modules>>#SlowForward>>#AbstractSMTPReferee) methodsFor: 'rules' stamp: 'KLG 1/6/2022 15:17:12'!
addPatternRuleSelectorsTo: aCollection
	"Answer all the pattern rules to referee."

	aCollection add: {
		#justQuit. [ :resultScore | score _ score + 91 ].
		#usesSTARTTLS. [ :resultScore | score _ score + (resultScore * 2) ] }! !

!(Modules>>#SlowForward>>#AbstractSMTPReferee) methodsFor: 'communication' stamp: 'KLG 12/4/2021 15:54:41'!
addCommunicationtem: anItem
	"Add anItem to the collection of protocol items."

	^ communicationItems add: anItem! !

!(Modules>>#SlowForward>>#AbstractSMTPReferee) methodsFor: 'communication' stamp: 'KLG 12/6/2021 01:43:06'!
addDataLine: someSMTPData
	"Add some SMTP data to the list of communication items.
	
	Abswer the response added."

	| answer |
	answer _ self addCommunicationtem:  (self smtpDataClass forData: someSMTPData).
	someSMTPData = '.' ifTrue: [ state _ #request ].
	^ answer 
		! !

!(Modules>>#SlowForward>>#AbstractSMTPReferee) methodsFor: 'communication' stamp: 'KLG 1/31/2022 13:57:03'!
addIngressLine: anItem
	"Add an ingress item.
	
	Send the right method, depending on my state."

	Tracer spy: [ :out |
		out
			newLine;
			show: 'ingress state: ';
			show: state ].
	^ state caseOf: {
		[ #data ] -> [ self addDataLine: anItem ].
		[ #request ] -> [ self addRequestLine: anItem ] }! !

!(Modules>>#SlowForward>>#AbstractSMTPReferee) methodsFor: 'communication' stamp: 'KLG 12/6/2021 01:43:49'!
addOutgressILine: anItem
	"Add an outgress item.
	
	Send the right method, depending on my state."

	^ self addResponseLine: anItem! !

!(Modules>>#SlowForward>>#AbstractSMTPReferee) methodsFor: 'communication' stamp: 'KLG 2/24/2022 20:47:51'!
addRequestLine: aSMTPRequest
	"Add an SMTP request the list of communication items.
	
	Abswer the resquestr added."

	| answer keyword |
	(keyword _ (answer _ self addCommunicationtem: (self smtpRequestClass forData: aSMTPRequest))
		keyword) = 'data' or: [
			keyword = 'bdat' ] :: ifTrue: [
				state _ #data ].
	^ answer! !

!(Modules>>#SlowForward>>#AbstractSMTPReferee) methodsFor: 'communication' stamp: 'KLG 12/4/2021 16:04:11'!
addResponseLine: aSMTPResponse
	"Add an SMTP response to the list of communication items.
	
	Abswer the response added."

	^ self addCommunicationtem: (self smtpResponseClass forData: aSMTPResponse)! !

!(Modules>>#SlowForward>>#AbstractSMTPReferee) methodsFor: 'communication' stamp: 'KLG 12/4/2021 16:02:15'!
communicationItemAt: anIndex
	"Answer the communication item at an index."

	^ communicationItems at: anIndex! !

!(Modules>>#SlowForward>>#AbstractSMTPReferee) methodsFor: 'communication' stamp: 'KLG 12/4/2021 17:46:06'!
communicationStream
	"Answer a read stream on the communication items."

	^ ReadStream on: communicationItems! !

!(Modules>>#SlowForward>>#AbstractSMTPReferee) methodsFor: 'instance creation' stamp: 'KLG 12/4/2021 15:57:08'!
smtpDataClass
	"Answer the class for SMTP data."

	^ self class smtpDataClass! !

!(Modules>>#SlowForward>>#AbstractSMTPReferee) methodsFor: 'instance creation' stamp: 'KLG 12/4/2021 15:35:57'!
smtpRequestClass
	"Answer the class for SMTP requests."

	^ self class smtpRequestClass! !

!(Modules>>#SlowForward>>#AbstractSMTPReferee) methodsFor: 'instance creation' stamp: 'KLG 12/4/2021 15:37:31'!
smtpResponseClass
	"Answer the class for SMTP responses."

	^ self class smtpResponseClass! !

!(Modules>>#SlowForward>>#AbstractSMTPReferee) methodsFor: 'journaling' stamp: 'KLG 12/9/2021 21:19:16'!
dumpCommunicationItemsWith: aBlock
	"Dump all the communication items with aBlock"

	aBlock value: communicationItems! !

!(Modules>>#SlowForward>>#AbstractSMTPReferee) class methodsFor: 'instance creation' stamp: 'KLG 12/4/2021 15:57:21'!
smtpDataClass
	"Answer the class for SMTP data."

	^ SMTPData! !

!(Modules>>#SlowForward>>#AbstractSMTPReferee) class methodsFor: 'instance creation' stamp: 'KLG 12/4/2021 15:34:20'!
smtpRequestClass
	"Answer the class for SMTP requests."

	^ SMTPRequest! !

!(Modules>>#SlowForward>>#AbstractSMTPReferee) class methodsFor: 'instance creation' stamp: 'KLG 12/4/2021 15:33:59'!
smtpResponseClass
	"Answer the class for SMTP responses."

	^ SMTPResponse! !

!(Modules>>#SlowForward>>#SMTPReferee) methodsFor: 'rules' stamp: 'KLG 12/18/2021 21:31:27'!
addPatternRuleSelectorsTo: aCollection
	"Add all the pattern rules to aCollection."

	| scoreAdder |
	super addPatternRuleSelectorsTo: aCollection.
	scoreAdder _ [ :resultScore | 
		score _ score + resultScore ].
	aCollection
		add: {	#mailToOneRecipient. 	scoreAdder };
		add: { #mailToMultipleRecipients. scoreAdder }! !

!(Modules>>#SlowForward>>#SlowForwarder) methodsFor: 'initialization' stamp: 'KLG 2/21/2022 06:47:50'!
configuration: aConfiguration
	"Set the configuration."
	
	self assert: configuration isNil.
	(configuration _ aConfiguration) isTestConfiguration ifTrue: [
		self onlyGiveLocalHostAGoodReputation ]! !

!(Modules>>#SlowForward>>#SlowForwarder) methodsFor: 'initialization' stamp: 'KLG 2/21/2022 06:47:08'!
initialize
	"Initialize the collections go clients and other stuff."

	super initialize.
	keepOnRunning _ false.
	pendingActions _ self queueClass new.
	unreachableTargetEndpoints _ Dictionary new! !

!(Modules>>#SlowForward>>#SlowForwarder) methodsFor: 'initialization' stamp: 'KLG 12/17/2021 15:11:59'!
onlyGiveLocalHostAGoodReputation
	"Fix the reputation store to give only a good reputation to localhost only."

	ReputationStore
		at: #[127 0 0 1]
		put: (self goodReputationClass
				forAddress: #[127 0 0 1])! !

!(Modules>>#SlowForward>>#SlowForwarder) methodsFor: 'testing' stamp: 'KLG 2/21/2022 14:53:28'!
inDevelopmentMode
	"Answer true if we are in development mode."

	^ self configuration isDevelopmentConfiguration! !

!(Modules>>#SlowForward>>#SlowForwarder) methodsFor: 'testing' stamp: 'KLG 11/18/2021 19:06:24'!
isOpen
	"Answer true if the forwarder is open."

	^ pumper notNil! !

!(Modules>>#SlowForward>>#SlowForwarder) methodsFor: 'open/close' stamp: 'KLG 2/20/2022 20:38:47'!
chooseTargetEndPoint: aSocket
	"Choose one target end point."
	
	| timestamp targetEndPoints availableEndpoints retryCondition |
	timestamp _ DateAndTime now.
	availableEndpoints _ (targetEndPoints  _ self targetEndpointsByListenPort: aSocket localPort)
		copyWithoutAll: 	unreachableTargetEndpoints keys.
	"If there are no available endpoints we have to retry ..."
	retryCondition _ availableEndpoints isEmpty.
	" ... otherwise if there are unreachable end points, maybe give them a chance." 
	retryCondition ifFalse: [ unreachableTargetEndpoints ifNotEmpty: [
			retryCondition _ Random withDefaultDo: [ :rng | rng nextBoolean ] ] ].
	retryCondition 
			ifTrue: [ | endpointsToRetry |
				endpointsToRetry _ Set new.
				unreachableTargetEndpoints keysAndValuesDo: [ :endpoint :failureTime |
				targetEndPoints includes: endpoint :: ifTrue: [
						(failureTime + self unreachableTragetEndpointRetryTime) < timestamp
							ifTrue: [ "A possible #ifFalse: branch could do a connection check."
								Tracer trace: [ :out |
									out
										show: 'Unreachable endpoint: ';
										show: endpoint;
										show: ' marked as such at: ';
										show: failureTime;
										show: ' will be used again' ].	
								endpointsToRetry add: endpoint  ] ] ].
				endpointsToRetry ifEmpty: [ "No end points to retry ..."
					availableEndpoints ifNotEmpty: [ "We still have reachable endpoints, so choose one ..."
						^ availableEndpoints atRandom ].
					^ nil "A shoot, trigger a delay" ].
				endpointsToRetry do: [ :endpoint | unreachableTargetEndpoints removeKey: endpoint ].
				^ endpointsToRetry atRandom ]
			ifFalse: [ ^ availableEndpoints atRandom ]! !

!(Modules>>#SlowForward>>#SlowForwarder) methodsFor: 'open/close' stamp: 'KLG 2/20/2022 18:30:03'!
chooseTargetEndPointSingle: aSocket
	"Choose one target end point."
	
	| answer |
	answer _ self targetEndpointsByListenPort: aSocket localPort :: atRandom.
	unreachableTargetEndpoints 
		at: answer
		ifPresent: [ :failureTime |
			(failureTime + self unreachableTragetEndpointRetryTime) < DateAndTime now
				ifTrue: [
					Tracer trace: [ :out |
						out
							show: 'Unreachable endpoint: ';
							show: answer;
							show: ' marked as such at: ';
							show: failureTime;
							show: ' will be used again' ].
					unreachableTargetEndpoints removeKey: answer ]
				ifFalse: [ answer _ nil ] ].
	^ answer	! !

!(Modules>>#SlowForward>>#SlowForwarder) methodsFor: 'open/close' stamp: 'KLG 11/12/2021 18:53:51'!
close
	"Close all the open sockets"

	self
		assert: listenEndpoints notNil;
		assert: forwardingConnections notNil.
	pendingActions nextPut: [
		listenEndpoints do: [ :endPoint |
			endPoint close ].
		forwardingConnections do: [ :socket |
			socket close ].
		forwardingConnections _ listenEndpoints _ nil ].
	self stopProcesses.
! !

!(Modules>>#SlowForward>>#SlowForwarder) methodsFor: 'open/close' stamp: 'KLG 2/20/2022 13:29:59'!
closeForwardingConnection: aForwardingConnection andKeep: aKeepFlag 
	"Create a forwarding connection for the connected socket and close it."

	"Only update the reputation, if we want to close the outside socket."
	aKeepFlag ifFalse: [
		aForwardingConnection updateReputation ].
	pendingActions nextPut: [
		Tracer trace: [ :out |
			out
				newLine;
				show: 'Closing forwarding connection: ';
				show: aForwardingConnection ].
		forwardingConnections
			remove: aForwardingConnection
			ifAbsent: [
				Tracer trace: [ :out |
					out
						newLine;
						show: 'Forwarding connection already closed/killed' ] ].
		"Do this once and in a synchronos manner."
		aKeepFlag ifFalse: [
			aForwardingConnection
				dumpCommunicationItemsWith: self forwarderCloseHook;
				close ] ]! !

!(Modules>>#SlowForward>>#SlowForwarder) methodsFor: 'open/close' stamp: 'KLG 12/9/2021 21:15:00'!
forwarderCloseHook
	"Answer the value of forwarderCloseHook"

	^ self class forwarderCloseHook! !

!(Modules>>#SlowForward>>#SlowForwarder) methodsFor: 'open/close' stamp: 'KLG 11/18/2021 19:45:26'!
kill
	"Try to kill the forwarder immediately and without mercy."

	pumper ifNotNil: [
		pumper terminate.
		pumper _ nil ].
	listenEndpoints ifNotNil: [
		listenEndpoints do: [ :endPoint |
			endPoint kill ].
	listenEndpoints _ nil ].
	forwardingConnections ifNotNil: [
		forwardingConnections do: [ :connection |
			connection kill ] ].
	forwardingConnections _ nil! !

!(Modules>>#SlowForward>>#SlowForwarder) methodsFor: 'open/close' stamp: 'KLG 2/20/2022 14:16:50'!
markEndpointAsUnreachable: anEndpoint
	"Mark anEndpoint as unreachable."

	| unreachableAt |
	unreachableAt _ DateAndTime now.
	pendingActions nextPut: [
		unreachableTargetEndpoints includesKey: anEndpoint ::
			ifFalse: [
				Tracer trace: [ :out |
					out
						show: 'Endpoint: ';
						show: anEndpoint;
						show: ' becomes unreachable at: ';
						show: unreachableAt ].
				unreachableTargetEndpoints at: anEndpoint put: unreachableAt ]
			ifTrue: [
				Tracer spy: [ :out |
					out
						show: 'Endpoint: ';
						show: anEndpoint;
						show: ' is already unreachable' ] ] ]
! !

!(Modules>>#SlowForward>>#SlowForwarder) methodsFor: 'open/close' stamp: 'KLG 11/12/2021 18:40:32'!
open
	"Open all the connections."
.
	forwardingConnections _ IdentitySet new.
	listenEndpoints _ IdentitySet new.
	self startProcesses.
	pendingActions nextPut: [ self openListenEndpoints ]! !

!(Modules>>#SlowForward>>#SlowForwarder) methodsFor: 'open/close' stamp: 'KLG 2/20/2022 15:47:39'!
openForwarderForConnectedSocket: aSocket
	"Create a forwarder for the connected socket and open it."

	pendingActions nextPut: [
		Tracer spy: [ :out |
			out
				newLine;
				show: 'Open forwarding connection for: ';
				show: aSocket ].
		forwardingConnections add: (self forwarderForConnectedSocket: aSocket) ::
			open ].
		! !

!(Modules>>#SlowForward>>#SlowForwarder) methodsFor: 'open/close' stamp: 'KLG 2/20/2022 15:48:03'!
openForwarderForConnectedSocket: aSocket andRefereeClass: aRefereeClass
	"Create a forwarder for the connected socket and open it."

	pendingActions nextPut: [
		Tracer spy: [ :out |
			out
				newLine;
				show: 'Open forwarding connection for: ';
				show: aSocket;
				show: 'referee class: ';
				show: aRefereeClass ]..
		forwardingConnections add: (
			self
				forwarderForConnectedSocket: aSocket
				andRefereeClass: aRefereeClass) ::
			open ].
		! !

!(Modules>>#SlowForward>>#SlowForwarder) methodsFor: 'open/close' stamp: 'KLG 1/31/2022 13:21:25'!
openListenEndpointOn: anEndpoint
	"Open a listen endpoint."
	
	
	| newEndPoint |
	Tracer trace: [ :out |
		out
			newLine;
			show: 'Open listen endpoint on: ';
			show: anEndpoint ].
	listenEndpoints add: (newEndPoint _ self listenEndPointClass forForwarder: self andEndPoint: anEndpoint).
	newEndPoint open! !

!(Modules>>#SlowForward>>#SlowForwarder) methodsFor: 'open/close' stamp: 'KLG 10/28/2021 13:18:54'!
openListenEndpoints
	"Open all the listening endpoints."
	
	self listenEndpoints do: [ :endpointAddress |
		self openListenEndpointOn: endpointAddress ]! !

!(Modules>>#SlowForward>>#SlowForwarder) methodsFor: 'open/close' stamp: 'KLG 2/2/2022 10:53:49'!
removeForwardingConnection: aForwardingConnection
	"Remove a forwarding  for the connected socket.
	
	Used when an error occurs."

	pendingActions nextPut: [
		Tracer trace: [ :out |
			out
				newLine;
				show: 'Removing forwarding connection: ';
				show: aForwardingConnection ].
		forwardingConnections
			remove: aForwardingConnection
			ifAbsent: [
				Tracer trace: [ :out |
					out
						newLine;
						show: 'Forwarding connection already gone' ] ] ]! !

!(Modules>>#SlowForward>>#SlowForwarder) methodsFor: 'open/close' stamp: 'KLG 2/20/2022 16:46:25'!
unreachableTragetEndpointActionDelayTime
	"Answer the delay time to wait befor trying to reconnect to unreachable targets."

	^ Duration seconds: `13 to: 23` atRandom! !

!(Modules>>#SlowForward>>#SlowForwarder) methodsFor: 'open/close' stamp: 'KLG 2/20/2022 16:46:33'!
unreachableTragetEndpointRetryTime
	"Answer the retry time for unreachable targets."

	^ `Duration seconds: 31`! !

!(Modules>>#SlowForward>>#SlowForwarder) methodsFor: 'accessing' stamp: 'KLG 10/28/2021 13:21:34'!
configuration
	"Answer the configuration."

	^ configuration ifNil: [ configuration _ self configurationClass defaultConfiguration ]! !

!(Modules>>#SlowForward>>#SlowForwarder) methodsFor: 'accessing' stamp: 'KLG 10/28/2021 13:29:39'!
listenEndpoints
	"Answer the listen endpoints".
	
	^ self configuration listenEndpoints! !

!(Modules>>#SlowForward>>#SlowForwarder) methodsFor: 'accessing' stamp: 'KLG 10/28/2021 13:20:17'!
targetEndpoints
	"Answer the target endpoints."
	
	^ self configuration targetEndpoints! !

!(Modules>>#SlowForward>>#SlowForwarder) methodsFor: 'accessing' stamp: 'KLG 12/30/2021 14:03:33'!
targetEndpointsByListenPort: aPortNumber
	"Answer the target endpoints."
	
	^ self configuration targetEndpointsByListenPort: aPortNumber! !

!(Modules>>#SlowForward>>#SlowForwarder) methodsFor: 'processes' stamp: 'KLG 4/4/2022 13:45:46'!
pumpQueue
	"Pump our message queue."

	[ keepOnRunning ] whileTrue: [
		[ pendingActions next value ] on: Error do: [ :error |
			Tracer trace: [ :out |
				out
					show: 'Error in action pump: ';
					show: error.
				Tracer flush ].
			self inDevelopmentMode
				ifTrue: [
					Processor activeProcess
						debug: error signalerContext
						title: error description ]
				ifFalse: [
					Smalltalk
						logError: error description
						inContext: error signalerContext
						to: 'SlowForwarderPumpQueue' ] ] ]! !

!(Modules>>#SlowForward>>#SlowForwarder) methodsFor: 'processes' stamp: 'KLG 2/22/2022 21:50:12'!
startProcesses
	"Start the necessary processes."

	keepOnRunning _ true.
	(pumper _ [ self pumpQueue ] newProcess)
		name: (String streamContents: [: stream |
			stream
				nextPutAll: '[sf] Action Pump for ';
				nextPutAll: self class name;
				nextPut: $(.
			self identityHash printOn: stream.
			stream nextPut: $) ]);
		priority: `40 - 2`;
		resume! !

!(Modules>>#SlowForward>>#SlowForwarder) methodsFor: 'processes' stamp: 'KLG 11/12/2021 18:51:28'!
stopProcesses
	"Stop the necessary processes."

	pendingActions nextPut: [
		keepOnRunning _ false.
		pumper _ nil ]
! !

!(Modules>>#SlowForward>>#SlowForwarder) methodsFor: 'reputation' stamp: 'KLG 12/17/2021 15:13:44'!
reputationForAddress: anAddress
	"Answer the reputation of an address."

	^ ReputationStore at: anAddress ifAbsent: [ self unknownReputationForAddress: anAddress ]! !

!(Modules>>#SlowForward>>#SlowForwarder) methodsFor: 'reputation' stamp: 'KLG 12/17/2021 15:11:59'!
unknownReputationForAddress: anAddress
	"Answer a new unknown reputation."

	^ self unknownReputationClass forAddress: anAddress! !

!(Modules>>#SlowForward>>#SlowForwarder) methodsFor: 'instance creation' stamp: 'KLG 10/28/2021 13:22:52'!
configurationClass
	"Answer the configuration class."
	
	^ self class configurationClass! !

!(Modules>>#SlowForward>>#SlowForwarder) methodsFor: 'instance creation' stamp: 'KLG 11/26/2021 13:42:32'!
defaultReputationClass
	"Answer the default reputation class."

	^ self unknownReputationClass! !

!(Modules>>#SlowForward>>#SlowForwarder) methodsFor: 'instance creation' stamp: 'KLG 11/9/2021 12:23:31'!
forwarderClassForConnectedSocket: aSocket
	"Answer the forwarder class for a connected socket.."

	^ self forwarderClassForRemoteAddress: aSocket remoteAddress! !

!(Modules>>#SlowForward>>#SlowForwarder) methodsFor: 'instance creation' stamp: 'KLG 11/12/2021 18:32:47'!
forwarderClassForRemoteAddress: aRemoteAddress.
	"Answer the forwarder class for a remote address."

	^ self subclassResponsibility! !

!(Modules>>#SlowForward>>#SlowForwarder) methodsFor: 'instance creation' stamp: 'KLG 2/20/2022 15:51:35'!
forwarderForConnectedSocket: aSocket
	"Answer the forwarder class for a connected socket.."

	^ self forwarderClassForConnectedSocket: aSocket ::
		forForwarder: self
		andConnectedSocket: aSocket
		andEndpoint: (self chooseTargetEndPoint: aSocket).! !

!(Modules>>#SlowForward>>#SlowForwarder) methodsFor: 'instance creation' stamp: 'KLG 12/30/2021 13:40:41'!
forwarderForConnectedSocket: aSocket andRefereeClass: aRefereeClass
	"Answer the forwarder class for a connected socket.."

	^ self forwarderClassForConnectedSocket: aSocket ::
		forForwarder: self
		andConnectedSocket: aSocket
		andEndpoint: (self chooseTargetEndPoint: aSocket)
		andReferrClass: aRefereeClass ! !

!(Modules>>#SlowForward>>#SlowForwarder) methodsFor: 'instance creation' stamp: 'KLG 12/17/2021 15:15:23'!
goodReputationClass
	"Answer the class of good reputations."

	^ GoodReputation! !

!(Modules>>#SlowForward>>#SlowForwarder) methodsFor: 'instance creation' stamp: 'KLG 11/5/2021 23:09:16'!
listenEndPointClass
	"Answer the listen endpoint class."
	
	^ self class listenEndPointClass! !

!(Modules>>#SlowForward>>#SlowForwarder) methodsFor: 'instance creation' stamp: 'KLG 11/12/2021 09:38:07'!
queueClass
	"Answer the class used for event and action queues."

	^ self class queueClass! !

!(Modules>>#SlowForward>>#SlowForwarder) methodsFor: 'instance creation' stamp: 'KLG 10/28/2021 13:33:07'!
socketClass
	"Answer the socket class."
	
	^ self class socketClass! !

!(Modules>>#SlowForward>>#SlowForwarder) methodsFor: 'instance creation' stamp: 'KLG 10/28/2021 14:06:34'!
socketStreamClass
	"Answer the socket stream class."
	
	^ self class socketStreamClass! !

!(Modules>>#SlowForward>>#SlowForwarder) methodsFor: 'instance creation' stamp: 'KLG 11/26/2021 13:43:54'!
spammerReputationClass
	"Answer the class of spammer reputations."

	^ SpammerReputation! !

!(Modules>>#SlowForward>>#SlowForwarder) methodsFor: 'instance creation' stamp: 'KLG 12/17/2021 16:18:58'!
unknownReputationClass
	"Answer the class of unknown reputations."

	^ UnknownReputation! !

!(Modules>>#SlowForward>>#SlowForwarder) class methodsFor: 'class initialization' stamp: 'KLG 2/1/2022 10:18:33'!
initialize
	"Create the global tracer."

	self installTracer: false.
	self flagHaver: 'Need a better solution than that!!'.
	self class environment compileAll! !

!(Modules>>#SlowForward>>#SlowForwarder) class methodsFor: 'class initialization' stamp: 'KLG 2/19/2022 12:35:25'!
installTracer: aTraceOnFileFlag
	"Install a tracer in the image"

	self class environment
		at: #Tracer
		put:
			(aTraceOnFileFlag
				ifTrue: [ FileStreamTracer appendTraceTo: 'SlowForwarder.trc' ]
				ifFalse: [ TranscriptTracer new ]) :: enableMonitor! !

!(Modules>>#SlowForward>>#SlowForwarder) class methodsFor: 'instance creation' stamp: 'KLG 1/18/2022 15:15:01'!
configurationClass
	"Answer the configuration class."
	
	^ PortWiseForwarderConfiguration! !

!(Modules>>#SlowForward>>#SlowForwarder) class methodsFor: 'instance creation' stamp: 'KLG 11/9/2021 12:12:28'!
listenEndPointClass
	"Answer the listen endpoint class."
	
	^ self subclassResponsibility! !

!(Modules>>#SlowForward>>#SlowForwarder) class methodsFor: 'instance creation' stamp: 'KLG 1/18/2022 14:44:29'!
portWiseConfigurationClass
	"Answer the configuration class."
	
	^ PortWiseForwarderConfiguration! !

!(Modules>>#SlowForward>>#SlowForwarder) class methodsFor: 'instance creation' stamp: 'KLG 11/12/2021 09:38:22'!
queueClass
	"Answer the class used for event and action queues."

	^ SharedQueue! !

!(Modules>>#SlowForward>>#SlowForwarder) class methodsFor: 'instance creation' stamp: 'KLG 10/28/2021 13:33:18'!
socketClass
	"Answer the socket class."
	
	^ Socket! !

!(Modules>>#SlowForward>>#SlowForwarder) class methodsFor: 'instance creation' stamp: 'KLG 10/28/2021 14:06:54'!
socketStreamClass
	"Answer the socket stream class."
	
	^ SocketStream! !

!(Modules>>#SlowForward>>#SlowForwarder) class methodsFor: 'instance creation' stamp: 'KLG 1/18/2022 14:43:54'!
withConfiguration: aConfigurationSpecifier
	"Answer a new forwarder with aConfigurationSpecifier,
	
	I aConfigurationSpecifier is a symbol send it to 'the configuration class."

	^ self new configuration: (
		aConfigurationSpecifier isSymbol
			ifTrue: [ self configurationClass perform: aConfigurationSpecifier ]
			ifFalse: [ aConfigurationSpecifier ]);
		yourself! !

!(Modules>>#SlowForward>>#SlowForwarder) class methodsFor: 'instance creation' stamp: 'KLG 1/18/2022 14:45:16'!
withPortWiseConfiguration: aPortWiseConfigurationSpecifier
	"Answer a new forwarder with aPortWiseConfigurationSpecifier,
	
	I aConfigurationSpecifier is a symbol send it to 'the configuration class."

	^ self new configuration: (
		aPortWiseConfigurationSpecifier isSymbol
			ifTrue: [ self portWiseConfigurationClass perform: aPortWiseConfigurationSpecifier ]
			ifFalse: [ aPortWiseConfigurationSpecifier ]);
		yourself! !

!(Modules>>#SlowForward>>#SlowForwarder) class methodsFor: 'accessing' stamp: 'KLG 12/9/2021 21:14:13'!
forwarderCloseHook
	"Answer the value of forwarderCloseHook"

	^ forwarderCloseHook ifNil: [ [ :someCommunicationData | ] ]! !

!(Modules>>#SlowForward>>#SlowForwarder) class methodsFor: 'accessing' stamp: 'KLG 12/9/2021 21:12:49'!
forwarderCloseHook: aBlock
	"A hook evaluated when a forwarder closes."

	| answer |
	answer _ forwarderCloseHook.
	forwarderCloseHook _ aBlock.
	^ answer! !

!(Modules>>#SlowForward>>#SMTPForwarder) methodsFor: 'instance creation' stamp: 'KLG 11/26/2021 14:26:05'!
forwarderClassForRemoteAddress: aRemoteAddress.
	"Answer the forwarder class for a remote address."

	^ self reputationForAddress: aRemoteAddress ::
		forwarderClass! !

!(Modules>>#SlowForward>>#SMTPForwarder) methodsFor: 'access - referee' stamp: 'KLG 12/6/2021 01:46:20'!
addIngressLine: anIngressLine to: aReferee
	"Queue the action to provide guarded access."

	pendingActions nextPut: [
		aReferee addIngressLine: anIngressLine ]! !

!(Modules>>#SlowForward>>#SMTPForwarder) methodsFor: 'access - referee' stamp: 'KLG 12/6/2021 01:47:08'!
addOutgressLine: anOutgressLine to: aReferee
	"Queue the action to provide guarded access."

	pendingActions nextPut: [
		aReferee addOutgressILine: anOutgressLine ]! !

!(Modules>>#SlowForward>>#SMTPForwarder) class methodsFor: 'instance creation' stamp: 'KLG 11/9/2021 12:12:46'!
listenEndPointClass
	"Answer the listen endpoint class."
	
	^ SMTPEndPoint! !

!(Modules>>#SlowForward>>#SMTPForwarder) class methodsFor: 'application start' stamp: 'KLG 12/7/2021 20:55:04'!
deactivateApplication
	"Remove me as application."

	Smalltalk removeKey: self globalClassname ifAbsent: []! !

!(Modules>>#SlowForward>>#SMTPForwarder) class methodsFor: 'application start' stamp: 'KLG 12/7/2021 20:55:04'!
globalClassname

	^ #ForwardingApp! !

!(Modules>>#SlowForward>>#SMTPForwarder) class methodsFor: 'application start' stamp: 'KLG 1/19/2022 11:39:41'!
installAsApplication
	"Install me as application."

	| globalClassname |
	Smalltalk at: (globalClassname _ self globalClassname) put: self.
	AppLauncher appGlobalName: globalClassname appSelector: #start:! !

!(Modules>>#SlowForward>>#SMTPForwarder) class methodsFor: 'application start' stamp: 'KLG 2/2/2022 18:04:19'!
start: aConfigurationSelector
	"Start the forwarder as an application."

	| configurationSelector |
	self installTracer: true.
	configurationSelector _ aConfigurationSelector 
		ifNotNil: [
			self configurationClass respondsTo: aConfigurationSelector asSymbol :: 
				ifTrue: [ aConfigurationSelector asSymbol ]
				ifFalse: [ #defaultConfiguration ] ]
		ifNil: [ #defaultConfiguration ].
	application ifNotNil: [ application kill ].
	Tracer trace: [ :out |
		out 
			show: 'Configuration selector: ';
			show: configurationSelector storeString ].
	(application _ self withPortWiseConfiguration: configurationSelector)
		 open! !

!SocketStream methodsFor: '*SlowForward-stream in' stamp: 'KLG 2/20/2022 18:16:52'!
nextReceivable
	"Answer all the data currently receivable,
	in buffer and in socket.
	Block if there is no data receivable."

	"Receive available data, as we want to answer as much data as possible."
	self receiveAvailableData.
	"Block, to avoid any busy loops."
	self isInBufferEmpty ifTrue: [ self receiveData ].
	^ self nextAllInBuffer! !
(Modules>>#SlowForward>>#AbstractProtocolMatcher) initialize!
(Modules>>#SlowForward>>#SlowForwarder) initialize!
