'From Haver 6.0 [latest update: #5041] on 6 January 2022 at 11:18:06 pm'!
'Description I contain the tests for our slow TCP forwarder.'!
!provides: 'SlowForwardTest' 1 5!
!requires: 'SlowForward' 1 35 nil!
SystemOrganization addCategory: 'SlowForwardTest'!


!moduleCreation: SlowForwardTest!
Modules newEnvironment: #SlowForwardTest!

!interfacesOf: SlowForwardTest!
Modules environment: #SlowForwardTest ::
	interface: #SPI aliasFor: #API ::
	interface: #UTI aliasFor: #API!

!importsOf: SlowForwardTest!
Modules environment: #SlowForwardTest :: 
	import: #(#SMTPReferee #SimpleProtocolPattern #SlowForwarder #SMTPForwarder ) from: #UTI of: Modules>>#SlowForward!

!classDefinition: (Modules>>#SlowForwardTest>>#CreationTestCase) category: 'SlowForwardTest'!
TestCase subclass: #CreationTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlowForwardTest'
	inModule: #SlowForwardTest!
!classDefinition: (Modules>>#SlowForwardTest>>#CreationTestCase) class category: 'SlowForwardTest'!
(Modules>>#SlowForwardTest>>#CreationTestCase) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#SlowForwardTest>>#OpenCloseTestCase) category: 'SlowForwardTest'!
TestCase subclass: #OpenCloseTestCase
	instanceVariableNames: 'forwarder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlowForwardTest'
	inModule: #SlowForwardTest!
!classDefinition: (Modules>>#SlowForwardTest>>#OpenCloseTestCase) class category: 'SlowForwardTest'!
(Modules>>#SlowForwardTest>>#OpenCloseTestCase) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#SlowForwardTest>>#SimpleProtocolPatternTestCase) category: 'SlowForwardTest'!
TestCase subclass: #SimpleProtocolPatternTestCase
	instanceVariableNames: 'patternRule referee'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlowForwardTest'
	inModule: #SlowForwardTest!
!classDefinition: (Modules>>#SlowForwardTest>>#SimpleProtocolPatternTestCase) class category: 'SlowForwardTest'!
(Modules>>#SlowForwardTest>>#SimpleProtocolPatternTestCase) class
	instanceVariableNames: ''!


!(Modules>>#SlowForwardTest>>#CreationTestCase) commentStamp: '<historical>' prior: 0!
I test the creation of slow forwarders.!

!(Modules>>#SlowForwardTest>>#OpenCloseTestCase) commentStamp: '<historical>' prior: 0!
I test opening and closing a forwarder.!

!(Modules>>#SlowForwardTest>>#CreationTestCase) methodsFor: 'testing' stamp: 'KLG 11/5/2021 22:47:22'!
testSimpleCreation
	"Just test the creation of a forwrder."

	| forwarder |
	forwarder _ SMTPForwarder new.
	self assert: (forwarder isKindOf: SlowForwarder)! !

!(Modules>>#SlowForwardTest>>#OpenCloseTestCase) methodsFor: 'testing' stamp: 'KLG 11/5/2021 23:30:50'!
testOpenClose
	"Open and close the forwarder."

	forwarder open.
	self assert: forwarder isOpen.
	forwarder close! !

!(Modules>>#SlowForwardTest>>#OpenCloseTestCase) methodsFor: 'setUp/tearDown' stamp: 'KLG 11/5/2021 23:28:01'!
setUp
	"Create the forwarder."

	super setUp.
	forwarder _ SMTPForwarder new! !

!(Modules>>#SlowForwardTest>>#SimpleProtocolPatternTestCase) methodsFor: 'setUp/tearDown' stamp: 'KLG 12/7/2021 11:55:47'!
addMultipleRecipientsMailSendSequence

	^ referee
		addResponseLine: '220 mail.klix.ch ESMTP TestMTA ', DateAndTime now printString;
		addRequestLine: 'ehlo sepp.it';
		addResponseLine: '250-mail.klix.ch Hello kasperl.it [192.168.42.42]';
		addResponseLine: '250-SIZE 52428800';
		addResponseLine: '250-8BITMIME';
		addResponseLine: '250-PIPELINING';
		addResponseLine: '250-AUTH LOGIN';
		addResponseLine: '250-CHUNKING';
		addResponseLine: '250-STARTTLS';
		addResponseLine: '250 HELP';
		addRequestLine: 'mail FROM:<dumm-baer@sepp.it> size=4';
		addResponseLine: '250 OK';
		addRequestLine: 'rcpt TO:<heini@sepp.it>';
		addResponseLine: '250 Accepted';
		addRequestLine: 'rcpt TO:<birnbaum@sepp.it>';
		addResponseLine: '250 Accepted';
		addRequestLine: 'data';
		addResponseLine: '354 Enter message, ending with "." on a line by itself';
		addDataLine: 'Test';
		addDataLine: '.';
		addResponseLine: '250 OK id=4711';
		addRequestLine: 'QUIT';
		addResponseLine: '221 mail.klix.ch closing connection'! !

!(Modules>>#SlowForwardTest>>#SimpleProtocolPatternTestCase) methodsFor: 'setUp/tearDown' stamp: 'KLG 12/4/2021 17:03:09'!
addQuitSequence

	^ referee
		addResponseLine: '220 mail.klix.ch ESMTP TestMTA ', DateAndTime now printString;
		addRequestLine: 'QUIT';
		addResponseLine: '221 mail.klix.ch closing connection'! !

!(Modules>>#SlowForwardTest>>#SimpleProtocolPatternTestCase) methodsFor: 'setUp/tearDown' stamp: 'KLG 12/4/2021 16:08:31'!
addSimpleMailSendSequence

	^ referee
		addResponseLine: '220 mail.klix.ch ESMTP TestMTA ', DateAndTime now printString;
		addRequestLine: 'ehlo sepp.it';
		addResponseLine: '250-mail.klix.ch Hello kasperl.it [192.168.42.42]';
		addResponseLine: '250-SIZE 52428800';
		addResponseLine: '250-8BITMIME';
		addResponseLine: '250-PIPELINING';
		addResponseLine: '250-AUTH LOGIN';
		addResponseLine: '250-CHUNKING';
		addResponseLine: '250-STARTTLS';
		addResponseLine: '250 HELP';
		addRequestLine: 'mail FROM:<dumm-baer@sepp.it> size=4';
		addResponseLine: '250 OK';
		addRequestLine: 'rcpt TO:<heini@sepp.it>';
		addResponseLine: '250 Accepted';
		addRequestLine: 'data';
		addResponseLine: '354 Enter message, ending with "." on a line by itself';
		addDataLine: 'Test';
		addDataLine: '.';
		addResponseLine: '250 OK id=4711';
		addRequestLine: 'QUIT';
		addResponseLine: '221 mail.klix.ch closing connection'! !

!(Modules>>#SlowForwardTest>>#SimpleProtocolPatternTestCase) methodsFor: 'setUp/tearDown' stamp: 'KLG 12/4/2021 20:34:01'!
setUp
	"Setup a simple pattern rule."

	super setUp.
	referee _ SMTPReferee new.
	patternRule _ SimpleProtocolPattern
		forReferee: referee
		andBenchmark: #justQuit
		andScoreBlock: [ :resultScore |
			self
				assert: 1
				equals: resultScore ].! !

!(Modules>>#SlowForwardTest>>#SimpleProtocolPatternTestCase) methodsFor: 'testing' stamp: 'KLG 12/4/2021 17:04:41'!
testCommunicationTracking
	"Check that we can add communication items to the referee."

	self addQuitSequence.
	self 
		assert: 220 equals:  (referee communicationItemAt: 1 :: code);
		assert: 'QUIT' equals: (referee communicationItemAt: 2 :: keyword);
		assert: 221 equals:  (referee communicationItemAt: 3 :: code)! !

!(Modules>>#SlowForwardTest>>#SimpleProtocolPatternTestCase) methodsFor: 'testing' stamp: 'KLG 12/4/2021 13:15:48'!
testCreation
	"Make sure that we can create such a thing."

	self
		assert: (patternRule isKindOf: SimpleProtocolPattern);
		assert: (referee isKindOf: SMTPReferee)
	! !

!(Modules>>#SlowForwardTest>>#SimpleProtocolPatternTestCase) methodsFor: 'testing' stamp: 'KLG 12/7/2021 11:56:43'!
testMultipleRecipientsMailSendSequence
	"Test the evaluation of a referee. for simple case"

	self addMultipleRecipientsMailSendSequence.
	referee evaluate.
	self assert: 100 equals: referee score! !

!(Modules>>#SlowForwardTest>>#SimpleProtocolPatternTestCase) methodsFor: 'testing' stamp: 'KLG 12/7/2021 12:36:42'!
testNormalMailSendRefereeEvaluation
	"Test the evaluation of a referee. for simple case"

	self addSimpleMailSendSequence .
	referee evaluate.
	"The score is 200, becuase to patterns match."
	self assert: 200 equals: referee score! !

!(Modules>>#SlowForwardTest>>#SimpleProtocolPatternTestCase) methodsFor: 'testing' stamp: 'KLG 1/6/2022 15:17:59'!
testRefereeEvaluation
	"Test the evaluation of a referee."

	self addQuitSequence.
	referee evaluate.
	self assert: 91 equals: referee score! !

!(Modules>>#SlowForwardTest>>#SimpleProtocolPatternTestCase) methodsFor: 'testing' stamp: 'KLG 1/6/2022 15:18:22'!
testSimpleRefereeEvaluation
	"Test the evaluation of a referee. for simple case"

	self addQuitSequence.
	referee evaluate.
	self assert: 91 equals: referee score! !
