'From Haver 6.0 [latest update: #5087] on 25 February 2022 at 3:19:38 pm'!
'Description Test PlanE.'!
!provides: 'PlanETest' 1 29!
!requires: 'PlanE' 1 46 nil!
SystemOrganization addCategory: 'PlanETest'!


!moduleCreation: PlanETest!
Modules newEnvironment: #PlanETest!

!interfacesOf: PlanETest!
Modules environment: #PlanETest ::
	interface: #UTI aliasFor: #API ::
	interface: #SPI aliasFor: #API!

!importsOf: PlanETest!
Modules environment: #PlanETest :: 
	import: #(#PersistentObject #PlanE #StoreRecord #FileStore ) from: #UTI of: Modules>>#PlanE!

!classDefinition: (Modules>>#PlanETest>>#PlanEShakeDownTest) category: 'PlanETest'!
TestCase subclass: #PlanEShakeDownTest
	instanceVariableNames: 'store testFilename'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlanETest'
	inModule: #PlanETest!
!classDefinition: (Modules>>#PlanETest>>#PlanEShakeDownTest) class category: 'PlanETest'!
(Modules>>#PlanETest>>#PlanEShakeDownTest) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#PlanETest>>#PlanETransactionTest) category: 'PlanETest'!
TestCase subclass: #PlanETransactionTest
	instanceVariableNames: 'testFilename planE'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlanETest'
	inModule: #PlanETest!
!classDefinition: (Modules>>#PlanETest>>#PlanETransactionTest) class category: 'PlanETest'!
(Modules>>#PlanETest>>#PlanETransactionTest) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#PlanETest>>#PeristentTestObject) category: 'PlanETest'!
(Modules>>#PlanE>>#PersistentObject) subclass: #PeristentTestObject
	instanceVariableNames: 'iv0 iv1'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlanETest'
	inModule: #PlanETest!
!classDefinition: (Modules>>#PlanETest>>#PeristentTestObject) class category: 'PlanETest'!
(Modules>>#PlanETest>>#PeristentTestObject) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#PlanETest>>#ATC) category: 'PlanETest'!
Object subclass: #ATC
	instanceVariableNames: 'a b'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlanETest'
	inModule: #PlanETest!
!classDefinition: (Modules>>#PlanETest>>#ATC) class category: 'PlanETest'!
(Modules>>#PlanETest>>#ATC) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#PlanETest>>#TC1) category: 'PlanETest'!
(Modules>>#PlanETest>>#ATC) subclass: #TC1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlanETest'
	inModule: #PlanETest!
!classDefinition: (Modules>>#PlanETest>>#TC1) class category: 'PlanETest'!
(Modules>>#PlanETest>>#TC1) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#PlanETest>>#TC2) category: 'PlanETest'!
(Modules>>#PlanETest>>#ATC) subclass: #TC2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlanETest'
	inModule: #PlanETest!
!classDefinition: (Modules>>#PlanETest>>#TC2) class category: 'PlanETest'!
(Modules>>#PlanETest>>#TC2) class
	instanceVariableNames: ''!


!(Modules>>#PlanETest>>#PlanETransactionTest) commentStamp: '<historical>' prior: 0!
I test transactions in PlanE.!

!(Modules>>#PlanETest>>#PeristentTestObject) commentStamp: '<historical>' prior: 0!
I am a persistent test object.!

!(Modules>>#PlanETest>>#TC1) commentStamp: '<historical>' prior: 0!
A test class to store instances into a store.!

!(Modules>>#PlanETest>>#PlanEShakeDownTest) methodsFor: 'setUp/tearDown' stamp: 'KLG 5/15/2021 21:19:53'!
openStore
	"Open the store."

	store _ FileStore openOn: testFilename! !

!(Modules>>#PlanETest>>#PlanEShakeDownTest) methodsFor: 'setUp/tearDown' stamp: 'KLG 5/18/2021 13:56:08'!
reOpenStore
	"Reopen the store."

	store isOpen ifTrue: [ store close ].
	store _ FileStore openOn: testFilename! !

!(Modules>>#PlanETest>>#PlanEShakeDownTest) methodsFor: 'setUp/tearDown' stamp: 'KLG 5/16/2021 19:53:10'!
setUp
	"Create a new file store."

	super setUp.
	(testFilename _ 'unitTest.planE' asFileEntry) exists ifTrue: [
		testFilename delete ].
	self openStore! !

!(Modules>>#PlanETest>>#PlanEShakeDownTest) methodsFor: 'setUp/tearDown' stamp: 'KLG 5/16/2021 19:49:50'!
tearDown
	"Close the database."

	store close.
	super tearDown! !

!(Modules>>#PlanETest>>#PlanEShakeDownTest) methodsFor: 'testing' stamp: 'KLG 5/15/2021 21:06:28'!
testCreation
	"Just try to create a store and check its first record."

	self assert: (store loadObjectAt: 0 :: isKindOf: StoreRecord)! !

!(Modules>>#PlanETest>>#PlanEShakeDownTest) methodsFor: 'testing' stamp: 'KLG 5/17/2021 20:27:21'!
testRootSimple
	"Test storing string as root object"

	| objectToBeStored objectLoaded |
	store 
		root: (objectToBeStored _ 'tt tt');
		close.
	self openStore.
	objectLoaded _ store root.
	self assert: objectToBeStored equals: objectLoaded! !

!(Modules>>#PlanETest>>#PlanEShakeDownTest) methodsFor: 'testing' stamp: 'KLG 5/17/2021 20:27:45'!
testRootWithTestClass
	"Test storing string as root object"

	| objectToBeStored objectLoaded |
	store 
		root: (objectToBeStored _ TC1 new);
		close.
	self openStore.
	objectLoaded _ store root.
	self assert: objectToBeStored equals: objectLoaded! !

!(Modules>>#PlanETest>>#PlanEShakeDownTest) methodsFor: 'testing' stamp: 'KLG 5/18/2021 13:56:33'!
testRootsWith2TestClasses
	"Test storing two test class instances in the roorts"

	| objectToBeStored1 objectToBeStored2 objectLoaded |
	store 
		rootAt: 1 put: (objectToBeStored1 _ TC1 new);
		rootAt: 2 put: (objectToBeStored2 _ TC2 new).
	self reOpenStore.
	objectLoaded _ store root.
	self assert: objectToBeStored1 equals: objectLoaded.
	objectLoaded _ store rootAt: 2.
	self assert: objectToBeStored2 equals: objectLoaded.! !

!(Modules>>#PlanETest>>#PlanEShakeDownTest) methodsFor: 'testing' stamp: 'KLG 5/21/2021 18:21:54'!
testRootsWith3TestClasses
	"Test storing two test class instances in the roorts"

	| objectToBeStored1 objectToBeStored2 objectLoaded lastRoot |
	store 
		rootAt: 1 put: (objectToBeStored1 _ TC1 new);
		rootAt: 2 put: (objectToBeStored2 _ TC2 new);
		rootAt: 3 put: (lastRoot _ 1 to: 2 :: asArray).
	self reOpenStore.
	objectLoaded _ store root.
	self assert: objectToBeStored1 equals: objectLoaded.
	objectLoaded _ store rootAt: 2.
	self assert: objectToBeStored2 equals: objectLoaded.
	self assert: lastRoot equals: (store rootAt: 3)! !

!(Modules>>#PlanETest>>#PlanEShakeDownTest) methodsFor: 'testing' stamp: 'KLG 5/22/2021 17:37:50'!
testRootsWithRootAt3
	"Test storing two test class instances in the roorts"

	| lastRoot |
	store rootAt: 3 put: (lastRoot _ 1 to: 100 :: asArray).
	self reOpenStore.
	self assert: lastRoot equals: (store rootAt: 3)! !

!(Modules>>#PlanETest>>#PlanEShakeDownTest) methodsFor: 'testing' stamp: 'KLG 5/19/2021 14:49:33'!
testStoreALocalSymbol
	"Test to store an local symbol."

	| position symbol symbolString environment |
	symbolString _ 'localSymbol', (Random 
		withDefaultDo: [ :random | random nextInteger: 1000000 ] :: asString).
	symbol _ Symbol new: symbolString size :: string: symbolString.
	symbol _ symbol forEnvironment: (environment _ 'Environment').
	self assert: symbol isSymbol.
	position _ store dumpObject: symbol.
	self assert: symbol asString equals: (store loadObjectAt: position) asString.
	self reOpenStore.
	self assert: symbol asString equals: (store loadObjectAt: position) asString.
	self assert: (store loadObjectAt: position) isSymbol.
	Symbol hasInterned: (store loadObjectAt: position) ifTrue: [ :ignoredString |
		self failWith: 'Symbol is interned' ].
	self assert: environment equals: (store loadObjectAt: position) environment ! !

!(Modules>>#PlanETest>>#PlanEShakeDownTest) methodsFor: 'testing' stamp: 'KLG 5/15/2021 21:12:03'!
testStoreAString
	"Test to store a string."

	| position string |
	position _ store dumpObject: (string _ 'Some funny words!!').
	self assert: string equals: (store loadObjectAt: position).
	self assert: string equals: (store rawLoadObjectAt: position)! !

!(Modules>>#PlanETest>>#PlanEShakeDownTest) methodsFor: 'testing' stamp: 'KLG 5/19/2021 14:07:43'!
testStoreAnInternedSymbol
	"Test to store an interned symbol."

	| position symbol |
	position _ store dumpObject: (symbol _ #hackIt).
	self assert: symbol equals: (store loadObjectAt: position).
	self assert: (store rawLoadObjectAt: position) isSymbol.
	self assert: symbol equals: (store rawLoadObjectAt: position).
	self reOpenStore.
	self 
		assert: (store loadObjectAt: position) isSymbol;
		assert: symbol equals: (store loadObjectAt: position)! !

!(Modules>>#PlanETest>>#PlanEShakeDownTest) methodsFor: 'testing' stamp: 'KLG 5/19/2021 14:50:16'!
testStoreAnUninternedSymbol
	"Test to store an uninterned symbol."

	| position symbol symbolString |
	symbolString _ 'uninternedSymbol', (Random 
		withDefaultDo: [ :random | random nextInteger: 1000000 ] :: asString).
	symbol _ Symbol new: symbolString size :: string: symbolString.
	self assert: symbol isSymbol.
	position _ store dumpObject: symbol.
	self assert: symbol asString equals: (store loadObjectAt: position) asString.
	self reOpenStore.
	self assert: symbol asString equals: (store loadObjectAt: position) asString.
	self assert: (store loadObjectAt: position) isSymbol.
	Symbol hasInterned: (store loadObjectAt: position) ifTrue: [ :ignoredString |
		self failWith: 'Symbol is interned' ]! !

!(Modules>>#PlanETest>>#PlanEShakeDownTest) methodsFor: 'testing' stamp: 'KLG 5/18/2021 21:22:35'!
testStoringABag

	| position objectToBeStored objectLoaded |
	position _ 	store dumpObject: (objectToBeStored _ #(42 4711) asBag).
	self reOpenStore.
	objectLoaded _ store loadObjectAt: position.
	self assert: objectToBeStored equals: objectLoaded ! !

!(Modules>>#PlanETest>>#PlanEShakeDownTest) methodsFor: 'testing' stamp: 'KLG 5/18/2021 13:57:04'!
testStoringABaseClass
	"Test storing a class in the Cuis base image."

	| position objectToBeStored objectLoaded |
	position _ 	store dumpObject: (objectToBeStored _ ActiveModel).
	self reOpenStore.
	objectLoaded _ store loadObjectAt: position.
	self assert: objectToBeStored equals: objectLoaded! !

!(Modules>>#PlanETest>>#PlanEShakeDownTest) methodsFor: 'testing' stamp: 'KLG 5/18/2021 14:43:07'!
testStoringABigArray

	| position objectToBeStored objectLoaded |
	position _ 	store dumpObject: (objectToBeStored _ 1 to: 10000 :: as: Array).
	store close.
	self reOpenStore.
	objectLoaded _ store loadObjectAt: position.
	self assert: objectToBeStored equals: objectLoaded! !

!(Modules>>#PlanETest>>#PlanEShakeDownTest) methodsFor: 'testing' stamp: 'KLG 5/18/2021 14:07:50'!
testStoringABigWordArray

	| position objectToBeStored objectLoaded |
	position _ 	store dumpObject: (objectToBeStored _ 1 to: 1000000 :: as: WordArray).
	store close.
	self reOpenStore.
	objectLoaded _ store loadObjectAt: position.
	self assert: objectToBeStored equals: objectLoaded! !

!(Modules>>#PlanETest>>#PlanEShakeDownTest) methodsFor: 'testing' stamp: 'KLG 5/18/2021 13:57:14'!
testStoringAByteArray

	| position objectToBeStored objectLoaded |
	position _ 	store dumpObject: (objectToBeStored _ #[42 47 11]).
	self reOpenStore.
	objectLoaded _ store loadObjectAt: position.
	self assert: objectToBeStored equals: objectLoaded! !

!(Modules>>#PlanETest>>#PlanEShakeDownTest) methodsFor: 'testing' stamp: 'KLG 5/18/2021 13:57:28'!
testStoringAClass
	"Test storing a class in a package (and an environment."

	| position objectToBeStored objectLoaded |
	position _ 	store dumpObject: (objectToBeStored _ TC1).
	self reOpenStore.
	objectLoaded _ store loadObjectAt: position.
	self assert: objectToBeStored equals: objectLoaded! !

!(Modules>>#PlanETest>>#PlanEShakeDownTest) methodsFor: 'testing' stamp: 'KLG 5/18/2021 13:57:42'!
testStoringAClassNoFixUps
	"Test storing a class in a package avoid fixups."

	| position objectToBeStored objectLoaded |
	store
		dumpObject: #Modules;
		dumpObject: TC1 package;
		dumpObject: #PlanETest.
	position _ 	store dumpObject: (objectToBeStored _ TC1).
	self reOpenStore.
	objectLoaded _ store loadObjectAt: position.
	self assert: objectToBeStored equals: objectLoaded! !

!(Modules>>#PlanETest>>#PlanEShakeDownTest) methodsFor: 'testing' stamp: 'KLG 5/18/2021 13:57:54'!
testStoringACodePackage
	"Test storing a code package."

	| position objectToBeStored objectLoaded |
	position _ 	store dumpObject: (objectToBeStored _ CodePackage installedPackages anyOne).
	self reOpenStore.
	objectLoaded _ store loadObjectAt: position.
	self assert: objectToBeStored equals: objectLoaded! !

!(Modules>>#PlanETest>>#PlanEShakeDownTest) methodsFor: 'testing' stamp: 'KLG 5/22/2021 18:03:05'!
testStoringACompiledMethod

	| position objectToBeStored objectLoaded |
	position _ 	store dumpObject: (objectToBeStored _ Array>>#is:).
	self reOpenStore.
	objectLoaded _ store loadObjectAt: position.
	self assert: objectToBeStored equals: objectLoaded! !

!(Modules>>#PlanETest>>#PlanEShakeDownTest) methodsFor: 'testing' stamp: 'KLG 5/18/2021 13:58:05'!
testStoringADictionary

	| position objectToBeStored objectLoaded |
	position _ 	store dumpObject: (objectToBeStored _ {#a ->1. #n -> 2} asDictionary).
	self reOpenStore.
	objectLoaded _ store loadObjectAt: position.
	self assert: objectToBeStored equals: objectLoaded! !

!(Modules>>#PlanETest>>#PlanEShakeDownTest) methodsFor: 'testing' stamp: 'KLG 5/18/2021 13:58:18'!
testStoringADoubleByteArray

	| position objectToBeStored objectLoaded |
	position _ 	store dumpObject: (objectToBeStored _ DoubleByteArray with: 47 with: 1).
	self reOpenStore.
	objectLoaded _ store loadObjectAt: position.
	self assert: objectToBeStored equals: objectLoaded! !

!(Modules>>#PlanETest>>#PlanEShakeDownTest) methodsFor: 'testing' stamp: 'KLG 5/18/2021 14:42:27'!
testStoringADoubleWordArray

	| position objectToBeStored objectLoaded |
	position _ 	store dumpObject: (objectToBeStored _ DoubleWordArray with: 47 with: 1).
	self reOpenStore.
	objectLoaded _ store loadObjectAt: position.
	self assert: objectToBeStored equals: objectLoaded! !

!(Modules>>#PlanETest>>#PlanEShakeDownTest) methodsFor: 'testing' stamp: 'KLG 5/18/2021 13:58:40'!
testStoringAFloat

	| position objectToBeStored objectLoaded |
	position _ 	store dumpObject: (objectToBeStored _ 12.34).
	self reOpenStore.
	objectLoaded _ store loadObjectAt: position.
	self assert: objectToBeStored equals: objectLoaded! !

!(Modules>>#PlanETest>>#PlanEShakeDownTest) methodsFor: 'testing' stamp: 'KLG 5/18/2021 13:58:52'!
testStoringALargeNegativeInteger

	| position objectToBeStored objectLoaded |
	position _ 	store dumpObject: (objectToBeStored _ -123467989090094309430349).
	self reOpenStore.
	objectLoaded _ store loadObjectAt: position.
	self assert: objectToBeStored equals: objectLoaded! !

!(Modules>>#PlanETest>>#PlanEShakeDownTest) methodsFor: 'testing' stamp: 'KLG 5/18/2021 13:59:01'!
testStoringALargePositiveInteger

	| position objectToBeStored objectLoaded |
	position _ 	store dumpObject: (objectToBeStored _ 123467989090094309430349).
	self reOpenStore.
	objectLoaded _ store loadObjectAt: position.
	self assert: objectToBeStored equals: objectLoaded! !

!(Modules>>#PlanETest>>#PlanEShakeDownTest) methodsFor: 'testing' stamp: 'KLG 5/18/2021 13:59:11'!
testStoringAModule
	"Test storing a module."

	| position objectToBeStored objectLoaded |
	position _ 	store dumpObject: (objectToBeStored _ Modules >> #ActionBuilder).
	self reOpenStore.
	objectLoaded _ store loadObjectAt: position.
	self assert: objectToBeStored equals: objectLoaded! !

!(Modules>>#PlanETest>>#PlanEShakeDownTest) methodsFor: 'testing' stamp: 'KLG 5/18/2021 14:00:49'!
testStoringARange

	| position objectToBeStored objectLoaded |
	position _ 	store dumpObject: (objectToBeStored _ 1 to: 1000).
	store close.
	self reOpenStore.
	objectLoaded _ store loadObjectAt: position.
	self assert: objectToBeStored equals: objectLoaded! !

!(Modules>>#PlanETest>>#PlanEShakeDownTest) methodsFor: 'testing' stamp: 'KLG 5/19/2021 11:36:12'!
testStoringARecursiveObject

	| position objectToBeStored objectLoaded |
	objectToBeStored _ Array new: 1.
	objectToBeStored at: 1 put: objectToBeStored.
	position _ 	store dumpObject: objectToBeStored.
	self reOpenStore.
	objectLoaded _ store loadObjectAt: position.
	self assert: objectToBeStored class equals: objectLoaded class.
	self assert: objectToBeStored == (objectToBeStored at: 1)! !

!(Modules>>#PlanETest>>#PlanEShakeDownTest) methodsFor: 'testing' stamp: 'KLG 5/18/2021 13:59:22'!
testStoringASet

	| position objectToBeStored objectLoaded |
	position _ 	store dumpObject: (objectToBeStored _ #(42 4711) asSet).
	self reOpenStore.
	objectLoaded _ store loadObjectAt: position.
	self assert: objectToBeStored equals: objectLoaded! !

!(Modules>>#PlanETest>>#PlanEShakeDownTest) methodsFor: 'testing' stamp: 'KLG 5/18/2021 13:59:32'!
testStoringASmallInteger

	| position objectToBeStored objectLoaded |
	position _ 	store dumpObject: (objectToBeStored _ -42).
	self reOpenStore.
	objectLoaded _ store loadObjectAt: position.
	self assert: objectToBeStored equals: objectLoaded! !

!(Modules>>#PlanETest>>#PlanEShakeDownTest) methodsFor: 'testing' stamp: 'KLG 5/18/2021 22:57:26'!
testStoringASystemDictionary

	| position objectToBeStored objectLoaded |
	objectToBeStored _ SystemDictionary new.
	objectToBeStored
		at: #A put: Smalltalk;
		at: #B put: 'Bh'.
	position _ 	store dumpObject: objectToBeStored.
	self reOpenStore.
	objectLoaded _ store loadObjectAt: position.
	self assert: objectToBeStored equals: objectLoaded! !

!(Modules>>#PlanETest>>#PlanEShakeDownTest) methodsFor: 'testing' stamp: 'KLG 5/18/2021 13:59:42'!
testStoringAWordArray

	| position objectToBeStored objectLoaded |
	position _ 	store dumpObject: (objectToBeStored _ WordArray with: 47 with: 1).
	self reOpenStore.
	objectLoaded _ store loadObjectAt: position.
	self assert: objectToBeStored equals: objectLoaded! !

!(Modules>>#PlanETest>>#PlanEShakeDownTest) methodsFor: 'testing' stamp: 'KLG 2/22/2022 10:19:18'!
testStoringAWorldMorph
	"Test storing a WorldMoprh."

	| position objectToBeStored objectLoaded |
	position _ 	store dumpObject: (objectToBeStored _ WorldMorph new).
	self reOpenStore.
	objectLoaded _ store loadObjectAt: position.
	self shouldFail: [
		self
			assert: objectLoaded isWorldMorph;
			assert: objectToBeStored submorphs equals: objectLoaded submorphs;
			assert: objectToBeStored morphExtent equals: objectLoaded morphExtent;
			assert: objectToBeStored morphPosition equals: objectLoaded morphPosition ]! !

!(Modules>>#PlanETest>>#PlanEShakeDownTest) methodsFor: 'testing' stamp: 'KLG 5/18/2021 13:59:52'!
testStoringAnArray

	| position objectToBeStored objectLoaded |
	position _ 	store dumpObject: (objectToBeStored _ #(42 4711)).
	self reOpenStore.
	objectLoaded _ store loadObjectAt: position.
	self assert: objectToBeStored equals: objectLoaded! !

!(Modules>>#PlanETest>>#PlanEShakeDownTest) methodsFor: 'testing' stamp: 'KLG 5/18/2021 14:00:00'!
testStoringAnEnvironment
	"Test storing an environment."

	| position objectToBeStored objectLoaded |
	position _ 	store dumpObject: (objectToBeStored _ Environments >> #Modules).
	self reOpenStore.
	objectLoaded _ store loadObjectAt: position.
	self assert: objectToBeStored equals: objectLoaded! !

!(Modules>>#PlanETest>>#PlanEShakeDownTest) methodsFor: 'testing' stamp: 'KLG 5/18/2021 14:00:14'!
testStoringAnInstance
	"Test storing a simple instance."

	| position objectToBeStored objectLoaded |
	position _ 	store dumpObject: (objectToBeStored _ TC1 new).
	self reOpenStore.
	objectLoaded _ store loadObjectAt: position.
	self assert: objectToBeStored equals: objectLoaded! !

!(Modules>>#PlanETest>>#PlanEShakeDownTest) methodsFor: 'testing' stamp: 'KLG 5/18/2021 14:00:24'!
testStoringAnOrderedCollection

	| position objectToBeStored objectLoaded |
	position _ 	store dumpObject: (objectToBeStored _ OrderedCollection with: 1 with: 42).
	store close.
	self reOpenStore.
	objectLoaded _ store loadObjectAt: position.
	self assert: objectToBeStored equals: objectLoaded! !

!(Modules>>#PlanETest>>#PlanEShakeDownTest) methodsFor: 'testing' stamp: 'KLG 5/18/2021 22:28:08'!
testStoringSmalltalk

	| position objectToBeStored objectLoaded |
	position _ 	store dumpObject: (objectToBeStored _ Smalltalk).
	self reOpenStore.
	objectLoaded _ store loadObjectAt: position.
	self assert: objectToBeStored equals: objectLoaded! !

!(Modules>>#PlanETest>>#PlanEShakeDownTest) methodsFor: 'testing' stamp: 'KLG 5/20/2021 16:21:54'!
testUpdateAString
	"Test to update a stored string.."

	| position string newPosition |
	position _ store dumpObject: (string _ '1: Other funny words!!' copy).
	self reOpenStore.
	self assert: string equals: (store loadObjectAt: position).
	string at: 1 put: $2.
	self assert: string ~= (store rawLoadObjectAt: position).	
	"Use an equal string loaded from the store for updates:"
	string _ store loadObjectAt: position.
	string at: 1 put: $3.
	store markObjectForUpdate: string.
	newPosition _ store dumpObject: string.
	self assert: position ~= newPosition.
	self assert: string equals: (store loadObjectAt: position).
	self reOpenStore.	
	self assert: string equals: (store loadObjectAt: position)! !

!(Modules>>#PlanETest>>#PlanEShakeDownTest) methodsFor: 'testing' stamp: 'KLG 5/20/2021 15:42:40'!
testUpdateAnInstance
	"Test to update aniInstance.."

	| position to newPosition |
	position _ store dumpObject: (to _ TC1 new).
	self reOpenStore.
	self assert: to equals: (store loadObjectAt: position).
	"We must update the newly loaded object, not this one!!"
	"O: to a: 1."
	to _ store loadObjectAt: position.
	to a: 1.
	store markObjectForUpdate: to.
	newPosition _ store dumpObject: to.
	self assert: position ~= newPosition.
	self assert: to equals: (store loadObjectAt: position).
	self reOpenStore.	
	self assert: to equals: (store loadObjectAt: position)! !

!(Modules>>#PlanETest>>#PlanETransactionTest) methodsFor: 'setUp/tearDown' stamp: 'KLG 5/21/2021 15:41:21'!
openInterface
	"Open the interface"

	planE _ PlanE openOn: testFilename ! !

!(Modules>>#PlanETest>>#PlanETransactionTest) methodsFor: 'setUp/tearDown' stamp: 'KLG 5/21/2021 17:22:07'!
reOpenInterface
	"Open the interface"

	planE ifNotNil: [ planE close ].
	self openInterface ! !

!(Modules>>#PlanETest>>#PlanETransactionTest) methodsFor: 'setUp/tearDown' stamp: 'KLG 5/21/2021 15:40:36'!
setUp
	"Create a new file store."

	super setUp.
	(testFilename _ 'transactionTest.planE' asFileEntry) exists ifTrue: [
		testFilename delete ].
	self openInterface! !

!(Modules>>#PlanETest>>#PlanETransactionTest) methodsFor: 'setUp/tearDown' stamp: 'KLG 5/21/2021 17:22:37'!
tearDown
	"Close the database."

	planE close.
	super tearDown! !

!(Modules>>#PlanETest>>#PlanETransactionTest) methodsFor: 'testing' stamp: 'KLG 2/25/2022 15:13:44'!
testCommit
	"Test commiting a transaction."

	| to newArray newObject loadedRoot |
	to _ PeristentTestObject forPlanE: planE.
	planE
		begin;
		root: to.
	to iv0: (newArray _ { newObject _ Object new }).
	self 
		assert: newArray equals: to iv0;
		assert: (planE isRegistered: newObject);
		assert: (planE isRegistered: newArray).
	newArray at: 1 put: (newObject _ 'One').
	self
		assert: (newArray at: 1) equals: newObject;
		assert: (planE isRegistered: newObject).
	planE commit.
	self
		assert: (newArray at: 1) equals: newObject;
		assert: (planE isRegistered: newObject).
	self assert: to equals: planE root.
	self reOpenInterface.
	self assert: ((loadedRoot _ planE root) isKindOf: PeristentTestObject).
	self assert: to equals: loadedRoot.
	self deny: to isReadOnlyObject.
	self deny: loadedRoot isReadOnlyObject.
	self deny: loadedRoot iv0 isReadOnlyObject.
	self deny: loadedRoot iv1 isReadOnlyObject.
	planE begin.
	self deny: to isReadOnlyObject.
	self assert: loadedRoot isReadOnlyObject.	
	self assert: loadedRoot iv0 isReadOnlyObject.
	self assert: [ loadedRoot iv1 isReadOnlyObject ].
	planE abort.
	self deny: to isReadOnlyObject.
	self deny: loadedRoot isReadOnlyObject.
	self deny: loadedRoot iv0 isReadOnlyObject.
	self deny: loadedRoot iv1 isReadOnlyObject.
	planE begin.
	self deny: to isReadOnlyObject.
	self should: loadedRoot isReadOnlyObject.	
	self should: loadedRoot iv0 isReadOnlyObject.
	self should: loadedRoot iv1 isReadOnlyObject.
	planE commit.
	self deny: to isReadOnlyObject.
	self deny: loadedRoot isReadOnlyObject.
	self deny: loadedRoot iv0 isReadOnlyObject.
	self deny: loadedRoot iv1 isReadOnlyObject
! !

!(Modules>>#PlanETest>>#PeristentTestObject) methodsFor: 'initialization' stamp: 'KLG 5/30/2021 23:56:36'!
initialize
	"Initialize our two instance variables."

	super initialize.
	iv0 _ OrderedCollection new.
	iv1 _ Set new! !

!(Modules>>#PlanETest>>#PeristentTestObject) methodsFor: 'accessing' stamp: 'KLG 5/30/2021 23:57:01'!
iv0
	"Answer the value of iv0"

	^ iv0! !

!(Modules>>#PlanETest>>#PeristentTestObject) methodsFor: 'accessing' stamp: 'KLG 5/30/2021 23:57:01'!
iv0: anObject
	"Set the value of iv0"

	iv0 _ anObject! !

!(Modules>>#PlanETest>>#PeristentTestObject) methodsFor: 'accessing' stamp: 'KLG 5/30/2021 23:57:01'!
iv1
	"Answer the value of iv1"

	^ iv1! !

!(Modules>>#PlanETest>>#PeristentTestObject) methodsFor: 'accessing' stamp: 'KLG 5/30/2021 23:57:01'!
iv1: anObject
	"Set the value of iv1"

	iv1 _ anObject! !

!(Modules>>#PlanETest>>#PeristentTestObject) methodsFor: 'comparing' stamp: 'KLG 2/25/2022 11:12:11'!
= anObject
	"Answer true if I am equal to anObject."

	self == anObject ifTrue: [ ^ true ].
	self class = anObject class ifFalse: [ ^ false ].
	iv0 = anObject iv0 ifFalse: [ ^ false ].
	^ iv1 = anObject iv1
				! !

!(Modules>>#PlanETest>>#ATC) methodsFor: 'comparing' stamp: 'KLG 5/16/2021 13:37:59'!
= anOtherObject

	self == anOtherObject ifTrue: [ ^ true ].
	self class == anOtherObject class ifFalse: [ ^ false ].
	a = anOtherObject a ifFalse: [ ^ false ].
	^ b = anOtherObject b! !

!(Modules>>#PlanETest>>#ATC) methodsFor: 'comparing' stamp: 'KLG 5/16/2021 13:38:03'!
hash
	"Answer a hash."

	^ a hash bitXor: b hash! !

!(Modules>>#PlanETest>>#ATC) methodsFor: 'accessing' stamp: 'KLG 5/16/2021 13:38:31'!
a
	"Answer the value of a"

	^ a! !

!(Modules>>#PlanETest>>#ATC) methodsFor: 'accessing' stamp: 'KLG 5/16/2021 13:38:31'!
a: anObject
	"Set the value of a"

	a _ anObject! !

!(Modules>>#PlanETest>>#ATC) methodsFor: 'accessing' stamp: 'KLG 5/16/2021 13:38:31'!
b
	"Answer the value of b"

	^ b! !

!(Modules>>#PlanETest>>#ATC) methodsFor: 'accessing' stamp: 'KLG 5/16/2021 13:38:31'!
b: anObject
	"Set the value of b"

	b _ anObject! !

!(Modules>>#PlanETest>>#TC1) methodsFor: 'initialization' stamp: 'KLG 5/15/2021 21:14:52'!
initialize

	super initialize.
	a _ 'A'.
	b _ 'B'! !

!(Modules>>#PlanETest>>#TC2) methodsFor: 'initialization' stamp: 'KLG 5/16/2021 13:36:17'!
initialize

	super initialize.
	a _ TC1 new.
	b _ TC1 new! !
