'From Haver 5.0 [latest update: #4627] on 7 June 2021 at 11:07:01 am'!
'Description '!
!provides: 'DebugWorlds' 1 1!
!requires: 'Cuis-Base' 50 4627 nil!
!requires: 'Worlds' 1 1 nil!
SystemOrganization addCategory: 'DebugWorlds'!


!moduleCreation: DebugWorlds!
Modules newEnvironment: #DebugWorlds!

!interfacesOf: DebugWorlds!
Modules environment: #DebugWorlds ::
	interface: #SPI aliasFor: #API ::
	interface: #UTI aliasFor: #API!

!importsOf: DebugWorlds!
Modules environment: #DebugWorlds :: 
	import: #(#WorldModel ) from: #SPI of: Modules>>#Worlds!

!classDefinition: (Modules>>#DebugWorlds>>#DebugWorldModel) category: 'DebugWorlds'!
(Modules>>#Worlds>>#AbstractWorldModelWithSpecificWorldMorph) subclass: #DebugWorldModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DebugWorlds'
	inModule: #DebugWorlds!
!classDefinition: (Modules>>#DebugWorlds>>#DebugWorldModel) class category: 'DebugWorlds'!
(Modules>>#DebugWorlds>>#DebugWorldModel) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#DebugWorlds>>#DebugProcess) category: 'DebugWorlds'!
Process subclass: #DebugProcess
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DebugWorlds'
	inModule: #DebugWorlds!
!classDefinition: (Modules>>#DebugWorlds>>#DebugProcess) class category: 'DebugWorlds'!
(Modules>>#DebugWorlds>>#DebugProcess) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#DebugWorlds>>#DebugWorldMorph) category: 'DebugWorlds'!
(Modules>>#Worlds>>#AbstractModelSpecificWorldMorph) subclass: #DebugWorldMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DebugWorlds'
	inModule: #DebugWorlds!
!classDefinition: (Modules>>#DebugWorlds>>#DebugWorldMorph) class category: 'DebugWorlds'!
(Modules>>#DebugWorlds>>#DebugWorldMorph) class
	instanceVariableNames: ''!


!(Modules>>#DebugWorlds>>#DebugWorldModel) commentStamp: '<historical>' prior: 0!
I am a debug world.

I help the user to debug (UI) code.!

!(Modules>>#DebugWorlds>>#DebugProcess) commentStamp: '<historical>' prior: 0!
I am a process that supports debugging a in world.!

!(Modules>>#DebugWorlds>>#DebugWorldMorph) commentStamp: '<historical>' prior: 0!
I am the world morph for debugging worlds..!

!(Modules>>#DebugWorlds>>#DebugWorldModel) methodsFor: 'user interface support' stamp: 'KLG 6/6/2021 14:25:16'!
shortLabelPrefix
	"Answer a short prefix for the window label."

	^ 'Debug'! !

!(Modules>>#DebugWorlds>>#DebugWorldModel) class methodsFor: 'menu building' stamp: 'KLG 6/6/2021 14:26:45'!
creationMenuItemText
	"Answer the text for the creation menu item."

	^ 'Debug'! !

!(Modules>>#DebugWorlds>>#DebugWorldModel) class methodsFor: 'instance creation' stamp: 'KLG 6/6/2021 14:36:08'!
worldClass

	"Answer my world morph class."

	^ DebugWorldMorph ! !

!(Modules>>#DebugWorlds>>#DebugProcess) methodsFor: 'debugging' stamp: 'KLG 6/7/2021 10:59:30'!
debug: aContext title: aTitle full: aFlag
	"Open debugger on self with context shown on top"
	
	WorldModel 
		activateParentWorldForDebugging: self context: aContext title: aTitle full: aFlag
! !

!(Modules>>#DebugWorlds>>#DebugWorldMorph) methodsFor: 'events' stamp: 'KLG 6/6/2021 14:09:10'!
keyStroke: aKeyboardEvent
	"Handle a keystroke event."

	(aKeyboardEvent commandAltKeyPressed or: [ aKeyboardEvent controlKeyPressed ])
		ifTrue: [
			aKeyboardEvent keyCharacter = $[ ifTrue: [ worldModel startRecording ].
			aKeyboardEvent keyCharacter = $] ifTrue: [ worldModel stopRecording ].
			aKeyboardEvent keyCharacter = $- ifTrue: [ worldModel resetRecording ].
			aKeyboardEvent keyCharacter = $\ ifTrue: [
				self activeHand initForEvents.
				worldModel startReplay ].
			aKeyboardEvent keyCharacter = $| ifTrue: [ worldModel stopReplay ].
			aKeyboardEvent keyCharacter = $= ifTrue: [ worldModel browseRecordedEvents ].
		].
	^ super keyStroke: aKeyboardEvent! !

!(Modules>>#DebugWorlds>>#DebugWorldMorph) methodsFor: 'interaction loop' stamp: 'KLG 6/7/2021 10:42:02'!
runProcess
	
	| process |
	
	process _ [ self mainLoop ] newDebugWorldProcess.
	process
		priority: Processor userSchedulingPriority;
		name: 'Morphic UI';
		animatedUI: self.
	
	^ process! !

!BlockClosure methodsFor: '*DebugWorlds' stamp: 'KLG 6/7/2021 10:40:36'!
newDebugWorldProcess
	"Answer a Process that special to a debug world running the code in the receiver. The process is not 
	scheduled."
	<primitive: 19> "Simulation guard"
	^ `Modules >> #DebugWorlds >> #DebugProcess`
		forContext: 
			[self value.
			Processor activeProcess suspend] asContext
		priority: Processor activePriority! !

!UISupervisor class methodsFor: '*DebugWorlds' stamp: 'KLG 6/7/2021 10:29:14'!
suspendUIProcess
	"Suspend the ui process to debug it later."

	UIProcess ifNotNil: [
		UIProcess animatedUI: nil.
		UIProcess suspend ].
	UIProcess _ nil! !
