'From Haver 5.0 [latest update: #4655] on 10 July 2021 at 1:42:17 pm'!
'Description I am the base package for visual worlds.'!
!provides: 'Worlds' 1 13!
!requires: 'Cuis-Base' 50 4621 nil!
!requires: 'PlanE' 1 40 nil!
!requires: 'SystemMorphs' 1 4 nil!
!requires: 'ActionBuilder' 1 33 nil!
SystemOrganization addCategory: 'Worlds'!


!moduleCreation: Worlds!
Modules newEnvironment: #Worlds!

!interfacesOf: Worlds!
Modules environment: #Worlds ::
	interface: #API exporting: #(#WorldModel ) ::
	interface: #SPI exporting: #(#PreviewMorph #ScalableImageMorph #WorldModel #WorldModelMorph ) ::
	interface: #UTI aliasFor: #API!

!importsOf: Worlds!
Modules environment: #Worlds :: 
	import: #API of: Modules>>#SystemMorphs :: 
	import: #API of: Modules>>#ActionBuilder!

!classDefinition: (Modules>>#Worlds>>#WorldModel) category: 'Worlds'!
(Modules>>#SystemMorphs>>#AbstractSystemMorphModel) subclass: #WorldModel
	instanceVariableNames: 'parent world thumbnail label'
	classVariableNames: 'Current Store WorldsToKeep'
	poolDictionaries: ''
	category: 'Worlds'
	inModule: #Worlds!
!classDefinition: (Modules>>#Worlds>>#WorldModel) class category: 'Worlds'!
(Modules>>#Worlds>>#WorldModel) class
	instanceVariableNames: 'transcript'!

!classDefinition: (Modules>>#Worlds>>#AbstractWorldModelWithSpecificWorldMorph) category: 'Worlds'!
(Modules>>#Worlds>>#WorldModel) subclass: #AbstractWorldModelWithSpecificWorldMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Worlds'
	inModule: #Worlds!
!classDefinition: (Modules>>#Worlds>>#AbstractWorldModelWithSpecificWorldMorph) class category: 'Worlds'!
(Modules>>#Worlds>>#AbstractWorldModelWithSpecificWorldMorph) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#Worlds>>#WorldsList) category: 'Worlds'!
(Modules>>#SystemMorphs>>#AbstractSystemMorphModel) subclass: #WorldsList
	instanceVariableNames: 'cachedWorlds selectedWorld'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Worlds'
	inModule: #Worlds!
!classDefinition: (Modules>>#Worlds>>#WorldsList) class category: 'Worlds'!
(Modules>>#Worlds>>#WorldsList) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#Worlds>>#AbstractModelSpecificWorldMorph) category: 'Worlds'!
WorldMorph subclass: #AbstractModelSpecificWorldMorph
	instanceVariableNames: 'worldModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Worlds'
	inModule: #Worlds!
!classDefinition: (Modules>>#Worlds>>#AbstractModelSpecificWorldMorph) class category: 'Worlds'!
(Modules>>#Worlds>>#AbstractModelSpecificWorldMorph) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#Worlds>>#AbstractWorldModelMorph) category: 'Worlds'!
(Modules>>#SystemMorphs>>#AbstractSystemMorph) subclass: #AbstractWorldModelMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Worlds'
	inModule: #Worlds!
!classDefinition: (Modules>>#Worlds>>#AbstractWorldModelMorph) class category: 'Worlds'!
(Modules>>#Worlds>>#AbstractWorldModelMorph) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#Worlds>>#WorldModelMorph) category: 'Worlds'!
(Modules>>#Worlds>>#AbstractWorldModelMorph) subclass: #WorldModelMorph
	instanceVariableNames: 'previewMorph buttonsBuilder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Worlds'
	inModule: #Worlds!
!classDefinition: (Modules>>#Worlds>>#WorldModelMorph) class category: 'Worlds'!
(Modules>>#Worlds>>#WorldModelMorph) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#Worlds>>#WorldsListMorph) category: 'Worlds'!
(Modules>>#Worlds>>#AbstractWorldModelMorph) subclass: #WorldsListMorph
	instanceVariableNames: 'menuBuilder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Worlds'
	inModule: #Worlds!
!classDefinition: (Modules>>#Worlds>>#WorldsListMorph) class category: 'Worlds'!
(Modules>>#Worlds>>#WorldsListMorph) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#Worlds>>#ScalableImageMorph) category: 'Worlds'!
ImageMorph subclass: #ScalableImageMorph
	instanceVariableNames: 'scaledImage originalImage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Worlds'
	inModule: #Worlds!
!classDefinition: (Modules>>#Worlds>>#ScalableImageMorph) class category: 'Worlds'!
(Modules>>#Worlds>>#ScalableImageMorph) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#Worlds>>#PreviewMorph) category: 'Worlds'!
(Modules>>#Worlds>>#ScalableImageMorph) subclass: #PreviewMorph
	instanceVariableNames: 'actionBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Worlds'
	inModule: #Worlds!
!classDefinition: (Modules>>#Worlds>>#PreviewMorph) class category: 'Worlds'!
(Modules>>#Worlds>>#PreviewMorph) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#Worlds>>#WorldsListItemWrapper) category: 'Worlds'!
ListItemWrapper subclass: #WorldsListItemWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Worlds'
	inModule: #Worlds!
!classDefinition: (Modules>>#Worlds>>#WorldsListItemWrapper) class category: 'Worlds'!
(Modules>>#Worlds>>#WorldsListItemWrapper) class
	instanceVariableNames: ''!


!(Modules>>#Worlds>>#WorldModel) commentStamp: '<historical>' prior: 0!
I am a visual environment. I use a world of my own.!

!(Modules>>#Worlds>>#AbstractWorldModelWithSpecificWorldMorph) commentStamp: '<historical>' prior: 0!
I am the abstract super class of all world modles that need a model specific world morph.!

!(Modules>>#Worlds>>#WorldsList) commentStamp: '<historical>' prior: 0!
I am the browser for the list of worlds.!

!(Modules>>#Worlds>>#AbstractModelSpecificWorldMorph) commentStamp: '<historical>' prior: 0!
I am the abstract superclass of all model specific world morphs.!

!(Modules>>#Worlds>>#WorldModelMorph) commentStamp: '<historical>' prior: 0!
I display a single world, when it is not active.!

!(Modules>>#Worlds>>#WorldsListMorph) commentStamp: '<historical>' prior: 0!
I am the morph for the worlds list.!

!(Modules>>#Worlds>>#ScalableImageMorph) commentStamp: '<historical>' prior: 0!
I am a morph to preview a visual environment.!

!(Modules>>#Worlds>>#PreviewMorph) commentStamp: '<historical>' prior: 0!
I am a preview moprh for the visual environment.!

!(Modules>>#Worlds>>#WorldsListItemWrapper) commentStamp: '<historical>' prior: 0!
I am the wrapper for worlds list items.!

!(Modules>>#Worlds>>#WorldModel) class methodsFor: 'system startup' stamp: 'KLG 7/10/2021 13:20:36'!
releaseClassCachedState
	"Will be called for each class on shutdown or snapshot.
	All class vars or class instVar vars that can be cheaply recreated lazily on demand, should be nilled.
	For more expensive stuff to clean and recreate, consider #releaseClassState that is not called on every image save.
	See implementors for examples"
	
	Store ifNotNil: [ :store |
		store close.
		Store _ nil ].
	self
		"Kill all persitent models from the image."
		allInstancesDo: [ :worldModel |
			worldModel isPersistent ifTrue: [ worldModel kill ] ];
		"Remove all dead (killed) models by makeing them something else."
		allInstancesDo: [ :worldModel |
		"This is a hacky way to break cyclic dependencies on dead worlds."
		worldModel isDead ifTrue: [ worldModel becomeForward: Object new ] ]! !

!(Modules>>#Worlds>>#WorldsList) class methodsFor: 'system startup' stamp: 'KLG 7/3/2021 15:27:52'!
releaseClassCachedState
	"Will be called for each class on shutdown or snapshot.
	All class vars or class instVar vars that can be cheaply recreated lazily on demand, should be nilled.
	For more expensive stuff to clean and recreate, consider #releaseClassState that is not called on every image save.
	See implementors for examples"
	
	self allInstancesDo: [ :worldsList |
		worldsList flushWorldsCache ]! !

!(Modules>>#Worlds>>#WorldModel) methodsFor: 'accessing' stamp: 'KLG 6/3/2021 16:21:44'!
parent
	"Answer the parent."
	
	^ parent! !

!(Modules>>#Worlds>>#WorldModel) methodsFor: 'commands' stamp: 'KLG 6/3/2021 16:21:44'!
addActionsToGroup: anActionGroup withBuilder: anActionBuilder
	"Add model specific actions to anActionGroup by using anActionBuilder. 
	
	Do nothing here, the morph knows about the default action which is #enter."! !

!(Modules>>#Worlds>>#WorldModel) methodsFor: 'initialization' stamp: 'KLG 6/3/2021 16:21:44'!
initialize
	"Initialize the visual environment."
	
	parent _ Current.
	
	" the root project (the only project with a nil parent) binds to the existing world. All other projects create a new world."
	
	parent 
		ifNil:[ world _ UISupervisor ui ]
		ifNotNil:[	world _ self newWorld ].
	world color: Theme current background! !

!(Modules>>#Worlds>>#WorldModel) methodsFor: 'initialization' stamp: 'KLG 6/3/2021 16:21:44'!
newWorld
	"Answer a new wordl for me."

	^ UISupervisor ui class newWorld! !

!(Modules>>#Worlds>>#WorldModel) methodsFor: 'state' stamp: 'KLG 6/3/2021 16:21:44'!
enter
	"Enter the world."

	self enter: nil
! !

!(Modules>>#Worlds>>#WorldModel) methodsFor: 'state' stamp: 'KLG 7/3/2021 15:21:53'!
enter: aBlock
	"Enter the world. Evaluate aBlock in the new world."

	self isActive ifTrue: [
		^ self inform: 'I am already the active world' ].
	self isDead ifTrue: [
		^ self inform: 'Can not enter a dead world' ].
	Current ifNotNil: [ Current leave ].
	Current _ self.
	[
		ActiveModel flushEventSystem.
		UISupervisor stopUIProcess.
		UISupervisor spawnNewMorphicProcessFor: world.
		Display triggerEvent: #screenSizeChanged.
		aBlock ifNotNil: [ UISupervisor whenUIinSafeState: aBlock ]
	] fork 

! !

!(Modules>>#Worlds>>#WorldModel) methodsFor: 'state' stamp: 'KLG 6/7/2021 11:36:23'!
enterSuspendingUIProcess
	"Enter the world for the purpose of debugging."

	self enterSuspendingUIProcess: nil! !

!(Modules>>#Worlds>>#WorldModel) methodsFor: 'state' stamp: 'KLG 6/7/2021 11:35:54'!
enterSuspendingUIProcess: aBlock
	"Enter the world , but just suspend the ui process.
	
	This is used for the purpose of debugging."

	Current ifNotNil: [ Current leave ].
	Current _ self.
	[
		ActiveModel flushEventSystem.
		UISupervisor suspendUIProcess.
		UISupervisor spawnNewMorphicProcessFor: world.
		Display triggerEvent: #screenSizeChanged.
		aBlock ifNotNil: [ UISupervisor whenUIinSafeState: aBlock ]
	] fork 

! !

!(Modules>>#Worlds>>#WorldModel) methodsFor: 'state' stamp: 'KLG 7/3/2021 14:41:32'!
isActive
	"Answer true when I am the active wolrd."

	^ Current == self! !

!(Modules>>#Worlds>>#WorldModel) methodsFor: 'state' stamp: 'KLG 7/3/2021 14:44:14'!
isInActive
	"Answer true when I am not the active wolrd."

	^ Current ~~ self! !

!(Modules>>#Worlds>>#WorldModel) methodsFor: 'state' stamp: 'KLG 6/3/2021 16:21:44'!
leave
	"Leave the environment."

	thumbnail _ Form fromDisplay: (0@0 extent: Display extent).
	self triggerEvent: #changed.! !

!(Modules>>#Worlds>>#WorldModel) methodsFor: 'user interface support' stamp: 'KLG 7/7/2021 14:41:01'!
defaultLabel
	"Answer a default label."
	
	parent ifNil: [ ^ 'Root World' ].
	^ String streamContents: [ :stream |
		stream 
			nextPutAll: self shortLabelPrefix;
			nextPut: `Character space`.
		self identityHash storeOn: stream base: 16 ]! !

!(Modules>>#Worlds>>#WorldModel) methodsFor: 'user interface support' stamp: 'KLG 6/8/2021 15:27:58'!
label
	"Answer my lable. Generate one if  there is none."
	
	^ label ifNil: [ label _ self defaultLabel ]! !

!(Modules>>#Worlds>>#WorldModel) methodsFor: 'user interface support' stamp: 'KLG 6/9/2021 21:13:23'!
label: aString 
	"Set the label."

	label _ aString.
	self changed: #relabel! !

!(Modules>>#Worlds>>#WorldModel) methodsFor: 'user interface support' stamp: 'KLG 6/8/2021 15:26:59'!
labelString
	"Answer a suitable label for system window titles.."
	
	^ 'World: ', self label! !

!(Modules>>#Worlds>>#WorldModel) methodsFor: 'user interface support' stamp: 'KLG 6/7/2021 17:20:42'!
shortLabelPrefix
	"Answer a short prefix for the window label."

	^ 'World'! !

!(Modules>>#Worlds>>#WorldModel) methodsFor: 'user interface support' stamp: 'KLG 6/3/2021 16:21:44'!
thumbnail
	"Answer the thumbnail"

	^thumbnail! !

!(Modules>>#Worlds>>#WorldModel) methodsFor: 'keep/dispose' stamp: 'KLG 6/9/2021 17:08:05'!
dispose
	"Dont keep this world any more."

	WorldsToKeep
		ifNotNil: [ :toKeep | toKeep remove: self ifAbsent: [] ]
		! !

!(Modules>>#Worlds>>#WorldModel) methodsFor: 'keep/dispose' stamp: 'KLG 7/3/2021 14:55:29'!
isDead
	"Answer true if this wolrd is dead."

	^ world isNil! !

!(Modules>>#Worlds>>#WorldModel) methodsFor: 'keep/dispose' stamp: 'KLG 6/9/2021 21:57:32'!
keep
	"Keep this world, even when it's morph gets deleted."

	WorldsToKeep
		ifNil: [ WorldsToKeep _ IdentitySet with: self ]
		ifNotNil: [ :toKeep | toKeep add: self ]
		! !

!(Modules>>#Worlds>>#WorldModel) methodsFor: 'keep/dispose' stamp: 'KLG 7/3/2021 15:19:50'!
kill
	"Kill me to avoid circularo references."

	self dispose..
	world _ thumbnail _ parent _ nil.
	self mySystemWindowsDo: [ :window | window delete ].
	WorldsList allInstancesDo: [ :worldsList |
		worldsList worldWasKilled: self ]! !

!(Modules>>#Worlds>>#WorldModel) methodsFor: 'keep/dispose' stamp: 'KLG 6/9/2021 17:24:37'!
toogleKeep
	"Toogle the keep state."

	self willBeKept 
		ifTrue: [ self dispose ]
		ifFalse: [ self keep ].
	self changed: #willBeKept! !

!(Modules>>#Worlds>>#WorldModel) methodsFor: 'keep/dispose' stamp: 'KLG 6/9/2021 13:11:28'!
willBeKept
	"Answer true if this model will be kept alive if its morph is delted."

	^ WorldsToKeep
		ifNil: [ false ]
		ifNotNil: [ :toKeep | toKeep includes: self ]! !

!(Modules>>#Worlds>>#WorldModel) methodsFor: 'persistence' stamp: 'KLG 7/9/2021 11:12:31'!
isPersistent
	"Answer true if the world is persistent."

	^ self persisentWorlds includesKey: self label! !

!(Modules>>#Worlds>>#WorldModel) methodsFor: 'persistence' stamp: 'KLG 7/9/2021 10:56:53'!
persisentWorlds
	"Answer the collection -- currently a dictionary -- of
	persistent worlds.
	
	May be changed to a store that holds all (binary)
	objects that shoulb be persistet accross images."

	^ self store root! !

!(Modules>>#Worlds>>#WorldModel) methodsFor: 'persistence' stamp: 'KLG 7/9/2021 21:48:24'!
save
	"Save me on a store."

	self persisentWorlds at: self label ifAbsentPut: [
		self store markObjectForUpdate: self persisentWorlds.
		self ].
	self store
		markObjectForUpdate: self;
		dumpObject: self! !

!(Modules>>#Worlds>>#WorldModel) methodsFor: 'persistence' stamp: 'KLG 6/19/2021 12:47:47'!
store
	"Answer the store to persist worlds into."

	^ self class store! !

!(Modules>>#Worlds>>#WorldModel) methodsFor: 'persistence' stamp: 'KLG 7/9/2021 14:39:08'!
togglePersistence
	"Toggle the persistence of the world."

	self isPersistent
		ifFalse:[ self save]
		ifTrue: [
			self persisentWorlds
				removeKey: self label
				ifAbsent: [ self inform: 'World ''', self label, '''was not saved!!' ].
			self store 
				markObjectForUpdate: self persisentWorlds;
				dumpObject: self persisentWorlds ]! !

!(Modules>>#Worlds>>#WorldModel) class methodsFor: 'state' stamp: 'KLG 6/3/2021 16:21:44'!
current
	"Answer the current environment."

	^ Current! !

!(Modules>>#Worlds>>#WorldModel) class methodsFor: 'class initialization' stamp: 'KLG 6/19/2021 12:37:38'!
initialize
	"Inittialize the world list class."

	Current _ self new! !

!(Modules>>#Worlds>>#WorldModel) class methodsFor: 'instance creation' stamp: 'KLG 6/4/2021 10:44:58'!
browserMorphClass
	"Answer the toplevel morph class for this model."

	^ WorldModelMorph! !

!(Modules>>#Worlds>>#WorldModel) class methodsFor: 'instance creation' stamp: 'KLG 7/7/2021 15:08:47'!
storeClass
	"Answer the class of the database store to presist worlds."

	^ `Modules >> #PlanE >> #FileStore`! !

!(Modules>>#Worlds>>#WorldModel) class methodsFor: 'menu building' stamp: 'KLG 6/3/2021 16:21:44'!
creationMenuItemText
	"Answer the text for the creation menu item."

	^ 'World'! !

!(Modules>>#Worlds>>#WorldModel) class methodsFor: 'menu building' stamp: 'KLG 6/3/2021 16:21:44'!
iconSymbol
	"Answer the icon symbol to use in the menu."

	^ #globeIcon! !

!(Modules>>#Worlds>>#WorldModel) class methodsFor: 'menu building' stamp: 'KLG 6/19/2021 12:38:43'!
worldMenuOptions

	^{{
		#itemGroup 				-> 		25.
		#itemOrder 				-> 		10.
		#label 				-> 		'Worlds ...'.
		#object 				-> 		self.
		#selector 				-> 		#worldsMenu.
		#icon 				-> 		#globeIcon.
		#balloonText 				-> 		'Open the menu of world actions'.
	} asDictionary }! !

!(Modules>>#Worlds>>#WorldModel) class methodsFor: 'menu building' stamp: 'KLG 6/19/2021 12:38:43'!
worldsMenu
	"Pop up a menu with the subworlds options.
	
	Maybe we replace this with a nice symtem window."

	| menu |
	(menu _ 	MenuMorph new)
		addTitle: 'Worlds';
		addTitle: 'Creation';
		addStayUpIcons.
	self withAllSubclassesDo: [ :subClass |
		subClass name beginsWith: 'Abstract' :: ifFalse: [
			menu
				add: 'Create ', subClass creationMenuItemText
					target: subClass
					action: #createInSystemWindow
					icon:  subClass iconSymbol ] ].
	menu
		addTitle: 'Browsing';
		add: 'Browse Worlds'
			target: WorldsList
			action: #browse
			icon: #globeIcon	;
		addTitle: 'Navigation';
 		add: 'Parent World'
			target: self
			action: #activateParentWorld
			icon:  #goUpIcon;
		popUpInWorld! !

!(Modules>>#Worlds>>#WorldModel) class methodsFor: 'navigation' stamp: 'KLG 6/3/2021 16:21:44'!
activateParentWorld
	"Enter the parent world."
	
	self current parent
		ifNotNil:[ :parent |  parent enter ].! !

!(Modules>>#Worlds>>#WorldModel) class methodsFor: 'navigation' stamp: 'KLG 7/3/2021 19:27:45'!
createInSystemWindow
	"Browse we in a SystemWindow"

	| newWorld |
	SystemWindow openOn: (newWorld _ self new).
	WorldsList allInstancesDo: [ :worldList |
		worldList worldWasCreated: newWorld ]! !

!(Modules>>#Worlds>>#WorldModel) class methodsFor: 'windowColor' stamp: 'KLG 6/9/2021 13:05:04'!
windowColor
	"I am a browser."	

	^ Theme current browser! !

!(Modules>>#Worlds>>#WorldModel) class methodsFor: 'persistence' stamp: 'KLG 7/9/2021 21:41:25'!
store
	"Answer the store to persist worlds into."

	^ Store ifNil: [ 
		(Store _ self storeClass openOn: 'worlds.planE')
			root ifNil: [ Store root: Dictionary new].
		Store ]! !

!(Modules>>#Worlds>>#AbstractWorldModelWithSpecificWorldMorph) methodsFor: 'initialization' stamp: 'KLG 6/6/2021 14:18:55'!
newWorld
	"Answer a new world for me."

	^ self worldClass newWorldFor: self! !

!(Modules>>#Worlds>>#AbstractWorldModelWithSpecificWorldMorph) methodsFor: 'instance creation' stamp: 'KLG 6/6/2021 14:18:21'!
worldClass

	"Answer the wolrd class."
	
	^ self class worldClass
	! !

!(Modules>>#Worlds>>#AbstractWorldModelWithSpecificWorldMorph) class methodsFor: 'instance creation' stamp: 'KLG 6/6/2021 14:17:30'!
worldClass

	"Answer my world morph class."

	^ self subclassResponsibility! !

!(Modules>>#Worlds>>#WorldsList) methodsFor: 'accessing' stamp: 'KLG 7/3/2021 15:23:24'!
computeWorlds
	"Compute the collection of know worlds."

	| answer |
	answer _ OrderedCollection new.
	WorldModel withAllSubclassesDo: [ :subclass |
		subclass allInstancesDo: [ :worldModel |
			worldModel isDead ifFalse: [
			answer add: worldModel ] ] ].
	^ answer! !

!(Modules>>#Worlds>>#WorldsList) methodsFor: 'accessing' stamp: 'KLG 6/8/2021 14:01:15'!
flushWorldsCache
	"Flush the cached list of worlds."

	cachedWorlds _ nil! !

!(Modules>>#Worlds>>#WorldsList) methodsFor: 'accessing' stamp: 'KLG 6/8/2021 14:00:23'!
worlds
	"Answer the collection of know worlds."

	^ cachedWorlds ifNil: [ cachedWorlds 		_ self computeWorlds ]! !

!(Modules>>#Worlds>>#WorldsList) methodsFor: 'browsing' stamp: 'KLG 6/8/2021 14:09:08'!
browse
	"Browse the modules list."

	^ SystemWindow openOn: self! !

!(Modules>>#Worlds>>#WorldsList) methodsFor: 'user interface support' stamp: 'KLG 6/9/2021 21:04:16'!
browseSelectedWorld
	"Browse the selected world."

	self hasWorldSelection
		ifTrue: [ SystemWindow openOn: selectedWorld ]
		ifFalse: [ self inform: 'Nothing selected to browse!!' ]! !

!(Modules>>#Worlds>>#WorldsList) methodsFor: 'user interface support' stamp: 'KLG 7/3/2021 14:42:35'!
enterSelectedWorld
	"Enter the selected world."

	self hasWorldSelection
		ifTrue: [ 
			selectedWorld isActive
			ifTrue: [ self inform: 'The selected world is already active' ]
			ifFalse: [ selectedWorld enter] ]
		ifFalse: [ self inform: 'Nothing selected to enter!!' ]! !

!(Modules>>#Worlds>>#WorldsList) methodsFor: 'user interface support' stamp: 'KLG 6/9/2021 21:35:29'!
exploreSelectedWorld
	"Exp,lore the selected world."

	self hasWorldSelection
		ifTrue: [ selectedWorld explore ]
		ifFalse: [ self inform: 'Nothing selected to explore!!' ]! !

!(Modules>>#Worlds>>#WorldsList) methodsFor: 'user interface support' stamp: 'KLG 7/3/2021 14:44:44'!
hasNonActiveWorldSelection
	"Answer true if a wolrd model is selected and not active."
	
	^ self hasWorldSelection and: [ selectedWorld isInActive ]! !

!(Modules>>#Worlds>>#WorldsList) methodsFor: 'user interface support' stamp: 'KLG 7/10/2021 13:23:59'!
hasPersistentWorldSelection
	"Answer true if a wolrd model is selected and not active."
	
	^ self hasWorldSelection and: [ selectedWorld isPersistent ]! !

!(Modules>>#Worlds>>#WorldsList) methodsFor: 'user interface support' stamp: 'KLG 6/8/2021 21:43:28'!
hasWorldSelection
	"Answer true if a wolrd model is selected."
	
	^ selectedWorld isKindOf: WorldModel! !

!(Modules>>#Worlds>>#WorldsList) methodsFor: 'user interface support' stamp: 'KLG 6/9/2021 21:34:57'!
inspectSelectedWorld
	"Inspect the selected world."

	self hasWorldSelection
		ifTrue: [ selectedWorld inspect]
		ifFalse: [ self inform: 'Nothing selected to inspect!!' ]! !

!(Modules>>#Worlds>>#WorldsList) methodsFor: 'user interface support' stamp: 'KLG 6/8/2021 21:58:32'!
labelSelectedWorld: aNewLabel
	"Label the selected word."

	self hasWorldSelection
		ifTrue: [ 
			selectedWorld label: aNewLabel.
			self changed: #worldsListItems ]
		ifFalse: [ self inform: 'Nothing selected to label!!' ]! !

!(Modules>>#Worlds>>#WorldsList) methodsFor: 'user interface support' stamp: 'KLG 6/8/2021 14:31:38'!
labelString
	"Answer the label string for the SystemWindow."
	
	^ 'Worlds'! !

!(Modules>>#Worlds>>#WorldsList) methodsFor: 'user interface support' stamp: 'KLG 6/9/2021 21:28:54'!
newSelectedWorld: anItemWrapper
	"Store the selected world." 

	anItemWrapper 
		ifNil: [ selectedWorld _ nil ]
		ifNotNil: [ selectedWorld _ anItemWrapper item ].
	self
		changed: #selectedWorld;
		"F: changed: #relabel;"
		changed: #hasWorldSelection;
		changed: #hasNonActiveWorldSelection;
		changed: #selectedWorldWillBeKept! !

!(Modules>>#Worlds>>#WorldsList) methodsFor: 'user interface support' stamp: 'KLG 7/3/2021 15:43:30'!
removeSelectedWorld
	"Remove the selected word from the cached list of worlds."
	
	self hasWorldSelection
		ifTrue: [
			cachedWorlds ifNotNil: [
				cachedWorlds remove: selectedWorld ifAbsent: [] ].
			self 
				newSelectedWorld: nil;
				changed: #worldsListItems ]
		ifFalse: [
			self inform: 'Nothing selected to remove' ]! !

!(Modules>>#Worlds>>#WorldsList) methodsFor: 'user interface support' stamp: 'KLG 6/19/2021 13:03:45'!
saveSelectedWorld
	"Savethe selected world."

	self hasWorldSelection
		ifTrue: [ 
			selectedWorld == WorldModel current
			ifTrue: [ self inform: 'The active world can not be saved' ]
			ifFalse: [ selectedWorld save] ]
		ifFalse: [ self inform: 'Nothing selected to save!!' ]! !

!(Modules>>#Worlds>>#WorldsList) methodsFor: 'user interface support' stamp: 'KLG 6/8/2021 14:29:09'!
selectedWorld
	"Answer the selected world."
	
	^ selectedWorld! !

!(Modules>>#Worlds>>#WorldsList) methodsFor: 'user interface support' stamp: 'KLG 6/9/2021 17:22:06'!
selectedWorldWillBeKept
	"Answer true when the selected word will be kept."

	^ self hasWorldSelection and: [ selectedWorld willBeKept ]! !

!(Modules>>#Worlds>>#WorldsList) methodsFor: 'user interface support' stamp: 'KLG 6/9/2021 17:23:43'!
toogleKeepSelectedWorld
	"Toggle the keep state of selected word."

	self hasWorldSelection
		ifTrue: [ 
			selectedWorld toogleKeep.
			self changed: #worldsListItems ]
		ifFalse: [ self inform: 'Nothing selected to keep!!' ]! !

!(Modules>>#Worlds>>#WorldsList) methodsFor: 'user interface support' stamp: 'KLG 7/3/2021 16:37:18'!
worldWasCreated: aWorld
	"aWorld was created, update everything."

	self flushWorldsCache.
	self changed: #worldsListItems! !

!(Modules>>#Worlds>>#WorldsList) methodsFor: 'user interface support' stamp: 'KLG 7/3/2021 15:53:35'!
worldWasKilled: aWorld
	"aWorld was killed, update everything."

	self flushWorldsCache.
	self changed: #worldsListItems.
	selectedWorld == aWorld ifTrue: [
		selectedWorld _ nil.
		self
			changed: #selectedWorld;
			changed: #hasWorldSelection;
			changed: #hasNonActiveWorldSelection ]! !

!(Modules>>#Worlds>>#WorldsList) methodsFor: 'user interface support' stamp: 'KLG 6/8/2021 14:26:34'!
worldsListItems
	"Answer the collection of list box items for worlds."
	
	^ self worlds collect: [ :world |
		self worldsListItemClass with: world model: self ]! !

!(Modules>>#Worlds>>#WorldsList) methodsFor: 'instance creation' stamp: 'KLG 6/8/2021 14:25:18'!
worldsListItemClass
	"Answer the class for the worlds list item."
	
	^ self class worldsListItemClass! !

!(Modules>>#Worlds>>#WorldsList) class methodsFor: 'instance creation' stamp: 'KLG 6/8/2021 14:12:09'!
browserMorphClass
	"Answer the browser morph class."

	^ WorldsListMorph ! !

!(Modules>>#Worlds>>#WorldsList) class methodsFor: 'instance creation' stamp: 'KLG 6/8/2021 14:42:27'!
worldsListItemClass
	"Answer the itme for a world."

	^ WorldsListItemWrapper! !

!(Modules>>#Worlds>>#WorldsList) class methodsFor: 'browsing' stamp: 'KLG 6/9/2021 13:00:12'!
browse
	"Browse the list of worlds."
	
	^ self new browse! !

!(Modules>>#Worlds>>#WorldsList) class methodsFor: 'windowColor' stamp: 'KLG 6/9/2021 13:07:23'!
windowColor
	"I am a browser."	

	^ Theme current browser! !

!(Modules>>#Worlds>>#AbstractModelSpecificWorldMorph) methodsFor: 'accessing' stamp: 'KLG 6/6/2021 14:22:02'!
worldModel: aWorldModel
	"Set the word model."

	worldModel _ aWorldModel 	! !

!(Modules>>#Worlds>>#AbstractModelSpecificWorldMorph) methodsFor: 'state' stamp: 'KLG 6/7/2021 19:08:30'!
enter
	"Enter the world models word (which is me)."

	worldModel enter! !

!(Modules>>#Worlds>>#AbstractModelSpecificWorldMorph) class methodsFor: 'instance creation' stamp: 'KLG 6/6/2021 14:22:45'!
newWorldFor: aWorldModel
	"Answer a new world for aWorldModel."

	^ self newWorld worldModel: aWorldModel! !

!(Modules>>#Worlds>>#AbstractWorldModelMorph) methodsFor: 'commands' stamp: 'KLG 6/9/2021 21:09:56'!
renameWorldWith: aBlock initialAnswer: anOldLabel
	"Rename the world with the help of aBlock."

	self 
		request: 'World label?'  
		initialAnswer: anOldLabel
		verifying:  [ :aString | aString notEmpty ]
		do: aBlock ! !

!(Modules>>#Worlds>>#WorldModelMorph) methodsFor: 'GUI building' stamp: 'KLG 7/9/2021 14:45:16'!
buildActions
	"Build all my actions."

	| builder |
	(builder _ ActionBuilder new)
		newRootActionGroup: #actions forModel: self model buildDoing: [ :root |
			root
				isHorizontal: false;
				title: 'World'.
			builder
				newAction: #enter buildDoing: [ :enter |
					enter
						text: 'Enter';
						icon: #goDownIcon;
						balloonText: 'Enter the environment';
						enabledSelector: #isInActive];
				newAction: #renameWorld buildDoing:  [ :renameWorld |
					renameWorld
						target: self;
						text: 'Rename world ...';
						buttonText: 'Rename ...';
						icon: #textEditorIcon;
						balloonText: 'Rename this world' ];
				newAction: #toogleKeep buildDoing: [ :keep |
					keep
						text: 'Keep';
						icon: #pushPinIcon;
						selectedSelector: #willBeKept;
						balloonText: 
							`'Keep the world after all its references were closed.', 
							String newLineString,
							'Please note, that a world may be ',
							'referenced from many parts of the image after entering it.' bold` ];
				newAction: #kill buildDoing: [ :kill |
					kill
						target: self;
						icon: #deleteIcon;
						text: 'Kill ...';
						balloonText: 'Kill this world'					];
				newAction: #save buildDoing:  [ :saveWorld |
							saveWorld
								text: 'Save';
								icon: #saveIcon;
								balloonText: 'Save the world to disk';
								enabledSelector: #isInActive ];
				newAction: #togglePersistence buildDoing: [ :persistence |
					persistence
						text: 'Persistent';
						icon: #saveIcon;
						balloonText: 'The world is persistent';
						enabledSelector: #isInActive;
						selectedSelector: #isPersistent ].
			self model addActionsToGroup: root withBuilder: builder ].
	^ builder! !

!(Modules>>#Worlds>>#WorldModelMorph) methodsFor: 'GUI building' stamp: 'KLG 6/11/2021 13:14:22'!
buildMorphicWidget
	"Build the morphic structure for this widget.
	
	If you like you may answer a different top level morph."
	
	self
		beRow
		addMorph: self buttonsBuilder buildUIElement fixedWidth: 200;
		addMorph:  (previewMorph _ PreviewMorph new) proportionalWidth: 1.
	previewMorph actionBlock: [ self model enter ]
! !

!(Modules>>#Worlds>>#WorldModelMorph) methodsFor: 'GUI building' stamp: 'KLG 6/3/2021 16:23:02'!
buttonsBuilder
	"Answer the buttons builder.
	Create it if does not extst."
	
	^ buttonsBuilder ifNil: [ buttonsBuilder _ self buildActions buttonsBuilder ]! !

!(Modules>>#Worlds>>#WorldModelMorph) methodsFor: 'accessing' stamp: 'KLG 6/3/2021 16:23:02'!
model: aVisualEnvironment

	super model: aVisualEnvironment.
	
	model when: #changed send: #updateThumbnail to:self 
! !

!(Modules>>#Worlds>>#WorldModelMorph) methodsFor: 'thumbnail' stamp: 'KLG 6/3/2021 16:23:02'!
updateThumbnail
	"Update the the thumbnail image."

	previewMorph image: model thumbnail.! !

!(Modules>>#Worlds>>#WorldModelMorph) methodsFor: 'commands' stamp: 'KLG 7/3/2021 15:03:34'!
kill
	"Kill the selected world."
	self confirm: 'Kill world ''', model label, '''?' ::
		ifTrue: [ model kill ]! !

!(Modules>>#Worlds>>#WorldModelMorph) methodsFor: 'commands' stamp: 'KLG 6/9/2021 21:10:42'!
renameWorld
	"Rename the selected world model."

	self 
		renameWorldWith: [ :aString | model label: aString ]
		initialAnswer: model label! !

!(Modules>>#Worlds>>#WorldModelMorph) class methodsFor: 'instance creation' stamp: 'KLG 6/4/2021 10:44:36'!
initializedModelBlock
	"Answer aBlock that constructs a new model of for me to display."

	^ [ WorldModel new ]! !

!(Modules>>#Worlds>>#WorldsListMorph) methodsFor: 'GUI building' stamp: 'KLG 7/10/2021 13:25:15'!
buildActions
	"Build all my actions."

	| builder |
	(builder _ ActionBuilder new)
		newRootActionGroup: #worldsListAction forModel: self model buildDoing: [ :root |
			root 
				heading: 'Worlds';
				isHorizontal: false.
			builder
				newActionGroup: #changeWorld buildDoing: [ :worldActions |
					worldActions title: 'Actions'.
					builder
						newAction: #enterSelectedWorld buildDoing: [ :enterSelection |
							enterSelection
								text: 'Enter it';
								icon: #goDownIcon;
								balloonText: 'Enter the selected world';
								enabledSelector: #hasNonActiveWorldSelection ];
						newAction: #removeSelectedWorld buildDoing: [ :removeWorld |
							removeWorld
								text: 'Remove world ...';
								buttonText: 'Remove ...';
								icon: #deleteIcon;
								balloonText: 'Remove the selected world';
								enabledSelector: #hasWorldSelection ];
						newAction: #toogleKeepSelectedWorld buildDoing: [ :keep |
							keep
								text: 'Keep';
								icon: #pushPinIcon;
								enabledSelector: #hasWorldSelection;
								selectedSelector: #selectedWorldWillBeKept;
								balloonText: 'Keep the world after all its referencing moprhs were closed' ];
						newAction: #killSelectedWorld buildDoing: [ :kill |
							kill
								target: self;
								text: 'Kill ...';
								icon: #deleteIcon;
								enabledSelector: #hasNonActiveWorldSelection;
								balloonText: 'Kill the selected world' ];
						newAction: #saveSelectedWorld buildDoing:  [ :saveWorld |
							saveWorld
								text: 'Save it';
								icon: #saveIcon;
								balloonText: 'Save the selected world';
								enabledSelector: #hasNonActiveWorldSelection ];
						newAction: #togglePersistence buildDoing: [ :persistence |
							persistence
								text: 'Persistent';
								icon: #saveIcon;
								balloonText: 'The world is persistent';
								enabledSelector: #hasNonActiveWorldSelection;
								selectedSelector: #hasPersistentWorldSelection ] ];
				newActionGroup: #creation buildDoing: [ :creation |
					builder ignoreDuplicateItemNames.
					creation title: 'Create'.
					WorldModel withAllSubclassesDo: [ :subClass |
						subClass name beginsWith: 'Abstract' :: ifFalse: [
							builder newAction: #createInSystemWindow buildDoing: [ :createWorld |
								createWorld
									text: subClass creationMenuItemText;
									target: subClass;
									icon: subClass iconSymbol ] ] ] ];
			 	newActionGroup: #editWorlds buildDoing: [ :edit |
					edit title: 'Edit'.
					builder
						newAction: #renameWorld buildDoing: [ :renameWorld |
							renameWorld
								target: self;
								text: 'Rename world ...';
								buttonText: 'Rename ...';
								icon: #textEditorIcon;
								balloonText: 'Rename the selected world';
								enabledSelector: #hasWorldSelection ];
						newAction: #browseSelectedWorld buildDoing: [ :open |
							open
								text: 'Browse it';
								icon: #editFindReplaceIcon;
								balloonText: 'Browse the selected word';
								enabledSelector: #hasWorldSelection  ];
						newAction: #inspectSelectedWorld buildDoing: [ :inspectWorld |
							inspectWorld
								text: 'Inspect it';
								icon: #inspectIcon;
								balloonText: 'Inspect the selected world';
								enabledSelector: #hasWorldSelection ];
						newAction: #exploreSelectedWorld buildDoing: [ :exploreWorld |
							exploreWorld
								text: 'Explore it';
								icon: #exploreIcon;
								balloonText: 'Explore the selected world';
								enabledSelector: #hasWorldSelection ] ] ].
	^ builder! !

!(Modules>>#Worlds>>#WorldsListMorph) methodsFor: 'GUI building' stamp: 'KLG 6/10/2021 10:33:34'!
buildMorphicWidget
	"Build the widget."

	| buttonsMorph worldsListMorph |
	buttonsMorph _ self buttonsBuilder buildUIElement.
	worldsListMorph _ HierarchicalListMorph
		model: model
		listGetter: #worldsListItems
		indexGetter: #selectedWorld
		indexSetter: #newSelectedWorld:
		mainView: self
		menuGetter: #worldsListMenu
		keystrokeAction: nil		.
	self 
		beRow
		addMorph: buttonsMorph fixedWidth: 200;
		addMorph: worldsListMorph proportionalWidth: 1 ! !

!(Modules>>#Worlds>>#WorldsListMorph) methodsFor: 'building menus' stamp: 'KLG 6/9/2021 21:23:41'!
buttonsBuilder
	"Answer the buttns builder"
	
	^ self menuBuilder buttonsBuilder ! !

!(Modules>>#Worlds>>#WorldsListMorph) methodsFor: 'building menus' stamp: 'KLG 6/8/2021 17:00:55'!
menuBuilder
	"Answer the menu builder.
	Create it if does not extst."
	
	^ menuBuilder ifNil: [ menuBuilder _ self buildActions menuBuilder ]! !

!(Modules>>#Worlds>>#WorldsListMorph) methodsFor: 'building menus' stamp: 'KLG 6/8/2021 21:40:41'!
worldsListMenu
	"Answer the menu for the list of world names."

	^ self menuBuilder buildUIElement ! !

!(Modules>>#Worlds>>#WorldsListMorph) methodsFor: 'commands' stamp: 'KLG 7/3/2021 15:42:26'!
killSelectedWorld
	"Kill the selected word."
	
	self confirm: 'Do you realy want to kill the selected world ''', model selectedWorld label, '''?' ::
		ifTrue: [ model selectedWorld kill ]! !

!(Modules>>#Worlds>>#WorldsListMorph) methodsFor: 'commands' stamp: 'KLG 6/9/2021 21:11:07'!
renameWorld
	"Rename the selected world model."

	self 
		renameWorldWith: [ :aString | model labelSelectedWorld: aString ]
		initialAnswer: model selectedWorld label! !

!(Modules>>#Worlds>>#ScalableImageMorph) methodsFor: 'accessing' stamp: 'KLG 6/3/2021 16:27:02'!
image: anImage 
	originalImage _ anImage.
	super image: anImage.
! !

!(Modules>>#Worlds>>#ScalableImageMorph) methodsFor: 'geometry' stamp: 'KLG 6/3/2021 16:27:02'!
morphExtent: aPoint
	extent _ aPoint. 
	self someSubmorphPositionOrExtentChanged! !

!(Modules>>#Worlds>>#ScalableImageMorph) methodsFor: 'layout' stamp: 'KLG 6/3/2021 16:27:02'!
someSubmorphPositionOrExtentChanged
		image _ originalImage magnifyTo: extent.
! !

!(Modules>>#Worlds>>#PreviewMorph) methodsFor: 'drawing' stamp: 'KLG 6/3/2021 16:27:38'!
minimumExtent
	"Answer my minimum extent."

	^ `200 @ 120`! !

!(Modules>>#Worlds>>#PreviewMorph) methodsFor: 'accessing' stamp: 'KLG 6/3/2021 16:27:38'!
actionBlock: aBlock
	"Set the actiom block"

	actionBlock _ aBlock! !

!(Modules>>#Worlds>>#PreviewMorph) methodsFor: 'event handling testing' stamp: 'KLG 6/3/2021 16:27:38'!
handlesMouseDown: aMouseButtonEvent
	"Do we want mouse down events."
	
	self flash.
	^ aMouseButtonEvent mouseButton1Pressed and: [ actionBlock notNil ]! !

!(Modules>>#Worlds>>#PreviewMorph) methodsFor: 'events' stamp: 'KLG 6/3/2021 16:27:38'!
mouseButton1Up: aMouseButtonEvent localPosition: localEventPosition
	"If we have an action, we evaluate it."
	
	actionBlock value! !

!(Modules>>#Worlds>>#WorldsListItemWrapper) methodsFor: 'converting' stamp: 'KLG 6/8/2021 15:30:10'!
asString
	"Answer a decent name for the world"

	^item label
! !
(Modules>>#Worlds>>#WorldModel) initialize!
