'From Haver 6.0 [latest update: #5173] on 24 May 2022 at 9:51:46 pm'!
'Description I provide some additional actions -- mostly for system windows -- triggered by additional mouse buttons.'!
!provides: 'MoreMouseActions' 1 9!
!requires: 'MoreMouseButtons' 1 8 nil!






!LayoutAdjustingMorph methodsFor: '*MoreMouseActions-events' stamp: 'KLG 5/24/2022 19:05:57'!
mouseButton4Down: aMouseButtonEvent localPosition: localEventPosition 
	"Handle a mouse down event.
	This message will only be sent to Morphs that answer true to #handlesMouseDown:"
	
	self withOriginalPositionRemoveAndDo: [ :op |
		owner ifNotNil: [ :o |
			o direction caseOf: {
				[ #horizontal ] -> [ o adjustHorizontallyBy: self at: op ].
				[ #vertical ] -> [ o adjustVerticallyBy: self at: op ] } ].
		Cursor defaultCursor activateCursor ].! !

!LayoutAdjustingMorph methodsFor: '*MoreMouseActions-events' stamp: 'KLG 5/24/2022 19:05:17'!
mouseButtonBackwardDown: aMouseButtonEvent localPosition: localEventPosition 
	"Handle a mouse down event.
	This message will only be sent to Morphs that answer true to #handlesMouseDown:"
	
	owner ifNotNil: [ :o | | e |
		self saveOriginalPosition.
		e _ o morphExtent.
		o direction caseOf: {
			[ #horizontal ] -> [ o adjustHorizontallyBy: self at: e ].
			[ #vertical ] -> [ o adjustVerticallyBy: self at: e ] } ].
	Cursor defaultCursor activateCursor
! !

!LayoutAdjustingMorph methodsFor: '*MoreMouseActions-events' stamp: 'KLG 5/24/2022 19:05:23'!
mouseButtonForwardDown: aMouseButtonEvent localPosition: localEventPosition 
	"Handle a mouse down event.
	This message will only be sent to Morphs that answer true to #handlesMouseDown:"
	
	owner ifNotNil: [ :o |
		self saveOriginalPosition.
		o direction caseOf: {
			[ #horizontal ] -> [ o adjustHorizontallyBy: self at: `0 @ 0` ].
			[ #vertical ] -> [ o adjustVerticallyBy: self at: `0 @ 0` ] } ].
	Cursor defaultCursor activateCursor
! !

!LayoutAdjustingMorph methodsFor: '*MoreMouseActions-events' stamp: 'KLG 5/24/2022 10:58:19'!
saveOriginalPosition
	
	self hasProperty: #originalPosition :: ifFalse: [
		self setProperty: #originalPosition toValue: self fullBoundsInOwner center]! !

!LayoutAdjustingMorph methodsFor: '*MoreMouseActions-events' stamp: 'KLG 5/24/2022 10:54:28'!
withOriginalPositionRemoveAndDo: aBlock
	
	self valueOfProperty: #originalPosition ifPresentDo: aBlock.
	self removeProperty: #originalPosition! !

!WindowEdgeAdjustingMorph methodsFor: '*MoreMouseActions-events' stamp: 'KLG 5/24/2022 21:48:23'!
adjustAllowedArea: anAllowedArea toBounds: aBoundingRectangle
	"Adjust allowed area to the correct side of the bound."

	| centerPoint |
	centerPoint _ Display boundingBox right // 2.
	^ (self externalizeDistanceToWorld: anAllowedArea center) x >
		(self externalizeDistanceToWorld: aBoundingRectangle center) x ::
			ifTrue: [ anAllowedArea right: centerPoint ]
			ifFalse: [ anAllowedArea left: centerPoint ]! !

!WindowEdgeAdjustingMorph methodsFor: '*MoreMouseActions-events' stamp: 'KLG 5/24/2022 19:06:20'!
mouseButton4Down: aMouseButtonEvent localPosition: localEventPosition 
	"Handle a mouse down event.
	This message will only be sent to Morphs that answer true to #handlesMouseDown:"

	owner ifNotNil: [ :sw | | bounds |
		sw valueOfProperty: #originalBounds ifPresentDo: [ :originalBounds |
			bounds _ sw displayBounds.
			selector caseOf: {
				[ #windowTop: ] -> [
					sw resize: (bounds top: originalBounds top) ].
				[ #windowBottom: ] -> [ 
					sw resize: (bounds bottom: originalBounds bottom) ].
				[ #windowRight: ] -> [
					sw resize: (bounds right: originalBounds right) ].
				[ #windowLeft: ] -> [
					sw resize: (bounds left: originalBounds left) ].
				[ #windowTopLeft: ] -> [
					sw resize: (Rectangle origin: originalBounds origin corner: bounds corner) ].
				[ #windowTopRight: ] -> [
					sw resize: (Rectangle
						left: bounds left
						right: originalBounds right
						top: originalBounds top
						bottom: bounds bottom) ].
				[ #windowBottomRight: ] -> [
					sw resize: (Rectangle origin: bounds origin corner: originalBounds corner) ].
				[ #windowBottomLeft: ] -> [
					sw resize: (Rectangle
						left: originalBounds left
						right: bounds right
						top: bounds top
						bottom: originalBounds bottom) ] }.
			Cursor defaultCursor activateCursor ] ]! !

!WindowEdgeAdjustingMorph methodsFor: '*MoreMouseActions-events' stamp: 'KLG 5/24/2022 20:03:09'!
mouseButtonBackwardDown: aMouseButtonEvent localPosition: localEventPosition 
	"Handle a mouse down event.
	This message will only be sent to Morphs that answer true to #handlesMouseDown:"

	owner ifNotNil: [ :sw | | allowedArea bounds |
		allowedArea _ sw allowedArea.
		bounds _ sw displayBounds.
		aMouseButtonEvent shiftPressed ifFalse: [
			allowedArea _ self adjustAllowedArea: allowedArea toBounds: bounds ].
		selector caseOf: {
			[ #windowTop: ] -> [
				 sw resize: (bounds translatedBy: 0 @ (allowedArea top - bounds top)) ].
			[ #windowBottom: ] -> [ 
				sw resize: (bounds translatedBy: 0 @ (allowedArea bottom - bounds bottom)) ].
			[ #windowRight: ] -> [
				sw resize: (bounds translatedBy: (allowedArea right - bounds right) @ 0) ].
			[ #windowLeft: ] -> [
				sw resize: (bounds translatedBy: (allowedArea left - bounds left) @ 0) ].
			[ #windowTopLeft: ] -> [
				sw resize: (Rectangle origin: allowedArea origin extent: bounds extent) ].
			[ #windowTopRight: ] -> [
				sw resize: (bounds translatedBy: (allowedArea right - bounds right) @ (allowedArea top - bounds top)) ].
			[ #windowBottomRight: ] -> [
				sw resize: (bounds translatedBy: allowedArea corner - bounds corner) ].
			[ #windowBottomLeft: ] -> [
				sw resize: (bounds translatedBy: (allowedArea left - bounds left) @ (allowedArea bottom - bounds bottom)) ] }.
		Cursor defaultCursor activateCursor ]
! !

!WindowEdgeAdjustingMorph methodsFor: '*MoreMouseActions-events' stamp: 'KLG 5/24/2022 20:03:02'!
mouseButtonForwardDown: aMouseButtonEvent localPosition: localEventPosition 
	"Handle a mouse down event.
	This message will only be sent to Morphs that answer true to #handlesMouseDown:"
	
	owner ifNotNil: [ :sw | | allowedArea bounds |
		allowedArea _ sw allowedArea.
		bounds _ sw displayBounds.
		aMouseButtonEvent shiftPressed ifFalse: [
			allowedArea _ self adjustAllowedArea: allowedArea toBounds: bounds ].
		selector caseOf: {
			[ #windowTop: ] -> [
				sw resize: (bounds top: allowedArea top) ].
			[ #windowBottom: ] -> [ 
				sw resize: (bounds bottom: allowedArea bottom) ].
			[ #windowRight: ] -> [
				sw resize: (bounds right: allowedArea right) ].
			[ #windowLeft: ] -> [
				sw resize: (bounds left: allowedArea left) ].
			[ #windowTopLeft: ] -> [
				sw resize: (Rectangle origin: allowedArea origin corner: bounds corner) ].
			[ #windowTopRight: ] -> [
				sw resize: (Rectangle
					left: bounds left
					right: allowedArea right
					top: allowedArea top
					bottom: bounds bottom) ].
			[ #windowBottomRight: ] -> [
				sw resize: (Rectangle origin: bounds origin corner: allowedArea corner) ].
			[ #windowBottomLeft: ] -> [
				sw resize: (Rectangle
					left: allowedArea left
					right: bounds right
					top: bounds top
					bottom: allowedArea bottom) ] }.
		Cursor defaultCursor activateCursor ]
! !

!SystemWindow methodsFor: '*MoreMouseActions-event handling testing' stamp: 'KLG 5/23/2022 17:45:25'!
handlesMouseDown: aMouseButtonEvent
	"Do I want to receive mouseButton messages?"

	^ aMouseButtonEvent mouseButtonBackwardPressed or: [
		aMouseButtonEvent mouseButtonForwardPressed  ] :: or: [
		aMouseButtonEvent mouseButton4Pressed ]! !

!SystemWindow methodsFor: '*MoreMouseActions-event handling testing' stamp: 'KLG 5/23/2022 19:46:39'!
hasOriginalBounds
	"Answer true if the window has original bounds."

	^ self hasProperty: #originalBounds! !

!SystemWindow methodsFor: '*MoreMouseActions-events' stamp: 'KLG 5/23/2022 18:22:11'!
mouseButton4Down: aMouseButtonEvent localPosition: localEventPosition 
	"Handle a mouse down event.
	This message will only be sent to Morphs that answer true to #handlesMouseDown:"
	
	self fullScreen
! !

!SystemWindow methodsFor: '*MoreMouseActions-events' stamp: 'KLG 5/23/2022 18:44:37'!
mouseButtonBackwardDown: aMouseButtonEvent localPosition: localEventPosition 
	"Handle a mouse down event.
	This message will only be sent to Morphs that answer true to #handlesMouseDown:"
	
	aMouseButtonEvent shiftPressed ifTrue: [
		^ self resizeTopRight ].
	aMouseButtonEvent controlKeyPressed ifTrue: [
		^ self resizeRight ].
	self resizeBottomRight
	! !

!SystemWindow methodsFor: '*MoreMouseActions-events' stamp: 'KLG 5/23/2022 18:43:18'!
mouseButtonForwardDown: aMouseButtonEvent localPosition: localEventPosition 
	"Handle a mouse down event.
	This message will only be sent to Morphs that answer true to #handlesMouseDown:"
	
	aMouseButtonEvent shiftPressed ifTrue: [
		^ self resizeTopLeft ].
	aMouseButtonEvent controlKeyPressed ifTrue: [
		^ self resizeLeft ].
	self resizeBottomLeft 
! !
