'From Cuis 5.0 [latest update: #4438] on 2 November 2020 at 10:56:35 am'!
'Description Tests KlgBaseliner.'!
!provides: 'KlgBaselinerTest' 1 2!
!requires: 'KlgBaseliner' 1 9 nil!
SystemOrganization addCategory: 'KlgBaselinerTest'!


!classDefinition: #KlgBaselinerTest category: 'KlgBaselinerTest'!
TestCase subclass: #KlgBaselinerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KlgBaselinerTest'!
!classDefinition: 'KlgBaselinerTest class' category: 'KlgBaselinerTest'!
KlgBaselinerTest class
	instanceVariableNames: ''!


!KlgBaselinerTest commentStamp: '<historical>' prior: 0!
I test the base liner.!

!KlgBaselinerTest methodsFor: 'testing' stamp: 'KLG 11/1/2020 22:57:53'!
testPersistence
	"Test the persistence stuff."

	| baseliner newBaseline baselineString loadedBaseline |
	newBaseline _ (baseliner _ KlgBaseliner new) createTestBaselineOnClass: Object.
	baselineString _ String streamContents: [ :stream |
		baseliner dumpBaseline:  newBaseline on: stream ].
	loadedBaseline _ baseliner loadBaselineFromStream: (ReadStream on: baselineString).
	self assert: newBaseline equals: loadedBaseline ! !

!KlgBaseliner methodsFor: '*KlgBaselinerTest' stamp: 'KLG 11/1/2020 22:23:19'!
createTestBaseline
	"Create a  simple test base line."

	lastBaselineCreated _ self baselineClass new.
	self fillTestBaseline: lastBaselineCreated.
	^ baselines at: lastBaselineCreated imageVersion put: lastBaselineCreated! !

!KlgBaseliner methodsFor: '*KlgBaselinerTest' stamp: 'KLG 11/1/2020 22:54:37'!
createTestBaselineOnClass: aClass
	"Create a  simple test base line."

	lastBaselineCreated _ self baselineClass new.
	self fillTestBaseline: lastBaselineCreated onClass: aClass.
	^ baselines at: lastBaselineCreated imageVersion put: lastBaselineCreated! !

!KlgBaseliner methodsFor: '*KlgBaselinerTest' stamp: 'KLG 11/1/2020 22:26:44'!
fillTestBaseline: aBaseline
	"Fill the base line for testing purposes."

	aBaseline imageVersion: SystemVersion current versionRevision	.
	{ActiveModel. ActiveModel class} do: [ :aBehavior | | behaviorBaseline |
		behaviorBaseline _ aBehavior isMeta
			ifFalse: [ aBaseline baselineForClass: aBehavior ]
			ifTrue: [ aBaseline baselineForMetaclass: aBehavior ].
		aBehavior methodsDo: [ :method |
			behaviorBaseline at: method selector put: method timeStamp ] ]! !

!KlgBaseliner methodsFor: '*KlgBaselinerTest' stamp: 'KLG 11/1/2020 23:42:42'!
fillTestBaseline: aBaseline onClass: aClass
	"Fill the base line for testing purposes."

	aBaseline imageVersion: SystemVersion current versionRevision	.
	{aClass. aClass class} do: [ :aBehavior | | behaviorBaseline |
		behaviorBaseline _ aBehavior isMeta
			ifFalse: [ aBaseline baselineForClass: aBehavior ]
			ifTrue: [ aBaseline baselineForMetaclass: aBehavior ].
		aBehavior methodsDo: [ :method |
			method timeStamp ifNotEmpty: [ :timeStamp |
			behaviorBaseline at: method selector put: timeStamp ] ] ]! !
